
(function() {
'use strict';

function F2(fun)
{
  function wrapper(a) { return function(b) { return fun(a,b); }; }
  wrapper.arity = 2;
  wrapper.func = fun;
  return wrapper;
}

function F3(fun)
{
  function wrapper(a) {
    return function(b) { return function(c) { return fun(a, b, c); }; };
  }
  wrapper.arity = 3;
  wrapper.func = fun;
  return wrapper;
}

function F4(fun)
{
  function wrapper(a) { return function(b) { return function(c) {
    return function(d) { return fun(a, b, c, d); }; }; };
  }
  wrapper.arity = 4;
  wrapper.func = fun;
  return wrapper;
}

function F5(fun)
{
  function wrapper(a) { return function(b) { return function(c) {
    return function(d) { return function(e) { return fun(a, b, c, d, e); }; }; }; };
  }
  wrapper.arity = 5;
  wrapper.func = fun;
  return wrapper;
}

function F6(fun)
{
  function wrapper(a) { return function(b) { return function(c) {
    return function(d) { return function(e) { return function(f) {
    return fun(a, b, c, d, e, f); }; }; }; }; };
  }
  wrapper.arity = 6;
  wrapper.func = fun;
  return wrapper;
}

function F7(fun)
{
  function wrapper(a) { return function(b) { return function(c) {
    return function(d) { return function(e) { return function(f) {
    return function(g) { return fun(a, b, c, d, e, f, g); }; }; }; }; }; };
  }
  wrapper.arity = 7;
  wrapper.func = fun;
  return wrapper;
}

function F8(fun)
{
  function wrapper(a) { return function(b) { return function(c) {
    return function(d) { return function(e) { return function(f) {
    return function(g) { return function(h) {
    return fun(a, b, c, d, e, f, g, h); }; }; }; }; }; }; };
  }
  wrapper.arity = 8;
  wrapper.func = fun;
  return wrapper;
}

function F9(fun)
{
  function wrapper(a) { return function(b) { return function(c) {
    return function(d) { return function(e) { return function(f) {
    return function(g) { return function(h) { return function(i) {
    return fun(a, b, c, d, e, f, g, h, i); }; }; }; }; }; }; }; };
  }
  wrapper.arity = 9;
  wrapper.func = fun;
  return wrapper;
}

function A2(fun, a, b)
{
  return fun.arity === 2
    ? fun.func(a, b)
    : fun(a)(b);
}
function A3(fun, a, b, c)
{
  return fun.arity === 3
    ? fun.func(a, b, c)
    : fun(a)(b)(c);
}
function A4(fun, a, b, c, d)
{
  return fun.arity === 4
    ? fun.func(a, b, c, d)
    : fun(a)(b)(c)(d);
}
function A5(fun, a, b, c, d, e)
{
  return fun.arity === 5
    ? fun.func(a, b, c, d, e)
    : fun(a)(b)(c)(d)(e);
}
function A6(fun, a, b, c, d, e, f)
{
  return fun.arity === 6
    ? fun.func(a, b, c, d, e, f)
    : fun(a)(b)(c)(d)(e)(f);
}
function A7(fun, a, b, c, d, e, f, g)
{
  return fun.arity === 7
    ? fun.func(a, b, c, d, e, f, g)
    : fun(a)(b)(c)(d)(e)(f)(g);
}
function A8(fun, a, b, c, d, e, f, g, h)
{
  return fun.arity === 8
    ? fun.func(a, b, c, d, e, f, g, h)
    : fun(a)(b)(c)(d)(e)(f)(g)(h);
}
function A9(fun, a, b, c, d, e, f, g, h, i)
{
  return fun.arity === 9
    ? fun.func(a, b, c, d, e, f, g, h, i)
    : fun(a)(b)(c)(d)(e)(f)(g)(h)(i);
}

//import Native.Utils //

var _elm_lang$core$Native_Basics = function() {

function div(a, b)
{
	return (a / b) | 0;
}
function rem(a, b)
{
	return a % b;
}
function mod(a, b)
{
	if (b === 0)
	{
		throw new Error('Cannot perform mod 0. Division by zero error.');
	}
	var r = a % b;
	var m = a === 0 ? 0 : (b > 0 ? (a >= 0 ? r : r + b) : -mod(-a, -b));

	return m === b ? 0 : m;
}
function logBase(base, n)
{
	return Math.log(n) / Math.log(base);
}
function negate(n)
{
	return -n;
}
function abs(n)
{
	return n < 0 ? -n : n;
}

function min(a, b)
{
	return _elm_lang$core$Native_Utils.cmp(a, b) < 0 ? a : b;
}
function max(a, b)
{
	return _elm_lang$core$Native_Utils.cmp(a, b) > 0 ? a : b;
}
function clamp(lo, hi, n)
{
	return _elm_lang$core$Native_Utils.cmp(n, lo) < 0
		? lo
		: _elm_lang$core$Native_Utils.cmp(n, hi) > 0
			? hi
			: n;
}

var ord = ['LT', 'EQ', 'GT'];

function compare(x, y)
{
	return { ctor: ord[_elm_lang$core$Native_Utils.cmp(x, y) + 1] };
}

function xor(a, b)
{
	return a !== b;
}
function not(b)
{
	return !b;
}
function isInfinite(n)
{
	return n === Infinity || n === -Infinity;
}

function truncate(n)
{
	return n | 0;
}

function degrees(d)
{
	return d * Math.PI / 180;
}
function turns(t)
{
	return 2 * Math.PI * t;
}
function fromPolar(point)
{
	var r = point._0;
	var t = point._1;
	return _elm_lang$core$Native_Utils.Tuple2(r * Math.cos(t), r * Math.sin(t));
}
function toPolar(point)
{
	var x = point._0;
	var y = point._1;
	return _elm_lang$core$Native_Utils.Tuple2(Math.sqrt(x * x + y * y), Math.atan2(y, x));
}

return {
	div: F2(div),
	rem: F2(rem),
	mod: F2(mod),

	pi: Math.PI,
	e: Math.E,
	cos: Math.cos,
	sin: Math.sin,
	tan: Math.tan,
	acos: Math.acos,
	asin: Math.asin,
	atan: Math.atan,
	atan2: F2(Math.atan2),

	degrees: degrees,
	turns: turns,
	fromPolar: fromPolar,
	toPolar: toPolar,

	sqrt: Math.sqrt,
	logBase: F2(logBase),
	negate: negate,
	abs: abs,
	min: F2(min),
	max: F2(max),
	clamp: F3(clamp),
	compare: F2(compare),

	xor: F2(xor),
	not: not,

	truncate: truncate,
	ceiling: Math.ceil,
	floor: Math.floor,
	round: Math.round,
	toFloat: function(x) { return x; },
	isNaN: isNaN,
	isInfinite: isInfinite
};

}();
//import //

var _elm_lang$core$Native_Utils = function() {

// COMPARISONS

function eq(x, y)
{
	var stack = [];
	var isEqual = eqHelp(x, y, 0, stack);
	var pair;
	while (isEqual && (pair = stack.pop()))
	{
		isEqual = eqHelp(pair.x, pair.y, 0, stack);
	}
	return isEqual;
}


function eqHelp(x, y, depth, stack)
{
	if (depth > 100)
	{
		stack.push({ x: x, y: y });
		return true;
	}

	if (x === y)
	{
		return true;
	}

	if (typeof x !== 'object')
	{
		if (typeof x === 'function')
		{
			throw new Error(
				'Trying to use `(==)` on functions. There is no way to know if functions are "the same" in the Elm sense.'
				+ ' Read more about this at http://package.elm-lang.org/packages/elm-lang/core/latest/Basics#=='
				+ ' which describes why it is this way and what the better version will look like.'
			);
		}
		return false;
	}

	if (x === null || y === null)
	{
		return false
	}

	if (x instanceof Date)
	{
		return x.getTime() === y.getTime();
	}

	if (!('ctor' in x))
	{
		for (var key in x)
		{
			if (!eqHelp(x[key], y[key], depth + 1, stack))
			{
				return false;
			}
		}
		return true;
	}

	// convert Dicts and Sets to lists
	if (x.ctor === 'RBNode_elm_builtin' || x.ctor === 'RBEmpty_elm_builtin')
	{
		x = _elm_lang$core$Dict$toList(x);
		y = _elm_lang$core$Dict$toList(y);
	}
	if (x.ctor === 'Set_elm_builtin')
	{
		x = _elm_lang$core$Set$toList(x);
		y = _elm_lang$core$Set$toList(y);
	}

	// check if lists are equal without recursion
	if (x.ctor === '::')
	{
		var a = x;
		var b = y;
		while (a.ctor === '::' && b.ctor === '::')
		{
			if (!eqHelp(a._0, b._0, depth + 1, stack))
			{
				return false;
			}
			a = a._1;
			b = b._1;
		}
		return a.ctor === b.ctor;
	}

	// check if Arrays are equal
	if (x.ctor === '_Array')
	{
		var xs = _elm_lang$core$Native_Array.toJSArray(x);
		var ys = _elm_lang$core$Native_Array.toJSArray(y);
		if (xs.length !== ys.length)
		{
			return false;
		}
		for (var i = 0; i < xs.length; i++)
		{
			if (!eqHelp(xs[i], ys[i], depth + 1, stack))
			{
				return false;
			}
		}
		return true;
	}

	if (!eqHelp(x.ctor, y.ctor, depth + 1, stack))
	{
		return false;
	}

	for (var key in x)
	{
		if (!eqHelp(x[key], y[key], depth + 1, stack))
		{
			return false;
		}
	}
	return true;
}

// Code in Generate/JavaScript.hs, Basics.js, and List.js depends on
// the particular integer values assigned to LT, EQ, and GT.

var LT = -1, EQ = 0, GT = 1;

function cmp(x, y)
{
	if (typeof x !== 'object')
	{
		return x === y ? EQ : x < y ? LT : GT;
	}

	if (x instanceof String)
	{
		var a = x.valueOf();
		var b = y.valueOf();
		return a === b ? EQ : a < b ? LT : GT;
	}

	if (x.ctor === '::' || x.ctor === '[]')
	{
		while (x.ctor === '::' && y.ctor === '::')
		{
			var ord = cmp(x._0, y._0);
			if (ord !== EQ)
			{
				return ord;
			}
			x = x._1;
			y = y._1;
		}
		return x.ctor === y.ctor ? EQ : x.ctor === '[]' ? LT : GT;
	}

	if (x.ctor.slice(0, 6) === '_Tuple')
	{
		var ord;
		var n = x.ctor.slice(6) - 0;
		var err = 'cannot compare tuples with more than 6 elements.';
		if (n === 0) return EQ;
		if (n >= 1) { ord = cmp(x._0, y._0); if (ord !== EQ) return ord;
		if (n >= 2) { ord = cmp(x._1, y._1); if (ord !== EQ) return ord;
		if (n >= 3) { ord = cmp(x._2, y._2); if (ord !== EQ) return ord;
		if (n >= 4) { ord = cmp(x._3, y._3); if (ord !== EQ) return ord;
		if (n >= 5) { ord = cmp(x._4, y._4); if (ord !== EQ) return ord;
		if (n >= 6) { ord = cmp(x._5, y._5); if (ord !== EQ) return ord;
		if (n >= 7) throw new Error('Comparison error: ' + err); } } } } } }
		return EQ;
	}

	throw new Error(
		'Comparison error: comparison is only defined on ints, '
		+ 'floats, times, chars, strings, lists of comparable values, '
		+ 'and tuples of comparable values.'
	);
}


// COMMON VALUES

var Tuple0 = {
	ctor: '_Tuple0'
};

function Tuple2(x, y)
{
	return {
		ctor: '_Tuple2',
		_0: x,
		_1: y
	};
}

function chr(c)
{
	return new String(c);
}


// GUID

var count = 0;
function guid(_)
{
	return count++;
}


// RECORDS

function update(oldRecord, updatedFields)
{
	var newRecord = {};

	for (var key in oldRecord)
	{
		newRecord[key] = oldRecord[key];
	}

	for (var key in updatedFields)
	{
		newRecord[key] = updatedFields[key];
	}

	return newRecord;
}


//// LIST STUFF ////

var Nil = { ctor: '[]' };

function Cons(hd, tl)
{
	return {
		ctor: '::',
		_0: hd,
		_1: tl
	};
}

function append(xs, ys)
{
	// append Strings
	if (typeof xs === 'string')
	{
		return xs + ys;
	}

	// append Lists
	if (xs.ctor === '[]')
	{
		return ys;
	}
	var root = Cons(xs._0, Nil);
	var curr = root;
	xs = xs._1;
	while (xs.ctor !== '[]')
	{
		curr._1 = Cons(xs._0, Nil);
		xs = xs._1;
		curr = curr._1;
	}
	curr._1 = ys;
	return root;
}


// CRASHES

function crash(moduleName, region)
{
	return function(message) {
		throw new Error(
			'Ran into a `Debug.crash` in module `' + moduleName + '` ' + regionToString(region) + '\n'
			+ 'The message provided by the code author is:\n\n    '
			+ message
		);
	};
}

function crashCase(moduleName, region, value)
{
	return function(message) {
		throw new Error(
			'Ran into a `Debug.crash` in module `' + moduleName + '`\n\n'
			+ 'This was caused by the `case` expression ' + regionToString(region) + '.\n'
			+ 'One of the branches ended with a crash and the following value got through:\n\n    ' + toString(value) + '\n\n'
			+ 'The message provided by the code author is:\n\n    '
			+ message
		);
	};
}

function regionToString(region)
{
	if (region.start.line == region.end.line)
	{
		return 'on line ' + region.start.line;
	}
	return 'between lines ' + region.start.line + ' and ' + region.end.line;
}


// TO STRING

function toString(v)
{
	var type = typeof v;
	if (type === 'function')
	{
		var name = v.func ? v.func.name : v.name;
		return '<function' + (name === '' ? '' : ':') + name + '>';
	}

	if (type === 'boolean')
	{
		return v ? 'True' : 'False';
	}

	if (type === 'number')
	{
		return v + '';
	}

	if (v instanceof String)
	{
		return '\'' + addSlashes(v, true) + '\'';
	}

	if (type === 'string')
	{
		return '"' + addSlashes(v, false) + '"';
	}

	if (v === null)
	{
		return 'null';
	}

	if (type === 'object' && 'ctor' in v)
	{
		var ctorStarter = v.ctor.substring(0, 5);

		if (ctorStarter === '_Tupl')
		{
			var output = [];
			for (var k in v)
			{
				if (k === 'ctor') continue;
				output.push(toString(v[k]));
			}
			return '(' + output.join(',') + ')';
		}

		if (ctorStarter === '_Task')
		{
			return '<task>'
		}

		if (v.ctor === '_Array')
		{
			var list = _elm_lang$core$Array$toList(v);
			return 'Array.fromList ' + toString(list);
		}

		if (v.ctor === '<decoder>')
		{
			return '<decoder>';
		}

		if (v.ctor === '_Process')
		{
			return '<process:' + v.id + '>';
		}

		if (v.ctor === '::')
		{
			var output = '[' + toString(v._0);
			v = v._1;
			while (v.ctor === '::')
			{
				output += ',' + toString(v._0);
				v = v._1;
			}
			return output + ']';
		}

		if (v.ctor === '[]')
		{
			return '[]';
		}

		if (v.ctor === 'Set_elm_builtin')
		{
			return 'Set.fromList ' + toString(_elm_lang$core$Set$toList(v));
		}

		if (v.ctor === 'RBNode_elm_builtin' || v.ctor === 'RBEmpty_elm_builtin')
		{
			return 'Dict.fromList ' + toString(_elm_lang$core$Dict$toList(v));
		}

		var output = '';
		for (var i in v)
		{
			if (i === 'ctor') continue;
			var str = toString(v[i]);
			var c0 = str[0];
			var parenless = c0 === '{' || c0 === '(' || c0 === '<' || c0 === '"' || str.indexOf(' ') < 0;
			output += ' ' + (parenless ? str : '(' + str + ')');
		}
		return v.ctor + output;
	}

	if (type === 'object')
	{
		if (v instanceof Date)
		{
			return '<' + v.toString() + '>';
		}

		if (v.elm_web_socket)
		{
			return '<websocket>';
		}

		var output = [];
		for (var k in v)
		{
			output.push(k + ' = ' + toString(v[k]));
		}
		if (output.length === 0)
		{
			return '{}';
		}
		return '{ ' + output.join(', ') + ' }';
	}

	return '<internal structure>';
}

function addSlashes(str, isChar)
{
	var s = str.replace(/\\/g, '\\\\')
			  .replace(/\n/g, '\\n')
			  .replace(/\t/g, '\\t')
			  .replace(/\r/g, '\\r')
			  .replace(/\v/g, '\\v')
			  .replace(/\0/g, '\\0');
	if (isChar)
	{
		return s.replace(/\'/g, '\\\'');
	}
	else
	{
		return s.replace(/\"/g, '\\"');
	}
}


return {
	eq: eq,
	cmp: cmp,
	Tuple0: Tuple0,
	Tuple2: Tuple2,
	chr: chr,
	update: update,
	guid: guid,

	append: F2(append),

	crash: crash,
	crashCase: crashCase,

	toString: toString
};

}();
var _elm_lang$core$Basics$never = function (_p0) {
	never:
	while (true) {
		var _p1 = _p0;
		var _v1 = _p1._0;
		_p0 = _v1;
		continue never;
	}
};
var _elm_lang$core$Basics$uncurry = F2(
	function (f, _p2) {
		var _p3 = _p2;
		return A2(f, _p3._0, _p3._1);
	});
var _elm_lang$core$Basics$curry = F3(
	function (f, a, b) {
		return f(
			{ctor: '_Tuple2', _0: a, _1: b});
	});
var _elm_lang$core$Basics$flip = F3(
	function (f, b, a) {
		return A2(f, a, b);
	});
var _elm_lang$core$Basics$always = F2(
	function (a, _p4) {
		return a;
	});
var _elm_lang$core$Basics$identity = function (x) {
	return x;
};
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['<|'] = F2(
	function (f, x) {
		return f(x);
	});
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['|>'] = F2(
	function (x, f) {
		return f(x);
	});
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['>>'] = F3(
	function (f, g, x) {
		return g(
			f(x));
	});
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['<<'] = F3(
	function (g, f, x) {
		return g(
			f(x));
	});
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['++'] = _elm_lang$core$Native_Utils.append;
var _elm_lang$core$Basics$toString = _elm_lang$core$Native_Utils.toString;
var _elm_lang$core$Basics$isInfinite = _elm_lang$core$Native_Basics.isInfinite;
var _elm_lang$core$Basics$isNaN = _elm_lang$core$Native_Basics.isNaN;
var _elm_lang$core$Basics$toFloat = _elm_lang$core$Native_Basics.toFloat;
var _elm_lang$core$Basics$ceiling = _elm_lang$core$Native_Basics.ceiling;
var _elm_lang$core$Basics$floor = _elm_lang$core$Native_Basics.floor;
var _elm_lang$core$Basics$truncate = _elm_lang$core$Native_Basics.truncate;
var _elm_lang$core$Basics$round = _elm_lang$core$Native_Basics.round;
var _elm_lang$core$Basics$not = _elm_lang$core$Native_Basics.not;
var _elm_lang$core$Basics$xor = _elm_lang$core$Native_Basics.xor;
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['||'] = _elm_lang$core$Native_Basics.or;
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['&&'] = _elm_lang$core$Native_Basics.and;
var _elm_lang$core$Basics$max = _elm_lang$core$Native_Basics.max;
var _elm_lang$core$Basics$min = _elm_lang$core$Native_Basics.min;
var _elm_lang$core$Basics$compare = _elm_lang$core$Native_Basics.compare;
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['>='] = _elm_lang$core$Native_Basics.ge;
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['<='] = _elm_lang$core$Native_Basics.le;
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['>'] = _elm_lang$core$Native_Basics.gt;
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['<'] = _elm_lang$core$Native_Basics.lt;
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['/='] = _elm_lang$core$Native_Basics.neq;
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['=='] = _elm_lang$core$Native_Basics.eq;
var _elm_lang$core$Basics$e = _elm_lang$core$Native_Basics.e;
var _elm_lang$core$Basics$pi = _elm_lang$core$Native_Basics.pi;
var _elm_lang$core$Basics$clamp = _elm_lang$core$Native_Basics.clamp;
var _elm_lang$core$Basics$logBase = _elm_lang$core$Native_Basics.logBase;
var _elm_lang$core$Basics$abs = _elm_lang$core$Native_Basics.abs;
var _elm_lang$core$Basics$negate = _elm_lang$core$Native_Basics.negate;
var _elm_lang$core$Basics$sqrt = _elm_lang$core$Native_Basics.sqrt;
var _elm_lang$core$Basics$atan2 = _elm_lang$core$Native_Basics.atan2;
var _elm_lang$core$Basics$atan = _elm_lang$core$Native_Basics.atan;
var _elm_lang$core$Basics$asin = _elm_lang$core$Native_Basics.asin;
var _elm_lang$core$Basics$acos = _elm_lang$core$Native_Basics.acos;
var _elm_lang$core$Basics$tan = _elm_lang$core$Native_Basics.tan;
var _elm_lang$core$Basics$sin = _elm_lang$core$Native_Basics.sin;
var _elm_lang$core$Basics$cos = _elm_lang$core$Native_Basics.cos;
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['^'] = _elm_lang$core$Native_Basics.exp;
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['%'] = _elm_lang$core$Native_Basics.mod;
var _elm_lang$core$Basics$rem = _elm_lang$core$Native_Basics.rem;
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['//'] = _elm_lang$core$Native_Basics.div;
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['/'] = _elm_lang$core$Native_Basics.floatDiv;
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['*'] = _elm_lang$core$Native_Basics.mul;
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['-'] = _elm_lang$core$Native_Basics.sub;
var _elm_lang$core$Basics_ops = _elm_lang$core$Basics_ops || {};
_elm_lang$core$Basics_ops['+'] = _elm_lang$core$Native_Basics.add;
var _elm_lang$core$Basics$toPolar = _elm_lang$core$Native_Basics.toPolar;
var _elm_lang$core$Basics$fromPolar = _elm_lang$core$Native_Basics.fromPolar;
var _elm_lang$core$Basics$turns = _elm_lang$core$Native_Basics.turns;
var _elm_lang$core$Basics$degrees = _elm_lang$core$Native_Basics.degrees;
var _elm_lang$core$Basics$radians = function (t) {
	return t;
};
var _elm_lang$core$Basics$GT = {ctor: 'GT'};
var _elm_lang$core$Basics$EQ = {ctor: 'EQ'};
var _elm_lang$core$Basics$LT = {ctor: 'LT'};
var _elm_lang$core$Basics$JustOneMore = function (a) {
	return {ctor: 'JustOneMore', _0: a};
};

//import Native.Utils //

var _elm_lang$core$Native_Debug = function() {

function log(tag, value)
{
	var msg = tag + ': ' + _elm_lang$core$Native_Utils.toString(value);
	var process = process || {};
	if (process.stdout)
	{
		process.stdout.write(msg);
	}
	else
	{
		console.log(msg);
	}
	return value;
}

function crash(message)
{
	throw new Error(message);
}

return {
	crash: crash,
	log: F2(log)
};

}();
var _elm_lang$core$Debug$crash = _elm_lang$core$Native_Debug.crash;
var _elm_lang$core$Debug$log = _elm_lang$core$Native_Debug.log;

var _elm_lang$core$Maybe$withDefault = F2(
	function ($default, maybe) {
		var _p0 = maybe;
		if (_p0.ctor === 'Just') {
			return _p0._0;
		} else {
			return $default;
		}
	});
var _elm_lang$core$Maybe$Nothing = {ctor: 'Nothing'};
var _elm_lang$core$Maybe$andThen = F2(
	function (callback, maybeValue) {
		var _p1 = maybeValue;
		if (_p1.ctor === 'Just') {
			return callback(_p1._0);
		} else {
			return _elm_lang$core$Maybe$Nothing;
		}
	});
var _elm_lang$core$Maybe$Just = function (a) {
	return {ctor: 'Just', _0: a};
};
var _elm_lang$core$Maybe$map = F2(
	function (f, maybe) {
		var _p2 = maybe;
		if (_p2.ctor === 'Just') {
			return _elm_lang$core$Maybe$Just(
				f(_p2._0));
		} else {
			return _elm_lang$core$Maybe$Nothing;
		}
	});
var _elm_lang$core$Maybe$map2 = F3(
	function (func, ma, mb) {
		var _p3 = {ctor: '_Tuple2', _0: ma, _1: mb};
		if (((_p3.ctor === '_Tuple2') && (_p3._0.ctor === 'Just')) && (_p3._1.ctor === 'Just')) {
			return _elm_lang$core$Maybe$Just(
				A2(func, _p3._0._0, _p3._1._0));
		} else {
			return _elm_lang$core$Maybe$Nothing;
		}
	});
var _elm_lang$core$Maybe$map3 = F4(
	function (func, ma, mb, mc) {
		var _p4 = {ctor: '_Tuple3', _0: ma, _1: mb, _2: mc};
		if ((((_p4.ctor === '_Tuple3') && (_p4._0.ctor === 'Just')) && (_p4._1.ctor === 'Just')) && (_p4._2.ctor === 'Just')) {
			return _elm_lang$core$Maybe$Just(
				A3(func, _p4._0._0, _p4._1._0, _p4._2._0));
		} else {
			return _elm_lang$core$Maybe$Nothing;
		}
	});
var _elm_lang$core$Maybe$map4 = F5(
	function (func, ma, mb, mc, md) {
		var _p5 = {ctor: '_Tuple4', _0: ma, _1: mb, _2: mc, _3: md};
		if (((((_p5.ctor === '_Tuple4') && (_p5._0.ctor === 'Just')) && (_p5._1.ctor === 'Just')) && (_p5._2.ctor === 'Just')) && (_p5._3.ctor === 'Just')) {
			return _elm_lang$core$Maybe$Just(
				A4(func, _p5._0._0, _p5._1._0, _p5._2._0, _p5._3._0));
		} else {
			return _elm_lang$core$Maybe$Nothing;
		}
	});
var _elm_lang$core$Maybe$map5 = F6(
	function (func, ma, mb, mc, md, me) {
		var _p6 = {ctor: '_Tuple5', _0: ma, _1: mb, _2: mc, _3: md, _4: me};
		if ((((((_p6.ctor === '_Tuple5') && (_p6._0.ctor === 'Just')) && (_p6._1.ctor === 'Just')) && (_p6._2.ctor === 'Just')) && (_p6._3.ctor === 'Just')) && (_p6._4.ctor === 'Just')) {
			return _elm_lang$core$Maybe$Just(
				A5(func, _p6._0._0, _p6._1._0, _p6._2._0, _p6._3._0, _p6._4._0));
		} else {
			return _elm_lang$core$Maybe$Nothing;
		}
	});

//import Native.Utils //

var _elm_lang$core$Native_List = function() {

var Nil = { ctor: '[]' };

function Cons(hd, tl)
{
	return { ctor: '::', _0: hd, _1: tl };
}

function fromArray(arr)
{
	var out = Nil;
	for (var i = arr.length; i--; )
	{
		out = Cons(arr[i], out);
	}
	return out;
}

function toArray(xs)
{
	var out = [];
	while (xs.ctor !== '[]')
	{
		out.push(xs._0);
		xs = xs._1;
	}
	return out;
}

function foldr(f, b, xs)
{
	var arr = toArray(xs);
	var acc = b;
	for (var i = arr.length; i--; )
	{
		acc = A2(f, arr[i], acc);
	}
	return acc;
}

function map2(f, xs, ys)
{
	var arr = [];
	while (xs.ctor !== '[]' && ys.ctor !== '[]')
	{
		arr.push(A2(f, xs._0, ys._0));
		xs = xs._1;
		ys = ys._1;
	}
	return fromArray(arr);
}

function map3(f, xs, ys, zs)
{
	var arr = [];
	while (xs.ctor !== '[]' && ys.ctor !== '[]' && zs.ctor !== '[]')
	{
		arr.push(A3(f, xs._0, ys._0, zs._0));
		xs = xs._1;
		ys = ys._1;
		zs = zs._1;
	}
	return fromArray(arr);
}

function map4(f, ws, xs, ys, zs)
{
	var arr = [];
	while (   ws.ctor !== '[]'
		   && xs.ctor !== '[]'
		   && ys.ctor !== '[]'
		   && zs.ctor !== '[]')
	{
		arr.push(A4(f, ws._0, xs._0, ys._0, zs._0));
		ws = ws._1;
		xs = xs._1;
		ys = ys._1;
		zs = zs._1;
	}
	return fromArray(arr);
}

function map5(f, vs, ws, xs, ys, zs)
{
	var arr = [];
	while (   vs.ctor !== '[]'
		   && ws.ctor !== '[]'
		   && xs.ctor !== '[]'
		   && ys.ctor !== '[]'
		   && zs.ctor !== '[]')
	{
		arr.push(A5(f, vs._0, ws._0, xs._0, ys._0, zs._0));
		vs = vs._1;
		ws = ws._1;
		xs = xs._1;
		ys = ys._1;
		zs = zs._1;
	}
	return fromArray(arr);
}

function sortBy(f, xs)
{
	return fromArray(toArray(xs).sort(function(a, b) {
		return _elm_lang$core$Native_Utils.cmp(f(a), f(b));
	}));
}

function sortWith(f, xs)
{
	return fromArray(toArray(xs).sort(function(a, b) {
		var ord = f(a)(b).ctor;
		return ord === 'EQ' ? 0 : ord === 'LT' ? -1 : 1;
	}));
}

return {
	Nil: Nil,
	Cons: Cons,
	cons: F2(Cons),
	toArray: toArray,
	fromArray: fromArray,

	foldr: F3(foldr),

	map2: F3(map2),
	map3: F4(map3),
	map4: F5(map4),
	map5: F6(map5),
	sortBy: F2(sortBy),
	sortWith: F2(sortWith)
};

}();
var _elm_lang$core$List$sortWith = _elm_lang$core$Native_List.sortWith;
var _elm_lang$core$List$sortBy = _elm_lang$core$Native_List.sortBy;
var _elm_lang$core$List$sort = function (xs) {
	return A2(_elm_lang$core$List$sortBy, _elm_lang$core$Basics$identity, xs);
};
var _elm_lang$core$List$drop = F2(
	function (n, list) {
		drop:
		while (true) {
			if (_elm_lang$core$Native_Utils.cmp(n, 0) < 1) {
				return list;
			} else {
				var _p0 = list;
				if (_p0.ctor === '[]') {
					return list;
				} else {
					var _v1 = n - 1,
						_v2 = _p0._1;
					n = _v1;
					list = _v2;
					continue drop;
				}
			}
		}
	});
var _elm_lang$core$List$map5 = _elm_lang$core$Native_List.map5;
var _elm_lang$core$List$map4 = _elm_lang$core$Native_List.map4;
var _elm_lang$core$List$map3 = _elm_lang$core$Native_List.map3;
var _elm_lang$core$List$map2 = _elm_lang$core$Native_List.map2;
var _elm_lang$core$List$any = F2(
	function (isOkay, list) {
		any:
		while (true) {
			var _p1 = list;
			if (_p1.ctor === '[]') {
				return false;
			} else {
				if (isOkay(_p1._0)) {
					return true;
				} else {
					var _v4 = isOkay,
						_v5 = _p1._1;
					isOkay = _v4;
					list = _v5;
					continue any;
				}
			}
		}
	});
var _elm_lang$core$List$all = F2(
	function (isOkay, list) {
		return !A2(
			_elm_lang$core$List$any,
			function (_p2) {
				return !isOkay(_p2);
			},
			list);
	});
var _elm_lang$core$List$foldr = _elm_lang$core$Native_List.foldr;
var _elm_lang$core$List$foldl = F3(
	function (func, acc, list) {
		foldl:
		while (true) {
			var _p3 = list;
			if (_p3.ctor === '[]') {
				return acc;
			} else {
				var _v7 = func,
					_v8 = A2(func, _p3._0, acc),
					_v9 = _p3._1;
				func = _v7;
				acc = _v8;
				list = _v9;
				continue foldl;
			}
		}
	});
var _elm_lang$core$List$length = function (xs) {
	return A3(
		_elm_lang$core$List$foldl,
		F2(
			function (_p4, i) {
				return i + 1;
			}),
		0,
		xs);
};
var _elm_lang$core$List$sum = function (numbers) {
	return A3(
		_elm_lang$core$List$foldl,
		F2(
			function (x, y) {
				return x + y;
			}),
		0,
		numbers);
};
var _elm_lang$core$List$product = function (numbers) {
	return A3(
		_elm_lang$core$List$foldl,
		F2(
			function (x, y) {
				return x * y;
			}),
		1,
		numbers);
};
var _elm_lang$core$List$maximum = function (list) {
	var _p5 = list;
	if (_p5.ctor === '::') {
		return _elm_lang$core$Maybe$Just(
			A3(_elm_lang$core$List$foldl, _elm_lang$core$Basics$max, _p5._0, _p5._1));
	} else {
		return _elm_lang$core$Maybe$Nothing;
	}
};
var _elm_lang$core$List$minimum = function (list) {
	var _p6 = list;
	if (_p6.ctor === '::') {
		return _elm_lang$core$Maybe$Just(
			A3(_elm_lang$core$List$foldl, _elm_lang$core$Basics$min, _p6._0, _p6._1));
	} else {
		return _elm_lang$core$Maybe$Nothing;
	}
};
var _elm_lang$core$List$member = F2(
	function (x, xs) {
		return A2(
			_elm_lang$core$List$any,
			function (a) {
				return _elm_lang$core$Native_Utils.eq(a, x);
			},
			xs);
	});
var _elm_lang$core$List$isEmpty = function (xs) {
	var _p7 = xs;
	if (_p7.ctor === '[]') {
		return true;
	} else {
		return false;
	}
};
var _elm_lang$core$List$tail = function (list) {
	var _p8 = list;
	if (_p8.ctor === '::') {
		return _elm_lang$core$Maybe$Just(_p8._1);
	} else {
		return _elm_lang$core$Maybe$Nothing;
	}
};
var _elm_lang$core$List$head = function (list) {
	var _p9 = list;
	if (_p9.ctor === '::') {
		return _elm_lang$core$Maybe$Just(_p9._0);
	} else {
		return _elm_lang$core$Maybe$Nothing;
	}
};
var _elm_lang$core$List_ops = _elm_lang$core$List_ops || {};
_elm_lang$core$List_ops['::'] = _elm_lang$core$Native_List.cons;
var _elm_lang$core$List$map = F2(
	function (f, xs) {
		return A3(
			_elm_lang$core$List$foldr,
			F2(
				function (x, acc) {
					return {
						ctor: '::',
						_0: f(x),
						_1: acc
					};
				}),
			{ctor: '[]'},
			xs);
	});
var _elm_lang$core$List$filter = F2(
	function (pred, xs) {
		var conditionalCons = F2(
			function (front, back) {
				return pred(front) ? {ctor: '::', _0: front, _1: back} : back;
			});
		return A3(
			_elm_lang$core$List$foldr,
			conditionalCons,
			{ctor: '[]'},
			xs);
	});
var _elm_lang$core$List$maybeCons = F3(
	function (f, mx, xs) {
		var _p10 = f(mx);
		if (_p10.ctor === 'Just') {
			return {ctor: '::', _0: _p10._0, _1: xs};
		} else {
			return xs;
		}
	});
var _elm_lang$core$List$filterMap = F2(
	function (f, xs) {
		return A3(
			_elm_lang$core$List$foldr,
			_elm_lang$core$List$maybeCons(f),
			{ctor: '[]'},
			xs);
	});
var _elm_lang$core$List$reverse = function (list) {
	return A3(
		_elm_lang$core$List$foldl,
		F2(
			function (x, y) {
				return {ctor: '::', _0: x, _1: y};
			}),
		{ctor: '[]'},
		list);
};
var _elm_lang$core$List$scanl = F3(
	function (f, b, xs) {
		var scan1 = F2(
			function (x, accAcc) {
				var _p11 = accAcc;
				if (_p11.ctor === '::') {
					return {
						ctor: '::',
						_0: A2(f, x, _p11._0),
						_1: accAcc
					};
				} else {
					return {ctor: '[]'};
				}
			});
		return _elm_lang$core$List$reverse(
			A3(
				_elm_lang$core$List$foldl,
				scan1,
				{
					ctor: '::',
					_0: b,
					_1: {ctor: '[]'}
				},
				xs));
	});
var _elm_lang$core$List$append = F2(
	function (xs, ys) {
		var _p12 = ys;
		if (_p12.ctor === '[]') {
			return xs;
		} else {
			return A3(
				_elm_lang$core$List$foldr,
				F2(
					function (x, y) {
						return {ctor: '::', _0: x, _1: y};
					}),
				ys,
				xs);
		}
	});
var _elm_lang$core$List$concat = function (lists) {
	return A3(
		_elm_lang$core$List$foldr,
		_elm_lang$core$List$append,
		{ctor: '[]'},
		lists);
};
var _elm_lang$core$List$concatMap = F2(
	function (f, list) {
		return _elm_lang$core$List$concat(
			A2(_elm_lang$core$List$map, f, list));
	});
var _elm_lang$core$List$partition = F2(
	function (pred, list) {
		var step = F2(
			function (x, _p13) {
				var _p14 = _p13;
				var _p16 = _p14._0;
				var _p15 = _p14._1;
				return pred(x) ? {
					ctor: '_Tuple2',
					_0: {ctor: '::', _0: x, _1: _p16},
					_1: _p15
				} : {
					ctor: '_Tuple2',
					_0: _p16,
					_1: {ctor: '::', _0: x, _1: _p15}
				};
			});
		return A3(
			_elm_lang$core$List$foldr,
			step,
			{
				ctor: '_Tuple2',
				_0: {ctor: '[]'},
				_1: {ctor: '[]'}
			},
			list);
	});
var _elm_lang$core$List$unzip = function (pairs) {
	var step = F2(
		function (_p18, _p17) {
			var _p19 = _p18;
			var _p20 = _p17;
			return {
				ctor: '_Tuple2',
				_0: {ctor: '::', _0: _p19._0, _1: _p20._0},
				_1: {ctor: '::', _0: _p19._1, _1: _p20._1}
			};
		});
	return A3(
		_elm_lang$core$List$foldr,
		step,
		{
			ctor: '_Tuple2',
			_0: {ctor: '[]'},
			_1: {ctor: '[]'}
		},
		pairs);
};
var _elm_lang$core$List$intersperse = F2(
	function (sep, xs) {
		var _p21 = xs;
		if (_p21.ctor === '[]') {
			return {ctor: '[]'};
		} else {
			var step = F2(
				function (x, rest) {
					return {
						ctor: '::',
						_0: sep,
						_1: {ctor: '::', _0: x, _1: rest}
					};
				});
			var spersed = A3(
				_elm_lang$core$List$foldr,
				step,
				{ctor: '[]'},
				_p21._1);
			return {ctor: '::', _0: _p21._0, _1: spersed};
		}
	});
var _elm_lang$core$List$takeReverse = F3(
	function (n, list, taken) {
		takeReverse:
		while (true) {
			if (_elm_lang$core$Native_Utils.cmp(n, 0) < 1) {
				return taken;
			} else {
				var _p22 = list;
				if (_p22.ctor === '[]') {
					return taken;
				} else {
					var _v23 = n - 1,
						_v24 = _p22._1,
						_v25 = {ctor: '::', _0: _p22._0, _1: taken};
					n = _v23;
					list = _v24;
					taken = _v25;
					continue takeReverse;
				}
			}
		}
	});
var _elm_lang$core$List$takeTailRec = F2(
	function (n, list) {
		return _elm_lang$core$List$reverse(
			A3(
				_elm_lang$core$List$takeReverse,
				n,
				list,
				{ctor: '[]'}));
	});
var _elm_lang$core$List$takeFast = F3(
	function (ctr, n, list) {
		if (_elm_lang$core$Native_Utils.cmp(n, 0) < 1) {
			return {ctor: '[]'};
		} else {
			var _p23 = {ctor: '_Tuple2', _0: n, _1: list};
			_v26_5:
			do {
				_v26_1:
				do {
					if (_p23.ctor === '_Tuple2') {
						if (_p23._1.ctor === '[]') {
							return list;
						} else {
							if (_p23._1._1.ctor === '::') {
								switch (_p23._0) {
									case 1:
										break _v26_1;
									case 2:
										return {
											ctor: '::',
											_0: _p23._1._0,
											_1: {
												ctor: '::',
												_0: _p23._1._1._0,
												_1: {ctor: '[]'}
											}
										};
									case 3:
										if (_p23._1._1._1.ctor === '::') {
											return {
												ctor: '::',
												_0: _p23._1._0,
												_1: {
													ctor: '::',
													_0: _p23._1._1._0,
													_1: {
														ctor: '::',
														_0: _p23._1._1._1._0,
														_1: {ctor: '[]'}
													}
												}
											};
										} else {
											break _v26_5;
										}
									default:
										if ((_p23._1._1._1.ctor === '::') && (_p23._1._1._1._1.ctor === '::')) {
											var _p28 = _p23._1._1._1._0;
											var _p27 = _p23._1._1._0;
											var _p26 = _p23._1._0;
											var _p25 = _p23._1._1._1._1._0;
											var _p24 = _p23._1._1._1._1._1;
											return (_elm_lang$core$Native_Utils.cmp(ctr, 1000) > 0) ? {
												ctor: '::',
												_0: _p26,
												_1: {
													ctor: '::',
													_0: _p27,
													_1: {
														ctor: '::',
														_0: _p28,
														_1: {
															ctor: '::',
															_0: _p25,
															_1: A2(_elm_lang$core$List$takeTailRec, n - 4, _p24)
														}
													}
												}
											} : {
												ctor: '::',
												_0: _p26,
												_1: {
													ctor: '::',
													_0: _p27,
													_1: {
														ctor: '::',
														_0: _p28,
														_1: {
															ctor: '::',
															_0: _p25,
															_1: A3(_elm_lang$core$List$takeFast, ctr + 1, n - 4, _p24)
														}
													}
												}
											};
										} else {
											break _v26_5;
										}
								}
							} else {
								if (_p23._0 === 1) {
									break _v26_1;
								} else {
									break _v26_5;
								}
							}
						}
					} else {
						break _v26_5;
					}
				} while(false);
				return {
					ctor: '::',
					_0: _p23._1._0,
					_1: {ctor: '[]'}
				};
			} while(false);
			return list;
		}
	});
var _elm_lang$core$List$take = F2(
	function (n, list) {
		return A3(_elm_lang$core$List$takeFast, 0, n, list);
	});
var _elm_lang$core$List$repeatHelp = F3(
	function (result, n, value) {
		repeatHelp:
		while (true) {
			if (_elm_lang$core$Native_Utils.cmp(n, 0) < 1) {
				return result;
			} else {
				var _v27 = {ctor: '::', _0: value, _1: result},
					_v28 = n - 1,
					_v29 = value;
				result = _v27;
				n = _v28;
				value = _v29;
				continue repeatHelp;
			}
		}
	});
var _elm_lang$core$List$repeat = F2(
	function (n, value) {
		return A3(
			_elm_lang$core$List$repeatHelp,
			{ctor: '[]'},
			n,
			value);
	});
var _elm_lang$core$List$rangeHelp = F3(
	function (lo, hi, list) {
		rangeHelp:
		while (true) {
			if (_elm_lang$core$Native_Utils.cmp(lo, hi) < 1) {
				var _v30 = lo,
					_v31 = hi - 1,
					_v32 = {ctor: '::', _0: hi, _1: list};
				lo = _v30;
				hi = _v31;
				list = _v32;
				continue rangeHelp;
			} else {
				return list;
			}
		}
	});
var _elm_lang$core$List$range = F2(
	function (lo, hi) {
		return A3(
			_elm_lang$core$List$rangeHelp,
			lo,
			hi,
			{ctor: '[]'});
	});
var _elm_lang$core$List$indexedMap = F2(
	function (f, xs) {
		return A3(
			_elm_lang$core$List$map2,
			f,
			A2(
				_elm_lang$core$List$range,
				0,
				_elm_lang$core$List$length(xs) - 1),
			xs);
	});

var _elm_lang$core$Result$toMaybe = function (result) {
	var _p0 = result;
	if (_p0.ctor === 'Ok') {
		return _elm_lang$core$Maybe$Just(_p0._0);
	} else {
		return _elm_lang$core$Maybe$Nothing;
	}
};
var _elm_lang$core$Result$withDefault = F2(
	function (def, result) {
		var _p1 = result;
		if (_p1.ctor === 'Ok') {
			return _p1._0;
		} else {
			return def;
		}
	});
var _elm_lang$core$Result$Err = function (a) {
	return {ctor: 'Err', _0: a};
};
var _elm_lang$core$Result$andThen = F2(
	function (callback, result) {
		var _p2 = result;
		if (_p2.ctor === 'Ok') {
			return callback(_p2._0);
		} else {
			return _elm_lang$core$Result$Err(_p2._0);
		}
	});
var _elm_lang$core$Result$Ok = function (a) {
	return {ctor: 'Ok', _0: a};
};
var _elm_lang$core$Result$map = F2(
	function (func, ra) {
		var _p3 = ra;
		if (_p3.ctor === 'Ok') {
			return _elm_lang$core$Result$Ok(
				func(_p3._0));
		} else {
			return _elm_lang$core$Result$Err(_p3._0);
		}
	});
var _elm_lang$core$Result$map2 = F3(
	function (func, ra, rb) {
		var _p4 = {ctor: '_Tuple2', _0: ra, _1: rb};
		if (_p4._0.ctor === 'Ok') {
			if (_p4._1.ctor === 'Ok') {
				return _elm_lang$core$Result$Ok(
					A2(func, _p4._0._0, _p4._1._0));
			} else {
				return _elm_lang$core$Result$Err(_p4._1._0);
			}
		} else {
			return _elm_lang$core$Result$Err(_p4._0._0);
		}
	});
var _elm_lang$core$Result$map3 = F4(
	function (func, ra, rb, rc) {
		var _p5 = {ctor: '_Tuple3', _0: ra, _1: rb, _2: rc};
		if (_p5._0.ctor === 'Ok') {
			if (_p5._1.ctor === 'Ok') {
				if (_p5._2.ctor === 'Ok') {
					return _elm_lang$core$Result$Ok(
						A3(func, _p5._0._0, _p5._1._0, _p5._2._0));
				} else {
					return _elm_lang$core$Result$Err(_p5._2._0);
				}
			} else {
				return _elm_lang$core$Result$Err(_p5._1._0);
			}
		} else {
			return _elm_lang$core$Result$Err(_p5._0._0);
		}
	});
var _elm_lang$core$Result$map4 = F5(
	function (func, ra, rb, rc, rd) {
		var _p6 = {ctor: '_Tuple4', _0: ra, _1: rb, _2: rc, _3: rd};
		if (_p6._0.ctor === 'Ok') {
			if (_p6._1.ctor === 'Ok') {
				if (_p6._2.ctor === 'Ok') {
					if (_p6._3.ctor === 'Ok') {
						return _elm_lang$core$Result$Ok(
							A4(func, _p6._0._0, _p6._1._0, _p6._2._0, _p6._3._0));
					} else {
						return _elm_lang$core$Result$Err(_p6._3._0);
					}
				} else {
					return _elm_lang$core$Result$Err(_p6._2._0);
				}
			} else {
				return _elm_lang$core$Result$Err(_p6._1._0);
			}
		} else {
			return _elm_lang$core$Result$Err(_p6._0._0);
		}
	});
var _elm_lang$core$Result$map5 = F6(
	function (func, ra, rb, rc, rd, re) {
		var _p7 = {ctor: '_Tuple5', _0: ra, _1: rb, _2: rc, _3: rd, _4: re};
		if (_p7._0.ctor === 'Ok') {
			if (_p7._1.ctor === 'Ok') {
				if (_p7._2.ctor === 'Ok') {
					if (_p7._3.ctor === 'Ok') {
						if (_p7._4.ctor === 'Ok') {
							return _elm_lang$core$Result$Ok(
								A5(func, _p7._0._0, _p7._1._0, _p7._2._0, _p7._3._0, _p7._4._0));
						} else {
							return _elm_lang$core$Result$Err(_p7._4._0);
						}
					} else {
						return _elm_lang$core$Result$Err(_p7._3._0);
					}
				} else {
					return _elm_lang$core$Result$Err(_p7._2._0);
				}
			} else {
				return _elm_lang$core$Result$Err(_p7._1._0);
			}
		} else {
			return _elm_lang$core$Result$Err(_p7._0._0);
		}
	});
var _elm_lang$core$Result$mapError = F2(
	function (f, result) {
		var _p8 = result;
		if (_p8.ctor === 'Ok') {
			return _elm_lang$core$Result$Ok(_p8._0);
		} else {
			return _elm_lang$core$Result$Err(
				f(_p8._0));
		}
	});
var _elm_lang$core$Result$fromMaybe = F2(
	function (err, maybe) {
		var _p9 = maybe;
		if (_p9.ctor === 'Just') {
			return _elm_lang$core$Result$Ok(_p9._0);
		} else {
			return _elm_lang$core$Result$Err(err);
		}
	});

//import Maybe, Native.List, Native.Utils, Result //

var _elm_lang$core$Native_String = function() {

function isEmpty(str)
{
	return str.length === 0;
}
function cons(chr, str)
{
	return chr + str;
}
function uncons(str)
{
	var hd = str[0];
	if (hd)
	{
		return _elm_lang$core$Maybe$Just(_elm_lang$core$Native_Utils.Tuple2(_elm_lang$core$Native_Utils.chr(hd), str.slice(1)));
	}
	return _elm_lang$core$Maybe$Nothing;
}
function append(a, b)
{
	return a + b;
}
function concat(strs)
{
	return _elm_lang$core$Native_List.toArray(strs).join('');
}
function length(str)
{
	return str.length;
}
function map(f, str)
{
	var out = str.split('');
	for (var i = out.length; i--; )
	{
		out[i] = f(_elm_lang$core$Native_Utils.chr(out[i]));
	}
	return out.join('');
}
function filter(pred, str)
{
	return str.split('').map(_elm_lang$core$Native_Utils.chr).filter(pred).join('');
}
function reverse(str)
{
	return str.split('').reverse().join('');
}
function foldl(f, b, str)
{
	var len = str.length;
	for (var i = 0; i < len; ++i)
	{
		b = A2(f, _elm_lang$core$Native_Utils.chr(str[i]), b);
	}
	return b;
}
function foldr(f, b, str)
{
	for (var i = str.length; i--; )
	{
		b = A2(f, _elm_lang$core$Native_Utils.chr(str[i]), b);
	}
	return b;
}
function split(sep, str)
{
	return _elm_lang$core$Native_List.fromArray(str.split(sep));
}
function join(sep, strs)
{
	return _elm_lang$core$Native_List.toArray(strs).join(sep);
}
function repeat(n, str)
{
	var result = '';
	while (n > 0)
	{
		if (n & 1)
		{
			result += str;
		}
		n >>= 1, str += str;
	}
	return result;
}
function slice(start, end, str)
{
	return str.slice(start, end);
}
function left(n, str)
{
	return n < 1 ? '' : str.slice(0, n);
}
function right(n, str)
{
	return n < 1 ? '' : str.slice(-n);
}
function dropLeft(n, str)
{
	return n < 1 ? str : str.slice(n);
}
function dropRight(n, str)
{
	return n < 1 ? str : str.slice(0, -n);
}
function pad(n, chr, str)
{
	var half = (n - str.length) / 2;
	return repeat(Math.ceil(half), chr) + str + repeat(half | 0, chr);
}
function padRight(n, chr, str)
{
	return str + repeat(n - str.length, chr);
}
function padLeft(n, chr, str)
{
	return repeat(n - str.length, chr) + str;
}

function trim(str)
{
	return str.trim();
}
function trimLeft(str)
{
	return str.replace(/^\s+/, '');
}
function trimRight(str)
{
	return str.replace(/\s+$/, '');
}

function words(str)
{
	return _elm_lang$core$Native_List.fromArray(str.trim().split(/\s+/g));
}
function lines(str)
{
	return _elm_lang$core$Native_List.fromArray(str.split(/\r\n|\r|\n/g));
}

function toUpper(str)
{
	return str.toUpperCase();
}
function toLower(str)
{
	return str.toLowerCase();
}

function any(pred, str)
{
	for (var i = str.length; i--; )
	{
		if (pred(_elm_lang$core$Native_Utils.chr(str[i])))
		{
			return true;
		}
	}
	return false;
}
function all(pred, str)
{
	for (var i = str.length; i--; )
	{
		if (!pred(_elm_lang$core$Native_Utils.chr(str[i])))
		{
			return false;
		}
	}
	return true;
}

function contains(sub, str)
{
	return str.indexOf(sub) > -1;
}
function startsWith(sub, str)
{
	return str.indexOf(sub) === 0;
}
function endsWith(sub, str)
{
	return str.length >= sub.length &&
		str.lastIndexOf(sub) === str.length - sub.length;
}
function indexes(sub, str)
{
	var subLen = sub.length;
	
	if (subLen < 1)
	{
		return _elm_lang$core$Native_List.Nil;
	}

	var i = 0;
	var is = [];

	while ((i = str.indexOf(sub, i)) > -1)
	{
		is.push(i);
		i = i + subLen;
	}	
	
	return _elm_lang$core$Native_List.fromArray(is);
}

function toInt(s)
{
	var len = s.length;
	if (len === 0)
	{
		return _elm_lang$core$Result$Err("could not convert string '" + s + "' to an Int" );
	}
	var start = 0;
	if (s[0] === '-')
	{
		if (len === 1)
		{
			return _elm_lang$core$Result$Err("could not convert string '" + s + "' to an Int" );
		}
		start = 1;
	}
	for (var i = start; i < len; ++i)
	{
		var c = s[i];
		if (c < '0' || '9' < c)
		{
			return _elm_lang$core$Result$Err("could not convert string '" + s + "' to an Int" );
		}
	}
	return _elm_lang$core$Result$Ok(parseInt(s, 10));
}

function toFloat(s)
{
	var len = s.length;
	if (len === 0)
	{
		return _elm_lang$core$Result$Err("could not convert string '" + s + "' to a Float" );
	}
	var start = 0;
	if (s[0] === '-')
	{
		if (len === 1)
		{
			return _elm_lang$core$Result$Err("could not convert string '" + s + "' to a Float" );
		}
		start = 1;
	}
	var dotCount = 0;
	for (var i = start; i < len; ++i)
	{
		var c = s[i];
		if ('0' <= c && c <= '9')
		{
			continue;
		}
		if (c === '.')
		{
			dotCount += 1;
			if (dotCount <= 1)
			{
				continue;
			}
		}
		return _elm_lang$core$Result$Err("could not convert string '" + s + "' to a Float" );
	}
	return _elm_lang$core$Result$Ok(parseFloat(s));
}

function toList(str)
{
	return _elm_lang$core$Native_List.fromArray(str.split('').map(_elm_lang$core$Native_Utils.chr));
}
function fromList(chars)
{
	return _elm_lang$core$Native_List.toArray(chars).join('');
}

return {
	isEmpty: isEmpty,
	cons: F2(cons),
	uncons: uncons,
	append: F2(append),
	concat: concat,
	length: length,
	map: F2(map),
	filter: F2(filter),
	reverse: reverse,
	foldl: F3(foldl),
	foldr: F3(foldr),

	split: F2(split),
	join: F2(join),
	repeat: F2(repeat),

	slice: F3(slice),
	left: F2(left),
	right: F2(right),
	dropLeft: F2(dropLeft),
	dropRight: F2(dropRight),

	pad: F3(pad),
	padLeft: F3(padLeft),
	padRight: F3(padRight),

	trim: trim,
	trimLeft: trimLeft,
	trimRight: trimRight,

	words: words,
	lines: lines,

	toUpper: toUpper,
	toLower: toLower,

	any: F2(any),
	all: F2(all),

	contains: F2(contains),
	startsWith: F2(startsWith),
	endsWith: F2(endsWith),
	indexes: F2(indexes),

	toInt: toInt,
	toFloat: toFloat,
	toList: toList,
	fromList: fromList
};

}();

//import Native.Utils //

var _elm_lang$core$Native_Char = function() {

return {
	fromCode: function(c) { return _elm_lang$core$Native_Utils.chr(String.fromCharCode(c)); },
	toCode: function(c) { return c.charCodeAt(0); },
	toUpper: function(c) { return _elm_lang$core$Native_Utils.chr(c.toUpperCase()); },
	toLower: function(c) { return _elm_lang$core$Native_Utils.chr(c.toLowerCase()); },
	toLocaleUpper: function(c) { return _elm_lang$core$Native_Utils.chr(c.toLocaleUpperCase()); },
	toLocaleLower: function(c) { return _elm_lang$core$Native_Utils.chr(c.toLocaleLowerCase()); }
};

}();
var _elm_lang$core$Char$fromCode = _elm_lang$core$Native_Char.fromCode;
var _elm_lang$core$Char$toCode = _elm_lang$core$Native_Char.toCode;
var _elm_lang$core$Char$toLocaleLower = _elm_lang$core$Native_Char.toLocaleLower;
var _elm_lang$core$Char$toLocaleUpper = _elm_lang$core$Native_Char.toLocaleUpper;
var _elm_lang$core$Char$toLower = _elm_lang$core$Native_Char.toLower;
var _elm_lang$core$Char$toUpper = _elm_lang$core$Native_Char.toUpper;
var _elm_lang$core$Char$isBetween = F3(
	function (low, high, $char) {
		var code = _elm_lang$core$Char$toCode($char);
		return (_elm_lang$core$Native_Utils.cmp(
			code,
			_elm_lang$core$Char$toCode(low)) > -1) && (_elm_lang$core$Native_Utils.cmp(
			code,
			_elm_lang$core$Char$toCode(high)) < 1);
	});
var _elm_lang$core$Char$isUpper = A2(
	_elm_lang$core$Char$isBetween,
	_elm_lang$core$Native_Utils.chr('A'),
	_elm_lang$core$Native_Utils.chr('Z'));
var _elm_lang$core$Char$isLower = A2(
	_elm_lang$core$Char$isBetween,
	_elm_lang$core$Native_Utils.chr('a'),
	_elm_lang$core$Native_Utils.chr('z'));
var _elm_lang$core$Char$isDigit = A2(
	_elm_lang$core$Char$isBetween,
	_elm_lang$core$Native_Utils.chr('0'),
	_elm_lang$core$Native_Utils.chr('9'));
var _elm_lang$core$Char$isOctDigit = A2(
	_elm_lang$core$Char$isBetween,
	_elm_lang$core$Native_Utils.chr('0'),
	_elm_lang$core$Native_Utils.chr('7'));
var _elm_lang$core$Char$isHexDigit = function ($char) {
	return _elm_lang$core$Char$isDigit($char) || (A3(
		_elm_lang$core$Char$isBetween,
		_elm_lang$core$Native_Utils.chr('a'),
		_elm_lang$core$Native_Utils.chr('f'),
		$char) || A3(
		_elm_lang$core$Char$isBetween,
		_elm_lang$core$Native_Utils.chr('A'),
		_elm_lang$core$Native_Utils.chr('F'),
		$char));
};

var _elm_lang$core$String$fromList = _elm_lang$core$Native_String.fromList;
var _elm_lang$core$String$toList = _elm_lang$core$Native_String.toList;
var _elm_lang$core$String$toFloat = _elm_lang$core$Native_String.toFloat;
var _elm_lang$core$String$toInt = _elm_lang$core$Native_String.toInt;
var _elm_lang$core$String$indices = _elm_lang$core$Native_String.indexes;
var _elm_lang$core$String$indexes = _elm_lang$core$Native_String.indexes;
var _elm_lang$core$String$endsWith = _elm_lang$core$Native_String.endsWith;
var _elm_lang$core$String$startsWith = _elm_lang$core$Native_String.startsWith;
var _elm_lang$core$String$contains = _elm_lang$core$Native_String.contains;
var _elm_lang$core$String$all = _elm_lang$core$Native_String.all;
var _elm_lang$core$String$any = _elm_lang$core$Native_String.any;
var _elm_lang$core$String$toLower = _elm_lang$core$Native_String.toLower;
var _elm_lang$core$String$toUpper = _elm_lang$core$Native_String.toUpper;
var _elm_lang$core$String$lines = _elm_lang$core$Native_String.lines;
var _elm_lang$core$String$words = _elm_lang$core$Native_String.words;
var _elm_lang$core$String$trimRight = _elm_lang$core$Native_String.trimRight;
var _elm_lang$core$String$trimLeft = _elm_lang$core$Native_String.trimLeft;
var _elm_lang$core$String$trim = _elm_lang$core$Native_String.trim;
var _elm_lang$core$String$padRight = _elm_lang$core$Native_String.padRight;
var _elm_lang$core$String$padLeft = _elm_lang$core$Native_String.padLeft;
var _elm_lang$core$String$pad = _elm_lang$core$Native_String.pad;
var _elm_lang$core$String$dropRight = _elm_lang$core$Native_String.dropRight;
var _elm_lang$core$String$dropLeft = _elm_lang$core$Native_String.dropLeft;
var _elm_lang$core$String$right = _elm_lang$core$Native_String.right;
var _elm_lang$core$String$left = _elm_lang$core$Native_String.left;
var _elm_lang$core$String$slice = _elm_lang$core$Native_String.slice;
var _elm_lang$core$String$repeat = _elm_lang$core$Native_String.repeat;
var _elm_lang$core$String$join = _elm_lang$core$Native_String.join;
var _elm_lang$core$String$split = _elm_lang$core$Native_String.split;
var _elm_lang$core$String$foldr = _elm_lang$core$Native_String.foldr;
var _elm_lang$core$String$foldl = _elm_lang$core$Native_String.foldl;
var _elm_lang$core$String$reverse = _elm_lang$core$Native_String.reverse;
var _elm_lang$core$String$filter = _elm_lang$core$Native_String.filter;
var _elm_lang$core$String$map = _elm_lang$core$Native_String.map;
var _elm_lang$core$String$length = _elm_lang$core$Native_String.length;
var _elm_lang$core$String$concat = _elm_lang$core$Native_String.concat;
var _elm_lang$core$String$append = _elm_lang$core$Native_String.append;
var _elm_lang$core$String$uncons = _elm_lang$core$Native_String.uncons;
var _elm_lang$core$String$cons = _elm_lang$core$Native_String.cons;
var _elm_lang$core$String$fromChar = function ($char) {
	return A2(_elm_lang$core$String$cons, $char, '');
};
var _elm_lang$core$String$isEmpty = _elm_lang$core$Native_String.isEmpty;

var _elm_lang$core$Tuple$mapSecond = F2(
	function (func, _p0) {
		var _p1 = _p0;
		return {
			ctor: '_Tuple2',
			_0: _p1._0,
			_1: func(_p1._1)
		};
	});
var _elm_lang$core$Tuple$mapFirst = F2(
	function (func, _p2) {
		var _p3 = _p2;
		return {
			ctor: '_Tuple2',
			_0: func(_p3._0),
			_1: _p3._1
		};
	});
var _elm_lang$core$Tuple$second = function (_p4) {
	var _p5 = _p4;
	return _p5._1;
};
var _elm_lang$core$Tuple$first = function (_p6) {
	var _p7 = _p6;
	return _p7._0;
};

//import //

var _elm_lang$core$Native_Platform = function() {


// PROGRAMS

function program(impl)
{
	return function(flagDecoder)
	{
		return function(object, moduleName)
		{
			object['worker'] = function worker(flags)
			{
				if (typeof flags !== 'undefined')
				{
					throw new Error(
						'The `' + moduleName + '` module does not need flags.\n'
						+ 'Call ' + moduleName + '.worker() with no arguments and you should be all set!'
					);
				}

				return initialize(
					impl.init,
					impl.update,
					impl.subscriptions,
					renderer
				);
			};
		};
	};
}

function programWithFlags(impl)
{
	return function(flagDecoder)
	{
		return function(object, moduleName)
		{
			object['worker'] = function worker(flags)
			{
				if (typeof flagDecoder === 'undefined')
				{
					throw new Error(
						'Are you trying to sneak a Never value into Elm? Trickster!\n'
						+ 'It looks like ' + moduleName + '.main is defined with `programWithFlags` but has type `Program Never`.\n'
						+ 'Use `program` instead if you do not want flags.'
					);
				}

				var result = A2(_elm_lang$core$Native_Json.run, flagDecoder, flags);
				if (result.ctor === 'Err')
				{
					throw new Error(
						moduleName + '.worker(...) was called with an unexpected argument.\n'
						+ 'I tried to convert it to an Elm value, but ran into this problem:\n\n'
						+ result._0
					);
				}

				return initialize(
					impl.init(result._0),
					impl.update,
					impl.subscriptions,
					renderer
				);
			};
		};
	};
}

function renderer(enqueue, _)
{
	return function(_) {};
}


// HTML TO PROGRAM

function htmlToProgram(vnode)
{
	var emptyBag = batch(_elm_lang$core$Native_List.Nil);
	var noChange = _elm_lang$core$Native_Utils.Tuple2(
		_elm_lang$core$Native_Utils.Tuple0,
		emptyBag
	);

	return _elm_lang$virtual_dom$VirtualDom$program({
		init: noChange,
		view: function(model) { return main; },
		update: F2(function(msg, model) { return noChange; }),
		subscriptions: function (model) { return emptyBag; }
	});
}


// INITIALIZE A PROGRAM

function initialize(init, update, subscriptions, renderer)
{
	// ambient state
	var managers = {};
	var updateView;

	// init and update state in main process
	var initApp = _elm_lang$core$Native_Scheduler.nativeBinding(function(callback) {
		var model = init._0;
		updateView = renderer(enqueue, model);
		var cmds = init._1;
		var subs = subscriptions(model);
		dispatchEffects(managers, cmds, subs);
		callback(_elm_lang$core$Native_Scheduler.succeed(model));
	});

	function onMessage(msg, model)
	{
		return _elm_lang$core$Native_Scheduler.nativeBinding(function(callback) {
			var results = A2(update, msg, model);
			model = results._0;
			updateView(model);
			var cmds = results._1;
			var subs = subscriptions(model);
			dispatchEffects(managers, cmds, subs);
			callback(_elm_lang$core$Native_Scheduler.succeed(model));
		});
	}

	var mainProcess = spawnLoop(initApp, onMessage);

	function enqueue(msg)
	{
		_elm_lang$core$Native_Scheduler.rawSend(mainProcess, msg);
	}

	var ports = setupEffects(managers, enqueue);

	return ports ? { ports: ports } : {};
}


// EFFECT MANAGERS

var effectManagers = {};

function setupEffects(managers, callback)
{
	var ports;

	// setup all necessary effect managers
	for (var key in effectManagers)
	{
		var manager = effectManagers[key];

		if (manager.isForeign)
		{
			ports = ports || {};
			ports[key] = manager.tag === 'cmd'
				? setupOutgoingPort(key)
				: setupIncomingPort(key, callback);
		}

		managers[key] = makeManager(manager, callback);
	}

	return ports;
}

function makeManager(info, callback)
{
	var router = {
		main: callback,
		self: undefined
	};

	var tag = info.tag;
	var onEffects = info.onEffects;
	var onSelfMsg = info.onSelfMsg;

	function onMessage(msg, state)
	{
		if (msg.ctor === 'self')
		{
			return A3(onSelfMsg, router, msg._0, state);
		}

		var fx = msg._0;
		switch (tag)
		{
			case 'cmd':
				return A3(onEffects, router, fx.cmds, state);

			case 'sub':
				return A3(onEffects, router, fx.subs, state);

			case 'fx':
				return A4(onEffects, router, fx.cmds, fx.subs, state);
		}
	}

	var process = spawnLoop(info.init, onMessage);
	router.self = process;
	return process;
}

function sendToApp(router, msg)
{
	return _elm_lang$core$Native_Scheduler.nativeBinding(function(callback)
	{
		router.main(msg);
		callback(_elm_lang$core$Native_Scheduler.succeed(_elm_lang$core$Native_Utils.Tuple0));
	});
}

function sendToSelf(router, msg)
{
	return A2(_elm_lang$core$Native_Scheduler.send, router.self, {
		ctor: 'self',
		_0: msg
	});
}


// HELPER for STATEFUL LOOPS

function spawnLoop(init, onMessage)
{
	var andThen = _elm_lang$core$Native_Scheduler.andThen;

	function loop(state)
	{
		var handleMsg = _elm_lang$core$Native_Scheduler.receive(function(msg) {
			return onMessage(msg, state);
		});
		return A2(andThen, loop, handleMsg);
	}

	var task = A2(andThen, loop, init);

	return _elm_lang$core$Native_Scheduler.rawSpawn(task);
}


// BAGS

function leaf(home)
{
	return function(value)
	{
		return {
			type: 'leaf',
			home: home,
			value: value
		};
	};
}

function batch(list)
{
	return {
		type: 'node',
		branches: list
	};
}

function map(tagger, bag)
{
	return {
		type: 'map',
		tagger: tagger,
		tree: bag
	}
}


// PIPE BAGS INTO EFFECT MANAGERS

function dispatchEffects(managers, cmdBag, subBag)
{
	var effectsDict = {};
	gatherEffects(true, cmdBag, effectsDict, null);
	gatherEffects(false, subBag, effectsDict, null);

	for (var home in managers)
	{
		var fx = home in effectsDict
			? effectsDict[home]
			: {
				cmds: _elm_lang$core$Native_List.Nil,
				subs: _elm_lang$core$Native_List.Nil
			};

		_elm_lang$core$Native_Scheduler.rawSend(managers[home], { ctor: 'fx', _0: fx });
	}
}

function gatherEffects(isCmd, bag, effectsDict, taggers)
{
	switch (bag.type)
	{
		case 'leaf':
			var home = bag.home;
			var effect = toEffect(isCmd, home, taggers, bag.value);
			effectsDict[home] = insert(isCmd, effect, effectsDict[home]);
			return;

		case 'node':
			var list = bag.branches;
			while (list.ctor !== '[]')
			{
				gatherEffects(isCmd, list._0, effectsDict, taggers);
				list = list._1;
			}
			return;

		case 'map':
			gatherEffects(isCmd, bag.tree, effectsDict, {
				tagger: bag.tagger,
				rest: taggers
			});
			return;
	}
}

function toEffect(isCmd, home, taggers, value)
{
	function applyTaggers(x)
	{
		var temp = taggers;
		while (temp)
		{
			x = temp.tagger(x);
			temp = temp.rest;
		}
		return x;
	}

	var map = isCmd
		? effectManagers[home].cmdMap
		: effectManagers[home].subMap;

	return A2(map, applyTaggers, value)
}

function insert(isCmd, newEffect, effects)
{
	effects = effects || {
		cmds: _elm_lang$core$Native_List.Nil,
		subs: _elm_lang$core$Native_List.Nil
	};
	if (isCmd)
	{
		effects.cmds = _elm_lang$core$Native_List.Cons(newEffect, effects.cmds);
		return effects;
	}
	effects.subs = _elm_lang$core$Native_List.Cons(newEffect, effects.subs);
	return effects;
}


// PORTS

function checkPortName(name)
{
	if (name in effectManagers)
	{
		throw new Error('There can only be one port named `' + name + '`, but your program has multiple.');
	}
}


// OUTGOING PORTS

function outgoingPort(name, converter)
{
	checkPortName(name);
	effectManagers[name] = {
		tag: 'cmd',
		cmdMap: outgoingPortMap,
		converter: converter,
		isForeign: true
	};
	return leaf(name);
}

var outgoingPortMap = F2(function cmdMap(tagger, value) {
	return value;
});

function setupOutgoingPort(name)
{
	var subs = [];
	var converter = effectManagers[name].converter;

	// CREATE MANAGER

	var init = _elm_lang$core$Native_Scheduler.succeed(null);

	function onEffects(router, cmdList, state)
	{
		while (cmdList.ctor !== '[]')
		{
			// grab a separate reference to subs in case unsubscribe is called
			var currentSubs = subs;
			var value = converter(cmdList._0);
			for (var i = 0; i < currentSubs.length; i++)
			{
				currentSubs[i](value);
			}
			cmdList = cmdList._1;
		}
		return init;
	}

	effectManagers[name].init = init;
	effectManagers[name].onEffects = F3(onEffects);

	// PUBLIC API

	function subscribe(callback)
	{
		subs.push(callback);
	}

	function unsubscribe(callback)
	{
		// copy subs into a new array in case unsubscribe is called within a
		// subscribed callback
		subs = subs.slice();
		var index = subs.indexOf(callback);
		if (index >= 0)
		{
			subs.splice(index, 1);
		}
	}

	return {
		subscribe: subscribe,
		unsubscribe: unsubscribe
	};
}


// INCOMING PORTS

function incomingPort(name, converter)
{
	checkPortName(name);
	effectManagers[name] = {
		tag: 'sub',
		subMap: incomingPortMap,
		converter: converter,
		isForeign: true
	};
	return leaf(name);
}

var incomingPortMap = F2(function subMap(tagger, finalTagger)
{
	return function(value)
	{
		return tagger(finalTagger(value));
	};
});

function setupIncomingPort(name, callback)
{
	var sentBeforeInit = [];
	var subs = _elm_lang$core$Native_List.Nil;
	var converter = effectManagers[name].converter;
	var currentOnEffects = preInitOnEffects;
	var currentSend = preInitSend;

	// CREATE MANAGER

	var init = _elm_lang$core$Native_Scheduler.succeed(null);

	function preInitOnEffects(router, subList, state)
	{
		var postInitResult = postInitOnEffects(router, subList, state);

		for(var i = 0; i < sentBeforeInit.length; i++)
		{
			postInitSend(sentBeforeInit[i]);
		}

		sentBeforeInit = null; // to release objects held in queue
		currentSend = postInitSend;
		currentOnEffects = postInitOnEffects;
		return postInitResult;
	}

	function postInitOnEffects(router, subList, state)
	{
		subs = subList;
		return init;
	}

	function onEffects(router, subList, state)
	{
		return currentOnEffects(router, subList, state);
	}

	effectManagers[name].init = init;
	effectManagers[name].onEffects = F3(onEffects);

	// PUBLIC API

	function preInitSend(value)
	{
		sentBeforeInit.push(value);
	}

	function postInitSend(incomingValue)
	{
		var result = A2(_elm_lang$core$Json_Decode$decodeValue, converter, incomingValue);
		if (result.ctor === 'Err')
		{
			throw new Error('Trying to send an unexpected type of value through port `' + name + '`:\n' + result._0);
		}

		var value = result._0;
		var temp = subs;
		while (temp.ctor !== '[]')
		{
			callback(temp._0(value));
			temp = temp._1;
		}
	}

	function send(incomingValue)
	{
		currentSend(incomingValue);
	}

	return { send: send };
}

return {
	// routers
	sendToApp: F2(sendToApp),
	sendToSelf: F2(sendToSelf),

	// global setup
	effectManagers: effectManagers,
	outgoingPort: outgoingPort,
	incomingPort: incomingPort,

	htmlToProgram: htmlToProgram,
	program: program,
	programWithFlags: programWithFlags,
	initialize: initialize,

	// effect bags
	leaf: leaf,
	batch: batch,
	map: F2(map)
};

}();

//import Native.Utils //

var _elm_lang$core$Native_Scheduler = function() {

var MAX_STEPS = 10000;


// TASKS

function succeed(value)
{
	return {
		ctor: '_Task_succeed',
		value: value
	};
}

function fail(error)
{
	return {
		ctor: '_Task_fail',
		value: error
	};
}

function nativeBinding(callback)
{
	return {
		ctor: '_Task_nativeBinding',
		callback: callback,
		cancel: null
	};
}

function andThen(callback, task)
{
	return {
		ctor: '_Task_andThen',
		callback: callback,
		task: task
	};
}

function onError(callback, task)
{
	return {
		ctor: '_Task_onError',
		callback: callback,
		task: task
	};
}

function receive(callback)
{
	return {
		ctor: '_Task_receive',
		callback: callback
	};
}


// PROCESSES

function rawSpawn(task)
{
	var process = {
		ctor: '_Process',
		id: _elm_lang$core$Native_Utils.guid(),
		root: task,
		stack: null,
		mailbox: []
	};

	enqueue(process);

	return process;
}

function spawn(task)
{
	return nativeBinding(function(callback) {
		var process = rawSpawn(task);
		callback(succeed(process));
	});
}

function rawSend(process, msg)
{
	process.mailbox.push(msg);
	enqueue(process);
}

function send(process, msg)
{
	return nativeBinding(function(callback) {
		rawSend(process, msg);
		callback(succeed(_elm_lang$core$Native_Utils.Tuple0));
	});
}

function kill(process)
{
	return nativeBinding(function(callback) {
		var root = process.root;
		if (root.ctor === '_Task_nativeBinding' && root.cancel)
		{
			root.cancel();
		}

		process.root = null;

		callback(succeed(_elm_lang$core$Native_Utils.Tuple0));
	});
}

function sleep(time)
{
	return nativeBinding(function(callback) {
		var id = setTimeout(function() {
			callback(succeed(_elm_lang$core$Native_Utils.Tuple0));
		}, time);

		return function() { clearTimeout(id); };
	});
}


// STEP PROCESSES

function step(numSteps, process)
{
	while (numSteps < MAX_STEPS)
	{
		var ctor = process.root.ctor;

		if (ctor === '_Task_succeed')
		{
			while (process.stack && process.stack.ctor === '_Task_onError')
			{
				process.stack = process.stack.rest;
			}
			if (process.stack === null)
			{
				break;
			}
			process.root = process.stack.callback(process.root.value);
			process.stack = process.stack.rest;
			++numSteps;
			continue;
		}

		if (ctor === '_Task_fail')
		{
			while (process.stack && process.stack.ctor === '_Task_andThen')
			{
				process.stack = process.stack.rest;
			}
			if (process.stack === null)
			{
				break;
			}
			process.root = process.stack.callback(process.root.value);
			process.stack = process.stack.rest;
			++numSteps;
			continue;
		}

		if (ctor === '_Task_andThen')
		{
			process.stack = {
				ctor: '_Task_andThen',
				callback: process.root.callback,
				rest: process.stack
			};
			process.root = process.root.task;
			++numSteps;
			continue;
		}

		if (ctor === '_Task_onError')
		{
			process.stack = {
				ctor: '_Task_onError',
				callback: process.root.callback,
				rest: process.stack
			};
			process.root = process.root.task;
			++numSteps;
			continue;
		}

		if (ctor === '_Task_nativeBinding')
		{
			process.root.cancel = process.root.callback(function(newRoot) {
				process.root = newRoot;
				enqueue(process);
			});

			break;
		}

		if (ctor === '_Task_receive')
		{
			var mailbox = process.mailbox;
			if (mailbox.length === 0)
			{
				break;
			}

			process.root = process.root.callback(mailbox.shift());
			++numSteps;
			continue;
		}

		throw new Error(ctor);
	}

	if (numSteps < MAX_STEPS)
	{
		return numSteps + 1;
	}
	enqueue(process);

	return numSteps;
}


// WORK QUEUE

var working = false;
var workQueue = [];

function enqueue(process)
{
	workQueue.push(process);

	if (!working)
	{
		setTimeout(work, 0);
		working = true;
	}
}

function work()
{
	var numSteps = 0;
	var process;
	while (numSteps < MAX_STEPS && (process = workQueue.shift()))
	{
		if (process.root)
		{
			numSteps = step(numSteps, process);
		}
	}
	if (!process)
	{
		working = false;
		return;
	}
	setTimeout(work, 0);
}


return {
	succeed: succeed,
	fail: fail,
	nativeBinding: nativeBinding,
	andThen: F2(andThen),
	onError: F2(onError),
	receive: receive,

	spawn: spawn,
	kill: kill,
	sleep: sleep,
	send: F2(send),

	rawSpawn: rawSpawn,
	rawSend: rawSend
};

}();
var _elm_lang$core$Platform_Cmd$batch = _elm_lang$core$Native_Platform.batch;
var _elm_lang$core$Platform_Cmd$none = _elm_lang$core$Platform_Cmd$batch(
	{ctor: '[]'});
var _elm_lang$core$Platform_Cmd_ops = _elm_lang$core$Platform_Cmd_ops || {};
_elm_lang$core$Platform_Cmd_ops['!'] = F2(
	function (model, commands) {
		return {
			ctor: '_Tuple2',
			_0: model,
			_1: _elm_lang$core$Platform_Cmd$batch(commands)
		};
	});
var _elm_lang$core$Platform_Cmd$map = _elm_lang$core$Native_Platform.map;
var _elm_lang$core$Platform_Cmd$Cmd = {ctor: 'Cmd'};

var _elm_lang$core$Platform_Sub$batch = _elm_lang$core$Native_Platform.batch;
var _elm_lang$core$Platform_Sub$none = _elm_lang$core$Platform_Sub$batch(
	{ctor: '[]'});
var _elm_lang$core$Platform_Sub$map = _elm_lang$core$Native_Platform.map;
var _elm_lang$core$Platform_Sub$Sub = {ctor: 'Sub'};

var _elm_lang$core$Platform$hack = _elm_lang$core$Native_Scheduler.succeed;
var _elm_lang$core$Platform$sendToSelf = _elm_lang$core$Native_Platform.sendToSelf;
var _elm_lang$core$Platform$sendToApp = _elm_lang$core$Native_Platform.sendToApp;
var _elm_lang$core$Platform$programWithFlags = _elm_lang$core$Native_Platform.programWithFlags;
var _elm_lang$core$Platform$program = _elm_lang$core$Native_Platform.program;
var _elm_lang$core$Platform$Program = {ctor: 'Program'};
var _elm_lang$core$Platform$Task = {ctor: 'Task'};
var _elm_lang$core$Platform$ProcessId = {ctor: 'ProcessId'};
var _elm_lang$core$Platform$Router = {ctor: 'Router'};

var _elm_community$elm_test$Test_Expectation$Fail = F2(
	function (a, b) {
		return {ctor: 'Fail', _0: a, _1: b};
	});
var _elm_community$elm_test$Test_Expectation$withGiven = F2(
	function (given, outcome) {
		var _p0 = outcome;
		if (_p0.ctor === 'Fail') {
			return A2(_elm_community$elm_test$Test_Expectation$Fail, given, _p0._1);
		} else {
			return outcome;
		}
	});
var _elm_community$elm_test$Test_Expectation$Pass = {ctor: 'Pass'};

var _elm_lang$core$Dict$foldr = F3(
	function (f, acc, t) {
		foldr:
		while (true) {
			var _p0 = t;
			if (_p0.ctor === 'RBEmpty_elm_builtin') {
				return acc;
			} else {
				var _v1 = f,
					_v2 = A3(
					f,
					_p0._1,
					_p0._2,
					A3(_elm_lang$core$Dict$foldr, f, acc, _p0._4)),
					_v3 = _p0._3;
				f = _v1;
				acc = _v2;
				t = _v3;
				continue foldr;
			}
		}
	});
var _elm_lang$core$Dict$keys = function (dict) {
	return A3(
		_elm_lang$core$Dict$foldr,
		F3(
			function (key, value, keyList) {
				return {ctor: '::', _0: key, _1: keyList};
			}),
		{ctor: '[]'},
		dict);
};
var _elm_lang$core$Dict$values = function (dict) {
	return A3(
		_elm_lang$core$Dict$foldr,
		F3(
			function (key, value, valueList) {
				return {ctor: '::', _0: value, _1: valueList};
			}),
		{ctor: '[]'},
		dict);
};
var _elm_lang$core$Dict$toList = function (dict) {
	return A3(
		_elm_lang$core$Dict$foldr,
		F3(
			function (key, value, list) {
				return {
					ctor: '::',
					_0: {ctor: '_Tuple2', _0: key, _1: value},
					_1: list
				};
			}),
		{ctor: '[]'},
		dict);
};
var _elm_lang$core$Dict$foldl = F3(
	function (f, acc, dict) {
		foldl:
		while (true) {
			var _p1 = dict;
			if (_p1.ctor === 'RBEmpty_elm_builtin') {
				return acc;
			} else {
				var _v5 = f,
					_v6 = A3(
					f,
					_p1._1,
					_p1._2,
					A3(_elm_lang$core$Dict$foldl, f, acc, _p1._3)),
					_v7 = _p1._4;
				f = _v5;
				acc = _v6;
				dict = _v7;
				continue foldl;
			}
		}
	});
var _elm_lang$core$Dict$merge = F6(
	function (leftStep, bothStep, rightStep, leftDict, rightDict, initialResult) {
		var stepState = F3(
			function (rKey, rValue, _p2) {
				stepState:
				while (true) {
					var _p3 = _p2;
					var _p9 = _p3._1;
					var _p8 = _p3._0;
					var _p4 = _p8;
					if (_p4.ctor === '[]') {
						return {
							ctor: '_Tuple2',
							_0: _p8,
							_1: A3(rightStep, rKey, rValue, _p9)
						};
					} else {
						var _p7 = _p4._1;
						var _p6 = _p4._0._1;
						var _p5 = _p4._0._0;
						if (_elm_lang$core$Native_Utils.cmp(_p5, rKey) < 0) {
							var _v10 = rKey,
								_v11 = rValue,
								_v12 = {
								ctor: '_Tuple2',
								_0: _p7,
								_1: A3(leftStep, _p5, _p6, _p9)
							};
							rKey = _v10;
							rValue = _v11;
							_p2 = _v12;
							continue stepState;
						} else {
							if (_elm_lang$core$Native_Utils.cmp(_p5, rKey) > 0) {
								return {
									ctor: '_Tuple2',
									_0: _p8,
									_1: A3(rightStep, rKey, rValue, _p9)
								};
							} else {
								return {
									ctor: '_Tuple2',
									_0: _p7,
									_1: A4(bothStep, _p5, _p6, rValue, _p9)
								};
							}
						}
					}
				}
			});
		var _p10 = A3(
			_elm_lang$core$Dict$foldl,
			stepState,
			{
				ctor: '_Tuple2',
				_0: _elm_lang$core$Dict$toList(leftDict),
				_1: initialResult
			},
			rightDict);
		var leftovers = _p10._0;
		var intermediateResult = _p10._1;
		return A3(
			_elm_lang$core$List$foldl,
			F2(
				function (_p11, result) {
					var _p12 = _p11;
					return A3(leftStep, _p12._0, _p12._1, result);
				}),
			intermediateResult,
			leftovers);
	});
var _elm_lang$core$Dict$reportRemBug = F4(
	function (msg, c, lgot, rgot) {
		return _elm_lang$core$Native_Debug.crash(
			_elm_lang$core$String$concat(
				{
					ctor: '::',
					_0: 'Internal red-black tree invariant violated, expected ',
					_1: {
						ctor: '::',
						_0: msg,
						_1: {
							ctor: '::',
							_0: ' and got ',
							_1: {
								ctor: '::',
								_0: _elm_lang$core$Basics$toString(c),
								_1: {
									ctor: '::',
									_0: '/',
									_1: {
										ctor: '::',
										_0: lgot,
										_1: {
											ctor: '::',
											_0: '/',
											_1: {
												ctor: '::',
												_0: rgot,
												_1: {
													ctor: '::',
													_0: '\nPlease report this bug to <https://github.com/elm-lang/core/issues>',
													_1: {ctor: '[]'}
												}
											}
										}
									}
								}
							}
						}
					}
				}));
	});
var _elm_lang$core$Dict$isBBlack = function (dict) {
	var _p13 = dict;
	_v14_2:
	do {
		if (_p13.ctor === 'RBNode_elm_builtin') {
			if (_p13._0.ctor === 'BBlack') {
				return true;
			} else {
				break _v14_2;
			}
		} else {
			if (_p13._0.ctor === 'LBBlack') {
				return true;
			} else {
				break _v14_2;
			}
		}
	} while(false);
	return false;
};
var _elm_lang$core$Dict$sizeHelp = F2(
	function (n, dict) {
		sizeHelp:
		while (true) {
			var _p14 = dict;
			if (_p14.ctor === 'RBEmpty_elm_builtin') {
				return n;
			} else {
				var _v16 = A2(_elm_lang$core$Dict$sizeHelp, n + 1, _p14._4),
					_v17 = _p14._3;
				n = _v16;
				dict = _v17;
				continue sizeHelp;
			}
		}
	});
var _elm_lang$core$Dict$size = function (dict) {
	return A2(_elm_lang$core$Dict$sizeHelp, 0, dict);
};
var _elm_lang$core$Dict$get = F2(
	function (targetKey, dict) {
		get:
		while (true) {
			var _p15 = dict;
			if (_p15.ctor === 'RBEmpty_elm_builtin') {
				return _elm_lang$core$Maybe$Nothing;
			} else {
				var _p16 = A2(_elm_lang$core$Basics$compare, targetKey, _p15._1);
				switch (_p16.ctor) {
					case 'LT':
						var _v20 = targetKey,
							_v21 = _p15._3;
						targetKey = _v20;
						dict = _v21;
						continue get;
					case 'EQ':
						return _elm_lang$core$Maybe$Just(_p15._2);
					default:
						var _v22 = targetKey,
							_v23 = _p15._4;
						targetKey = _v22;
						dict = _v23;
						continue get;
				}
			}
		}
	});
var _elm_lang$core$Dict$member = F2(
	function (key, dict) {
		var _p17 = A2(_elm_lang$core$Dict$get, key, dict);
		if (_p17.ctor === 'Just') {
			return true;
		} else {
			return false;
		}
	});
var _elm_lang$core$Dict$maxWithDefault = F3(
	function (k, v, r) {
		maxWithDefault:
		while (true) {
			var _p18 = r;
			if (_p18.ctor === 'RBEmpty_elm_builtin') {
				return {ctor: '_Tuple2', _0: k, _1: v};
			} else {
				var _v26 = _p18._1,
					_v27 = _p18._2,
					_v28 = _p18._4;
				k = _v26;
				v = _v27;
				r = _v28;
				continue maxWithDefault;
			}
		}
	});
var _elm_lang$core$Dict$NBlack = {ctor: 'NBlack'};
var _elm_lang$core$Dict$BBlack = {ctor: 'BBlack'};
var _elm_lang$core$Dict$Black = {ctor: 'Black'};
var _elm_lang$core$Dict$blackish = function (t) {
	var _p19 = t;
	if (_p19.ctor === 'RBNode_elm_builtin') {
		var _p20 = _p19._0;
		return _elm_lang$core$Native_Utils.eq(_p20, _elm_lang$core$Dict$Black) || _elm_lang$core$Native_Utils.eq(_p20, _elm_lang$core$Dict$BBlack);
	} else {
		return true;
	}
};
var _elm_lang$core$Dict$Red = {ctor: 'Red'};
var _elm_lang$core$Dict$moreBlack = function (color) {
	var _p21 = color;
	switch (_p21.ctor) {
		case 'Black':
			return _elm_lang$core$Dict$BBlack;
		case 'Red':
			return _elm_lang$core$Dict$Black;
		case 'NBlack':
			return _elm_lang$core$Dict$Red;
		default:
			return _elm_lang$core$Native_Debug.crash('Can\'t make a double black node more black!');
	}
};
var _elm_lang$core$Dict$lessBlack = function (color) {
	var _p22 = color;
	switch (_p22.ctor) {
		case 'BBlack':
			return _elm_lang$core$Dict$Black;
		case 'Black':
			return _elm_lang$core$Dict$Red;
		case 'Red':
			return _elm_lang$core$Dict$NBlack;
		default:
			return _elm_lang$core$Native_Debug.crash('Can\'t make a negative black node less black!');
	}
};
var _elm_lang$core$Dict$LBBlack = {ctor: 'LBBlack'};
var _elm_lang$core$Dict$LBlack = {ctor: 'LBlack'};
var _elm_lang$core$Dict$RBEmpty_elm_builtin = function (a) {
	return {ctor: 'RBEmpty_elm_builtin', _0: a};
};
var _elm_lang$core$Dict$empty = _elm_lang$core$Dict$RBEmpty_elm_builtin(_elm_lang$core$Dict$LBlack);
var _elm_lang$core$Dict$isEmpty = function (dict) {
	return _elm_lang$core$Native_Utils.eq(dict, _elm_lang$core$Dict$empty);
};
var _elm_lang$core$Dict$RBNode_elm_builtin = F5(
	function (a, b, c, d, e) {
		return {ctor: 'RBNode_elm_builtin', _0: a, _1: b, _2: c, _3: d, _4: e};
	});
var _elm_lang$core$Dict$ensureBlackRoot = function (dict) {
	var _p23 = dict;
	if ((_p23.ctor === 'RBNode_elm_builtin') && (_p23._0.ctor === 'Red')) {
		return A5(_elm_lang$core$Dict$RBNode_elm_builtin, _elm_lang$core$Dict$Black, _p23._1, _p23._2, _p23._3, _p23._4);
	} else {
		return dict;
	}
};
var _elm_lang$core$Dict$lessBlackTree = function (dict) {
	var _p24 = dict;
	if (_p24.ctor === 'RBNode_elm_builtin') {
		return A5(
			_elm_lang$core$Dict$RBNode_elm_builtin,
			_elm_lang$core$Dict$lessBlack(_p24._0),
			_p24._1,
			_p24._2,
			_p24._3,
			_p24._4);
	} else {
		return _elm_lang$core$Dict$RBEmpty_elm_builtin(_elm_lang$core$Dict$LBlack);
	}
};
var _elm_lang$core$Dict$balancedTree = function (col) {
	return function (xk) {
		return function (xv) {
			return function (yk) {
				return function (yv) {
					return function (zk) {
						return function (zv) {
							return function (a) {
								return function (b) {
									return function (c) {
										return function (d) {
											return A5(
												_elm_lang$core$Dict$RBNode_elm_builtin,
												_elm_lang$core$Dict$lessBlack(col),
												yk,
												yv,
												A5(_elm_lang$core$Dict$RBNode_elm_builtin, _elm_lang$core$Dict$Black, xk, xv, a, b),
												A5(_elm_lang$core$Dict$RBNode_elm_builtin, _elm_lang$core$Dict$Black, zk, zv, c, d));
										};
									};
								};
							};
						};
					};
				};
			};
		};
	};
};
var _elm_lang$core$Dict$blacken = function (t) {
	var _p25 = t;
	if (_p25.ctor === 'RBEmpty_elm_builtin') {
		return _elm_lang$core$Dict$RBEmpty_elm_builtin(_elm_lang$core$Dict$LBlack);
	} else {
		return A5(_elm_lang$core$Dict$RBNode_elm_builtin, _elm_lang$core$Dict$Black, _p25._1, _p25._2, _p25._3, _p25._4);
	}
};
var _elm_lang$core$Dict$redden = function (t) {
	var _p26 = t;
	if (_p26.ctor === 'RBEmpty_elm_builtin') {
		return _elm_lang$core$Native_Debug.crash('can\'t make a Leaf red');
	} else {
		return A5(_elm_lang$core$Dict$RBNode_elm_builtin, _elm_lang$core$Dict$Red, _p26._1, _p26._2, _p26._3, _p26._4);
	}
};
var _elm_lang$core$Dict$balanceHelp = function (tree) {
	var _p27 = tree;
	_v36_6:
	do {
		_v36_5:
		do {
			_v36_4:
			do {
				_v36_3:
				do {
					_v36_2:
					do {
						_v36_1:
						do {
							_v36_0:
							do {
								if (_p27.ctor === 'RBNode_elm_builtin') {
									if (_p27._3.ctor === 'RBNode_elm_builtin') {
										if (_p27._4.ctor === 'RBNode_elm_builtin') {
											switch (_p27._3._0.ctor) {
												case 'Red':
													switch (_p27._4._0.ctor) {
														case 'Red':
															if ((_p27._3._3.ctor === 'RBNode_elm_builtin') && (_p27._3._3._0.ctor === 'Red')) {
																break _v36_0;
															} else {
																if ((_p27._3._4.ctor === 'RBNode_elm_builtin') && (_p27._3._4._0.ctor === 'Red')) {
																	break _v36_1;
																} else {
																	if ((_p27._4._3.ctor === 'RBNode_elm_builtin') && (_p27._4._3._0.ctor === 'Red')) {
																		break _v36_2;
																	} else {
																		if ((_p27._4._4.ctor === 'RBNode_elm_builtin') && (_p27._4._4._0.ctor === 'Red')) {
																			break _v36_3;
																		} else {
																			break _v36_6;
																		}
																	}
																}
															}
														case 'NBlack':
															if ((_p27._3._3.ctor === 'RBNode_elm_builtin') && (_p27._3._3._0.ctor === 'Red')) {
																break _v36_0;
															} else {
																if ((_p27._3._4.ctor === 'RBNode_elm_builtin') && (_p27._3._4._0.ctor === 'Red')) {
																	break _v36_1;
																} else {
																	if (((((_p27._0.ctor === 'BBlack') && (_p27._4._3.ctor === 'RBNode_elm_builtin')) && (_p27._4._3._0.ctor === 'Black')) && (_p27._4._4.ctor === 'RBNode_elm_builtin')) && (_p27._4._4._0.ctor === 'Black')) {
																		break _v36_4;
																	} else {
																		break _v36_6;
																	}
																}
															}
														default:
															if ((_p27._3._3.ctor === 'RBNode_elm_builtin') && (_p27._3._3._0.ctor === 'Red')) {
																break _v36_0;
															} else {
																if ((_p27._3._4.ctor === 'RBNode_elm_builtin') && (_p27._3._4._0.ctor === 'Red')) {
																	break _v36_1;
																} else {
																	break _v36_6;
																}
															}
													}
												case 'NBlack':
													switch (_p27._4._0.ctor) {
														case 'Red':
															if ((_p27._4._3.ctor === 'RBNode_elm_builtin') && (_p27._4._3._0.ctor === 'Red')) {
																break _v36_2;
															} else {
																if ((_p27._4._4.ctor === 'RBNode_elm_builtin') && (_p27._4._4._0.ctor === 'Red')) {
																	break _v36_3;
																} else {
																	if (((((_p27._0.ctor === 'BBlack') && (_p27._3._3.ctor === 'RBNode_elm_builtin')) && (_p27._3._3._0.ctor === 'Black')) && (_p27._3._4.ctor === 'RBNode_elm_builtin')) && (_p27._3._4._0.ctor === 'Black')) {
																		break _v36_5;
																	} else {
																		break _v36_6;
																	}
																}
															}
														case 'NBlack':
															if (_p27._0.ctor === 'BBlack') {
																if ((((_p27._4._3.ctor === 'RBNode_elm_builtin') && (_p27._4._3._0.ctor === 'Black')) && (_p27._4._4.ctor === 'RBNode_elm_builtin')) && (_p27._4._4._0.ctor === 'Black')) {
																	break _v36_4;
																} else {
																	if ((((_p27._3._3.ctor === 'RBNode_elm_builtin') && (_p27._3._3._0.ctor === 'Black')) && (_p27._3._4.ctor === 'RBNode_elm_builtin')) && (_p27._3._4._0.ctor === 'Black')) {
																		break _v36_5;
																	} else {
																		break _v36_6;
																	}
																}
															} else {
																break _v36_6;
															}
														default:
															if (((((_p27._0.ctor === 'BBlack') && (_p27._3._3.ctor === 'RBNode_elm_builtin')) && (_p27._3._3._0.ctor === 'Black')) && (_p27._3._4.ctor === 'RBNode_elm_builtin')) && (_p27._3._4._0.ctor === 'Black')) {
																break _v36_5;
															} else {
																break _v36_6;
															}
													}
												default:
													switch (_p27._4._0.ctor) {
														case 'Red':
															if ((_p27._4._3.ctor === 'RBNode_elm_builtin') && (_p27._4._3._0.ctor === 'Red')) {
																break _v36_2;
															} else {
																if ((_p27._4._4.ctor === 'RBNode_elm_builtin') && (_p27._4._4._0.ctor === 'Red')) {
																	break _v36_3;
																} else {
																	break _v36_6;
																}
															}
														case 'NBlack':
															if (((((_p27._0.ctor === 'BBlack') && (_p27._4._3.ctor === 'RBNode_elm_builtin')) && (_p27._4._3._0.ctor === 'Black')) && (_p27._4._4.ctor === 'RBNode_elm_builtin')) && (_p27._4._4._0.ctor === 'Black')) {
																break _v36_4;
															} else {
																break _v36_6;
															}
														default:
															break _v36_6;
													}
											}
										} else {
											switch (_p27._3._0.ctor) {
												case 'Red':
													if ((_p27._3._3.ctor === 'RBNode_elm_builtin') && (_p27._3._3._0.ctor === 'Red')) {
														break _v36_0;
													} else {
														if ((_p27._3._4.ctor === 'RBNode_elm_builtin') && (_p27._3._4._0.ctor === 'Red')) {
															break _v36_1;
														} else {
															break _v36_6;
														}
													}
												case 'NBlack':
													if (((((_p27._0.ctor === 'BBlack') && (_p27._3._3.ctor === 'RBNode_elm_builtin')) && (_p27._3._3._0.ctor === 'Black')) && (_p27._3._4.ctor === 'RBNode_elm_builtin')) && (_p27._3._4._0.ctor === 'Black')) {
														break _v36_5;
													} else {
														break _v36_6;
													}
												default:
													break _v36_6;
											}
										}
									} else {
										if (_p27._4.ctor === 'RBNode_elm_builtin') {
											switch (_p27._4._0.ctor) {
												case 'Red':
													if ((_p27._4._3.ctor === 'RBNode_elm_builtin') && (_p27._4._3._0.ctor === 'Red')) {
														break _v36_2;
													} else {
														if ((_p27._4._4.ctor === 'RBNode_elm_builtin') && (_p27._4._4._0.ctor === 'Red')) {
															break _v36_3;
														} else {
															break _v36_6;
														}
													}
												case 'NBlack':
													if (((((_p27._0.ctor === 'BBlack') && (_p27._4._3.ctor === 'RBNode_elm_builtin')) && (_p27._4._3._0.ctor === 'Black')) && (_p27._4._4.ctor === 'RBNode_elm_builtin')) && (_p27._4._4._0.ctor === 'Black')) {
														break _v36_4;
													} else {
														break _v36_6;
													}
												default:
													break _v36_6;
											}
										} else {
											break _v36_6;
										}
									}
								} else {
									break _v36_6;
								}
							} while(false);
							return _elm_lang$core$Dict$balancedTree(_p27._0)(_p27._3._3._1)(_p27._3._3._2)(_p27._3._1)(_p27._3._2)(_p27._1)(_p27._2)(_p27._3._3._3)(_p27._3._3._4)(_p27._3._4)(_p27._4);
						} while(false);
						return _elm_lang$core$Dict$balancedTree(_p27._0)(_p27._3._1)(_p27._3._2)(_p27._3._4._1)(_p27._3._4._2)(_p27._1)(_p27._2)(_p27._3._3)(_p27._3._4._3)(_p27._3._4._4)(_p27._4);
					} while(false);
					return _elm_lang$core$Dict$balancedTree(_p27._0)(_p27._1)(_p27._2)(_p27._4._3._1)(_p27._4._3._2)(_p27._4._1)(_p27._4._2)(_p27._3)(_p27._4._3._3)(_p27._4._3._4)(_p27._4._4);
				} while(false);
				return _elm_lang$core$Dict$balancedTree(_p27._0)(_p27._1)(_p27._2)(_p27._4._1)(_p27._4._2)(_p27._4._4._1)(_p27._4._4._2)(_p27._3)(_p27._4._3)(_p27._4._4._3)(_p27._4._4._4);
			} while(false);
			return A5(
				_elm_lang$core$Dict$RBNode_elm_builtin,
				_elm_lang$core$Dict$Black,
				_p27._4._3._1,
				_p27._4._3._2,
				A5(_elm_lang$core$Dict$RBNode_elm_builtin, _elm_lang$core$Dict$Black, _p27._1, _p27._2, _p27._3, _p27._4._3._3),
				A5(
					_elm_lang$core$Dict$balance,
					_elm_lang$core$Dict$Black,
					_p27._4._1,
					_p27._4._2,
					_p27._4._3._4,
					_elm_lang$core$Dict$redden(_p27._4._4)));
		} while(false);
		return A5(
			_elm_lang$core$Dict$RBNode_elm_builtin,
			_elm_lang$core$Dict$Black,
			_p27._3._4._1,
			_p27._3._4._2,
			A5(
				_elm_lang$core$Dict$balance,
				_elm_lang$core$Dict$Black,
				_p27._3._1,
				_p27._3._2,
				_elm_lang$core$Dict$redden(_p27._3._3),
				_p27._3._4._3),
			A5(_elm_lang$core$Dict$RBNode_elm_builtin, _elm_lang$core$Dict$Black, _p27._1, _p27._2, _p27._3._4._4, _p27._4));
	} while(false);
	return tree;
};
var _elm_lang$core$Dict$balance = F5(
	function (c, k, v, l, r) {
		var tree = A5(_elm_lang$core$Dict$RBNode_elm_builtin, c, k, v, l, r);
		return _elm_lang$core$Dict$blackish(tree) ? _elm_lang$core$Dict$balanceHelp(tree) : tree;
	});
var _elm_lang$core$Dict$bubble = F5(
	function (c, k, v, l, r) {
		return (_elm_lang$core$Dict$isBBlack(l) || _elm_lang$core$Dict$isBBlack(r)) ? A5(
			_elm_lang$core$Dict$balance,
			_elm_lang$core$Dict$moreBlack(c),
			k,
			v,
			_elm_lang$core$Dict$lessBlackTree(l),
			_elm_lang$core$Dict$lessBlackTree(r)) : A5(_elm_lang$core$Dict$RBNode_elm_builtin, c, k, v, l, r);
	});
var _elm_lang$core$Dict$removeMax = F5(
	function (c, k, v, l, r) {
		var _p28 = r;
		if (_p28.ctor === 'RBEmpty_elm_builtin') {
			return A3(_elm_lang$core$Dict$rem, c, l, r);
		} else {
			return A5(
				_elm_lang$core$Dict$bubble,
				c,
				k,
				v,
				l,
				A5(_elm_lang$core$Dict$removeMax, _p28._0, _p28._1, _p28._2, _p28._3, _p28._4));
		}
	});
var _elm_lang$core$Dict$rem = F3(
	function (color, left, right) {
		var _p29 = {ctor: '_Tuple2', _0: left, _1: right};
		if (_p29._0.ctor === 'RBEmpty_elm_builtin') {
			if (_p29._1.ctor === 'RBEmpty_elm_builtin') {
				var _p30 = color;
				switch (_p30.ctor) {
					case 'Red':
						return _elm_lang$core$Dict$RBEmpty_elm_builtin(_elm_lang$core$Dict$LBlack);
					case 'Black':
						return _elm_lang$core$Dict$RBEmpty_elm_builtin(_elm_lang$core$Dict$LBBlack);
					default:
						return _elm_lang$core$Native_Debug.crash('cannot have bblack or nblack nodes at this point');
				}
			} else {
				var _p33 = _p29._1._0;
				var _p32 = _p29._0._0;
				var _p31 = {ctor: '_Tuple3', _0: color, _1: _p32, _2: _p33};
				if ((((_p31.ctor === '_Tuple3') && (_p31._0.ctor === 'Black')) && (_p31._1.ctor === 'LBlack')) && (_p31._2.ctor === 'Red')) {
					return A5(_elm_lang$core$Dict$RBNode_elm_builtin, _elm_lang$core$Dict$Black, _p29._1._1, _p29._1._2, _p29._1._3, _p29._1._4);
				} else {
					return A4(
						_elm_lang$core$Dict$reportRemBug,
						'Black/LBlack/Red',
						color,
						_elm_lang$core$Basics$toString(_p32),
						_elm_lang$core$Basics$toString(_p33));
				}
			}
		} else {
			if (_p29._1.ctor === 'RBEmpty_elm_builtin') {
				var _p36 = _p29._1._0;
				var _p35 = _p29._0._0;
				var _p34 = {ctor: '_Tuple3', _0: color, _1: _p35, _2: _p36};
				if ((((_p34.ctor === '_Tuple3') && (_p34._0.ctor === 'Black')) && (_p34._1.ctor === 'Red')) && (_p34._2.ctor === 'LBlack')) {
					return A5(_elm_lang$core$Dict$RBNode_elm_builtin, _elm_lang$core$Dict$Black, _p29._0._1, _p29._0._2, _p29._0._3, _p29._0._4);
				} else {
					return A4(
						_elm_lang$core$Dict$reportRemBug,
						'Black/Red/LBlack',
						color,
						_elm_lang$core$Basics$toString(_p35),
						_elm_lang$core$Basics$toString(_p36));
				}
			} else {
				var _p40 = _p29._0._2;
				var _p39 = _p29._0._4;
				var _p38 = _p29._0._1;
				var newLeft = A5(_elm_lang$core$Dict$removeMax, _p29._0._0, _p38, _p40, _p29._0._3, _p39);
				var _p37 = A3(_elm_lang$core$Dict$maxWithDefault, _p38, _p40, _p39);
				var k = _p37._0;
				var v = _p37._1;
				return A5(_elm_lang$core$Dict$bubble, color, k, v, newLeft, right);
			}
		}
	});
var _elm_lang$core$Dict$map = F2(
	function (f, dict) {
		var _p41 = dict;
		if (_p41.ctor === 'RBEmpty_elm_builtin') {
			return _elm_lang$core$Dict$RBEmpty_elm_builtin(_elm_lang$core$Dict$LBlack);
		} else {
			var _p42 = _p41._1;
			return A5(
				_elm_lang$core$Dict$RBNode_elm_builtin,
				_p41._0,
				_p42,
				A2(f, _p42, _p41._2),
				A2(_elm_lang$core$Dict$map, f, _p41._3),
				A2(_elm_lang$core$Dict$map, f, _p41._4));
		}
	});
var _elm_lang$core$Dict$Same = {ctor: 'Same'};
var _elm_lang$core$Dict$Remove = {ctor: 'Remove'};
var _elm_lang$core$Dict$Insert = {ctor: 'Insert'};
var _elm_lang$core$Dict$update = F3(
	function (k, alter, dict) {
		var up = function (dict) {
			var _p43 = dict;
			if (_p43.ctor === 'RBEmpty_elm_builtin') {
				var _p44 = alter(_elm_lang$core$Maybe$Nothing);
				if (_p44.ctor === 'Nothing') {
					return {ctor: '_Tuple2', _0: _elm_lang$core$Dict$Same, _1: _elm_lang$core$Dict$empty};
				} else {
					return {
						ctor: '_Tuple2',
						_0: _elm_lang$core$Dict$Insert,
						_1: A5(_elm_lang$core$Dict$RBNode_elm_builtin, _elm_lang$core$Dict$Red, k, _p44._0, _elm_lang$core$Dict$empty, _elm_lang$core$Dict$empty)
					};
				}
			} else {
				var _p55 = _p43._2;
				var _p54 = _p43._4;
				var _p53 = _p43._3;
				var _p52 = _p43._1;
				var _p51 = _p43._0;
				var _p45 = A2(_elm_lang$core$Basics$compare, k, _p52);
				switch (_p45.ctor) {
					case 'EQ':
						var _p46 = alter(
							_elm_lang$core$Maybe$Just(_p55));
						if (_p46.ctor === 'Nothing') {
							return {
								ctor: '_Tuple2',
								_0: _elm_lang$core$Dict$Remove,
								_1: A3(_elm_lang$core$Dict$rem, _p51, _p53, _p54)
							};
						} else {
							return {
								ctor: '_Tuple2',
								_0: _elm_lang$core$Dict$Same,
								_1: A5(_elm_lang$core$Dict$RBNode_elm_builtin, _p51, _p52, _p46._0, _p53, _p54)
							};
						}
					case 'LT':
						var _p47 = up(_p53);
						var flag = _p47._0;
						var newLeft = _p47._1;
						var _p48 = flag;
						switch (_p48.ctor) {
							case 'Same':
								return {
									ctor: '_Tuple2',
									_0: _elm_lang$core$Dict$Same,
									_1: A5(_elm_lang$core$Dict$RBNode_elm_builtin, _p51, _p52, _p55, newLeft, _p54)
								};
							case 'Insert':
								return {
									ctor: '_Tuple2',
									_0: _elm_lang$core$Dict$Insert,
									_1: A5(_elm_lang$core$Dict$balance, _p51, _p52, _p55, newLeft, _p54)
								};
							default:
								return {
									ctor: '_Tuple2',
									_0: _elm_lang$core$Dict$Remove,
									_1: A5(_elm_lang$core$Dict$bubble, _p51, _p52, _p55, newLeft, _p54)
								};
						}
					default:
						var _p49 = up(_p54);
						var flag = _p49._0;
						var newRight = _p49._1;
						var _p50 = flag;
						switch (_p50.ctor) {
							case 'Same':
								return {
									ctor: '_Tuple2',
									_0: _elm_lang$core$Dict$Same,
									_1: A5(_elm_lang$core$Dict$RBNode_elm_builtin, _p51, _p52, _p55, _p53, newRight)
								};
							case 'Insert':
								return {
									ctor: '_Tuple2',
									_0: _elm_lang$core$Dict$Insert,
									_1: A5(_elm_lang$core$Dict$balance, _p51, _p52, _p55, _p53, newRight)
								};
							default:
								return {
									ctor: '_Tuple2',
									_0: _elm_lang$core$Dict$Remove,
									_1: A5(_elm_lang$core$Dict$bubble, _p51, _p52, _p55, _p53, newRight)
								};
						}
				}
			}
		};
		var _p56 = up(dict);
		var flag = _p56._0;
		var updatedDict = _p56._1;
		var _p57 = flag;
		switch (_p57.ctor) {
			case 'Same':
				return updatedDict;
			case 'Insert':
				return _elm_lang$core$Dict$ensureBlackRoot(updatedDict);
			default:
				return _elm_lang$core$Dict$blacken(updatedDict);
		}
	});
var _elm_lang$core$Dict$insert = F3(
	function (key, value, dict) {
		return A3(
			_elm_lang$core$Dict$update,
			key,
			_elm_lang$core$Basics$always(
				_elm_lang$core$Maybe$Just(value)),
			dict);
	});
var _elm_lang$core$Dict$singleton = F2(
	function (key, value) {
		return A3(_elm_lang$core$Dict$insert, key, value, _elm_lang$core$Dict$empty);
	});
var _elm_lang$core$Dict$union = F2(
	function (t1, t2) {
		return A3(_elm_lang$core$Dict$foldl, _elm_lang$core$Dict$insert, t2, t1);
	});
var _elm_lang$core$Dict$filter = F2(
	function (predicate, dictionary) {
		var add = F3(
			function (key, value, dict) {
				return A2(predicate, key, value) ? A3(_elm_lang$core$Dict$insert, key, value, dict) : dict;
			});
		return A3(_elm_lang$core$Dict$foldl, add, _elm_lang$core$Dict$empty, dictionary);
	});
var _elm_lang$core$Dict$intersect = F2(
	function (t1, t2) {
		return A2(
			_elm_lang$core$Dict$filter,
			F2(
				function (k, _p58) {
					return A2(_elm_lang$core$Dict$member, k, t2);
				}),
			t1);
	});
var _elm_lang$core$Dict$partition = F2(
	function (predicate, dict) {
		var add = F3(
			function (key, value, _p59) {
				var _p60 = _p59;
				var _p62 = _p60._1;
				var _p61 = _p60._0;
				return A2(predicate, key, value) ? {
					ctor: '_Tuple2',
					_0: A3(_elm_lang$core$Dict$insert, key, value, _p61),
					_1: _p62
				} : {
					ctor: '_Tuple2',
					_0: _p61,
					_1: A3(_elm_lang$core$Dict$insert, key, value, _p62)
				};
			});
		return A3(
			_elm_lang$core$Dict$foldl,
			add,
			{ctor: '_Tuple2', _0: _elm_lang$core$Dict$empty, _1: _elm_lang$core$Dict$empty},
			dict);
	});
var _elm_lang$core$Dict$fromList = function (assocs) {
	return A3(
		_elm_lang$core$List$foldl,
		F2(
			function (_p63, dict) {
				var _p64 = _p63;
				return A3(_elm_lang$core$Dict$insert, _p64._0, _p64._1, dict);
			}),
		_elm_lang$core$Dict$empty,
		assocs);
};
var _elm_lang$core$Dict$remove = F2(
	function (key, dict) {
		return A3(
			_elm_lang$core$Dict$update,
			key,
			_elm_lang$core$Basics$always(_elm_lang$core$Maybe$Nothing),
			dict);
	});
var _elm_lang$core$Dict$diff = F2(
	function (t1, t2) {
		return A3(
			_elm_lang$core$Dict$foldl,
			F3(
				function (k, v, t) {
					return A2(_elm_lang$core$Dict$remove, k, t);
				}),
			t1,
			t2);
	});

var _elm_lang$core$Set$foldr = F3(
	function (f, b, _p0) {
		var _p1 = _p0;
		return A3(
			_elm_lang$core$Dict$foldr,
			F3(
				function (k, _p2, b) {
					return A2(f, k, b);
				}),
			b,
			_p1._0);
	});
var _elm_lang$core$Set$foldl = F3(
	function (f, b, _p3) {
		var _p4 = _p3;
		return A3(
			_elm_lang$core$Dict$foldl,
			F3(
				function (k, _p5, b) {
					return A2(f, k, b);
				}),
			b,
			_p4._0);
	});
var _elm_lang$core$Set$toList = function (_p6) {
	var _p7 = _p6;
	return _elm_lang$core$Dict$keys(_p7._0);
};
var _elm_lang$core$Set$size = function (_p8) {
	var _p9 = _p8;
	return _elm_lang$core$Dict$size(_p9._0);
};
var _elm_lang$core$Set$member = F2(
	function (k, _p10) {
		var _p11 = _p10;
		return A2(_elm_lang$core$Dict$member, k, _p11._0);
	});
var _elm_lang$core$Set$isEmpty = function (_p12) {
	var _p13 = _p12;
	return _elm_lang$core$Dict$isEmpty(_p13._0);
};
var _elm_lang$core$Set$Set_elm_builtin = function (a) {
	return {ctor: 'Set_elm_builtin', _0: a};
};
var _elm_lang$core$Set$empty = _elm_lang$core$Set$Set_elm_builtin(_elm_lang$core$Dict$empty);
var _elm_lang$core$Set$singleton = function (k) {
	return _elm_lang$core$Set$Set_elm_builtin(
		A2(
			_elm_lang$core$Dict$singleton,
			k,
			{ctor: '_Tuple0'}));
};
var _elm_lang$core$Set$insert = F2(
	function (k, _p14) {
		var _p15 = _p14;
		return _elm_lang$core$Set$Set_elm_builtin(
			A3(
				_elm_lang$core$Dict$insert,
				k,
				{ctor: '_Tuple0'},
				_p15._0));
	});
var _elm_lang$core$Set$fromList = function (xs) {
	return A3(_elm_lang$core$List$foldl, _elm_lang$core$Set$insert, _elm_lang$core$Set$empty, xs);
};
var _elm_lang$core$Set$map = F2(
	function (f, s) {
		return _elm_lang$core$Set$fromList(
			A2(
				_elm_lang$core$List$map,
				f,
				_elm_lang$core$Set$toList(s)));
	});
var _elm_lang$core$Set$remove = F2(
	function (k, _p16) {
		var _p17 = _p16;
		return _elm_lang$core$Set$Set_elm_builtin(
			A2(_elm_lang$core$Dict$remove, k, _p17._0));
	});
var _elm_lang$core$Set$union = F2(
	function (_p19, _p18) {
		var _p20 = _p19;
		var _p21 = _p18;
		return _elm_lang$core$Set$Set_elm_builtin(
			A2(_elm_lang$core$Dict$union, _p20._0, _p21._0));
	});
var _elm_lang$core$Set$intersect = F2(
	function (_p23, _p22) {
		var _p24 = _p23;
		var _p25 = _p22;
		return _elm_lang$core$Set$Set_elm_builtin(
			A2(_elm_lang$core$Dict$intersect, _p24._0, _p25._0));
	});
var _elm_lang$core$Set$diff = F2(
	function (_p27, _p26) {
		var _p28 = _p27;
		var _p29 = _p26;
		return _elm_lang$core$Set$Set_elm_builtin(
			A2(_elm_lang$core$Dict$diff, _p28._0, _p29._0));
	});
var _elm_lang$core$Set$filter = F2(
	function (p, _p30) {
		var _p31 = _p30;
		return _elm_lang$core$Set$Set_elm_builtin(
			A2(
				_elm_lang$core$Dict$filter,
				F2(
					function (k, _p32) {
						return p(k);
					}),
				_p31._0));
	});
var _elm_lang$core$Set$partition = F2(
	function (p, _p33) {
		var _p34 = _p33;
		var _p35 = A2(
			_elm_lang$core$Dict$partition,
			F2(
				function (k, _p36) {
					return p(k);
				}),
			_p34._0);
		var p1 = _p35._0;
		var p2 = _p35._1;
		return {
			ctor: '_Tuple2',
			_0: _elm_lang$core$Set$Set_elm_builtin(p1),
			_1: _elm_lang$core$Set$Set_elm_builtin(p2)
		};
	});

var _elm_community$elm_test$Expect$formatDiffs = F2(
	function (diffType, diffs) {
		if (_elm_lang$core$List$isEmpty(diffs)) {
			return '';
		} else {
			var modifier = function () {
				var _p0 = diffType;
				if (_p0.ctor === 'Extra') {
					return '+';
				} else {
					return '-';
				}
			}();
			return function (d) {
				return A2(
					_elm_lang$core$Basics_ops['++'],
					' ',
					A2(
						_elm_lang$core$Basics_ops['++'],
						modifier,
						A2(
							_elm_lang$core$Basics_ops['++'],
							'[ ',
							A2(_elm_lang$core$Basics_ops['++'], d, ' ]'))));
			}(
				A2(
					_elm_lang$core$String$join,
					', ',
					A2(_elm_lang$core$List$map, _elm_lang$core$Basics$toString, diffs)));
		}
	});
var _elm_community$elm_test$Expect$reportFailure = F3(
	function (comparison, expected, actual) {
		return A2(
			_elm_lang$core$String$join,
			'\n',
			{
				ctor: '::',
				_0: actual,
				_1: {
					ctor: '::',
					_0: '╷',
					_1: {
						ctor: '::',
						_0: A2(_elm_lang$core$Basics_ops['++'], '│ ', comparison),
						_1: {
							ctor: '::',
							_0: '╵',
							_1: {
								ctor: '::',
								_0: expected,
								_1: {ctor: '[]'}
							}
						}
					}
				}
			});
	});
var _elm_community$elm_test$Expect$onFail = F2(
	function (str, expectation) {
		var _p1 = expectation;
		if (_p1.ctor === 'Pass') {
			return expectation;
		} else {
			return A2(_elm_community$elm_test$Test_Expectation$Fail, _p1._0, str);
		}
	});
var _elm_community$elm_test$Expect$getFailure = function (expectation) {
	var _p2 = expectation;
	if (_p2.ctor === 'Pass') {
		return _elm_lang$core$Maybe$Nothing;
	} else {
		return _elm_lang$core$Maybe$Just(
			{given: _p2._0, message: _p2._1});
	}
};
var _elm_community$elm_test$Expect$fail = _elm_community$elm_test$Test_Expectation$Fail('');
var _elm_community$elm_test$Expect$pass = _elm_community$elm_test$Test_Expectation$Pass;
var _elm_community$elm_test$Expect$compareWith = F4(
	function (label, compare, expected, actual) {
		return A2(compare, actual, expected) ? _elm_community$elm_test$Expect$pass : _elm_community$elm_test$Expect$fail(
			A3(
				_elm_community$elm_test$Expect$reportFailure,
				label,
				_elm_lang$core$Basics$toString(expected),
				_elm_lang$core$Basics$toString(actual)));
	});
var _elm_community$elm_test$Expect$equalLists = F2(
	function (expected, actual) {
		if (_elm_lang$core$Native_Utils.eq(expected, actual)) {
			return _elm_community$elm_test$Expect$pass;
		} else {
			var result = A2(
				_elm_lang$core$Maybe$map,
				function (_p3) {
					var _p4 = _p3;
					var _p7 = _p4._0;
					var _p6 = _p4._2;
					var _p5 = _p4._1;
					return _elm_community$elm_test$Expect$fail(
						A2(
							_elm_lang$core$String$join,
							'\n',
							{
								ctor: '::',
								_0: _elm_lang$core$Basics$toString(actual),
								_1: {
									ctor: '::',
									_0: A2(
										_elm_lang$core$Basics_ops['++'],
										'first diff at index index ',
										A2(
											_elm_lang$core$Basics_ops['++'],
											_elm_lang$core$Basics$toString(_p7),
											A2(
												_elm_lang$core$Basics_ops['++'],
												': +`',
												A2(
													_elm_lang$core$Basics_ops['++'],
													_elm_lang$core$Basics$toString(_p5),
													A2(
														_elm_lang$core$Basics_ops['++'],
														'`, -`',
														A2(
															_elm_lang$core$Basics_ops['++'],
															_elm_lang$core$Basics$toString(_p6),
															'`')))))),
									_1: {
										ctor: '::',
										_0: '╷',
										_1: {
											ctor: '::',
											_0: '│ Expect.equalLists',
											_1: {
												ctor: '::',
												_0: '╵',
												_1: {
													ctor: '::',
													_0: A2(
														_elm_lang$core$Basics_ops['++'],
														'first diff at index index ',
														A2(
															_elm_lang$core$Basics_ops['++'],
															_elm_lang$core$Basics$toString(_p7),
															A2(
																_elm_lang$core$Basics_ops['++'],
																': +`',
																A2(
																	_elm_lang$core$Basics_ops['++'],
																	_elm_lang$core$Basics$toString(_p6),
																	A2(
																		_elm_lang$core$Basics_ops['++'],
																		'`, -`',
																		A2(
																			_elm_lang$core$Basics_ops['++'],
																			_elm_lang$core$Basics$toString(_p5),
																			'`')))))),
													_1: {
														ctor: '::',
														_0: _elm_lang$core$Basics$toString(expected),
														_1: {ctor: '[]'}
													}
												}
											}
										}
									}
								}
							}));
				},
				_elm_lang$core$List$head(
					A2(
						_elm_lang$core$List$filterMap,
						function (_p8) {
							var _p9 = _p8;
							var _p11 = _p9._1._1;
							var _p10 = _p9._1._0;
							return _elm_lang$core$Native_Utils.eq(_p11, _p10) ? _elm_lang$core$Maybe$Nothing : _elm_lang$core$Maybe$Just(
								{ctor: '_Tuple3', _0: _p9._0, _1: _p10, _2: _p11});
						},
						A2(
							_elm_lang$core$List$indexedMap,
							F2(
								function (v0, v1) {
									return {ctor: '_Tuple2', _0: v0, _1: v1};
								}),
							A3(
								_elm_lang$core$List$map2,
								F2(
									function (v0, v1) {
										return {ctor: '_Tuple2', _0: v0, _1: v1};
									}),
								actual,
								expected)))));
			var _p12 = result;
			if (_p12.ctor === 'Just') {
				return _p12._0;
			} else {
				var _p13 = A2(
					_elm_lang$core$Basics$compare,
					_elm_lang$core$List$length(actual),
					_elm_lang$core$List$length(expected));
				switch (_p13.ctor) {
					case 'GT':
						return _elm_community$elm_test$Expect$fail(
							A3(
								_elm_community$elm_test$Expect$reportFailure,
								'Expect.equalLists was longer than',
								_elm_lang$core$Basics$toString(expected),
								_elm_lang$core$Basics$toString(actual)));
					case 'LT':
						return _elm_community$elm_test$Expect$fail(
							A3(
								_elm_community$elm_test$Expect$reportFailure,
								'Expect.equalLists was shorter than',
								_elm_lang$core$Basics$toString(expected),
								_elm_lang$core$Basics$toString(actual)));
					default:
						return _elm_community$elm_test$Expect$pass;
				}
			}
		}
	});
var _elm_community$elm_test$Expect$false = F2(
	function (message, bool) {
		return bool ? _elm_community$elm_test$Expect$fail(message) : _elm_community$elm_test$Expect$pass;
	});
var _elm_community$elm_test$Expect$true = F2(
	function (message, bool) {
		return bool ? _elm_community$elm_test$Expect$pass : _elm_community$elm_test$Expect$fail(message);
	});
var _elm_community$elm_test$Expect$atLeast = A2(
	_elm_community$elm_test$Expect$compareWith,
	'Expect.atLeast',
	F2(
		function (x, y) {
			return _elm_lang$core$Native_Utils.cmp(x, y) > -1;
		}));
var _elm_community$elm_test$Expect$greaterThan = A2(
	_elm_community$elm_test$Expect$compareWith,
	'Expect.greaterThan',
	F2(
		function (x, y) {
			return _elm_lang$core$Native_Utils.cmp(x, y) > 0;
		}));
var _elm_community$elm_test$Expect$atMost = A2(
	_elm_community$elm_test$Expect$compareWith,
	'Expect.atMost',
	F2(
		function (x, y) {
			return _elm_lang$core$Native_Utils.cmp(x, y) < 1;
		}));
var _elm_community$elm_test$Expect$lessThan = A2(
	_elm_community$elm_test$Expect$compareWith,
	'Expect.lessThan',
	F2(
		function (x, y) {
			return _elm_lang$core$Native_Utils.cmp(x, y) < 0;
		}));
var _elm_community$elm_test$Expect$notEqual = A2(
	_elm_community$elm_test$Expect$compareWith,
	'Expect.notEqual',
	F2(
		function (x, y) {
			return !_elm_lang$core$Native_Utils.eq(x, y);
		}));
var _elm_community$elm_test$Expect$equal = A2(
	_elm_community$elm_test$Expect$compareWith,
	'Expect.equal',
	F2(
		function (x, y) {
			return _elm_lang$core$Native_Utils.eq(x, y);
		}));
var _elm_community$elm_test$Expect$Missing = {ctor: 'Missing'};
var _elm_community$elm_test$Expect$Extra = {ctor: 'Extra'};
var _elm_community$elm_test$Expect$reportCollectionFailure = F5(
	function (comparison, expected, actual, missingKeys, extraKeys) {
		return A2(
			_elm_lang$core$String$join,
			'\n',
			{
				ctor: '::',
				_0: _elm_lang$core$Basics$toString(actual),
				_1: {
					ctor: '::',
					_0: A2(
						_elm_lang$core$Basics_ops['++'],
						'diff:',
						A2(
							_elm_lang$core$Basics_ops['++'],
							A2(_elm_community$elm_test$Expect$formatDiffs, _elm_community$elm_test$Expect$Missing, missingKeys),
							A2(_elm_community$elm_test$Expect$formatDiffs, _elm_community$elm_test$Expect$Extra, extraKeys))),
					_1: {
						ctor: '::',
						_0: '╷',
						_1: {
							ctor: '::',
							_0: A2(_elm_lang$core$Basics_ops['++'], '│ ', comparison),
							_1: {
								ctor: '::',
								_0: '╵',
								_1: {
									ctor: '::',
									_0: A2(
										_elm_lang$core$Basics_ops['++'],
										'diff:',
										A2(
											_elm_lang$core$Basics_ops['++'],
											A2(_elm_community$elm_test$Expect$formatDiffs, _elm_community$elm_test$Expect$Extra, missingKeys),
											A2(_elm_community$elm_test$Expect$formatDiffs, _elm_community$elm_test$Expect$Missing, extraKeys))),
									_1: {
										ctor: '::',
										_0: _elm_lang$core$Basics$toString(expected),
										_1: {ctor: '[]'}
									}
								}
							}
						}
					}
				}
			});
	});
var _elm_community$elm_test$Expect$equalDicts = F2(
	function (expected, actual) {
		if (_elm_lang$core$Native_Utils.eq(
			_elm_lang$core$Dict$toList(expected),
			_elm_lang$core$Dict$toList(actual))) {
			return _elm_community$elm_test$Expect$pass;
		} else {
			var differ = F4(
				function (dict, k, v, diffs) {
					return _elm_lang$core$Native_Utils.eq(
						A2(_elm_lang$core$Dict$get, k, dict),
						_elm_lang$core$Maybe$Just(v)) ? diffs : {
						ctor: '::',
						_0: {ctor: '_Tuple2', _0: k, _1: v},
						_1: diffs
					};
				});
			var missingKeys = A3(
				_elm_lang$core$Dict$foldr,
				differ(actual),
				{ctor: '[]'},
				expected);
			var extraKeys = A3(
				_elm_lang$core$Dict$foldr,
				differ(expected),
				{ctor: '[]'},
				actual);
			return _elm_community$elm_test$Expect$fail(
				A5(_elm_community$elm_test$Expect$reportCollectionFailure, 'Expect.equalDicts', expected, actual, missingKeys, extraKeys));
		}
	});
var _elm_community$elm_test$Expect$equalSets = F2(
	function (expected, actual) {
		if (_elm_lang$core$Native_Utils.eq(
			_elm_lang$core$Set$toList(expected),
			_elm_lang$core$Set$toList(actual))) {
			return _elm_community$elm_test$Expect$pass;
		} else {
			var extraKeys = _elm_lang$core$Set$toList(
				A2(_elm_lang$core$Set$diff, actual, expected));
			var missingKeys = _elm_lang$core$Set$toList(
				A2(_elm_lang$core$Set$diff, expected, actual));
			return _elm_community$elm_test$Expect$fail(
				A5(_elm_community$elm_test$Expect$reportCollectionFailure, 'Expect.equalSets', expected, actual, missingKeys, extraKeys));
		}
	});

//import Native.List //

var _elm_lang$core$Native_Array = function() {

// A RRB-Tree has two distinct data types.
// Leaf -> "height"  is always 0
//         "table"   is an array of elements
// Node -> "height"  is always greater than 0
//         "table"   is an array of child nodes
//         "lengths" is an array of accumulated lengths of the child nodes

// M is the maximal table size. 32 seems fast. E is the allowed increase
// of search steps when concatting to find an index. Lower values will
// decrease balancing, but will increase search steps.
var M = 32;
var E = 2;

// An empty array.
var empty = {
	ctor: '_Array',
	height: 0,
	table: []
};


function get(i, array)
{
	if (i < 0 || i >= length(array))
	{
		throw new Error(
			'Index ' + i + ' is out of range. Check the length of ' +
			'your array first or use getMaybe or getWithDefault.');
	}
	return unsafeGet(i, array);
}


function unsafeGet(i, array)
{
	for (var x = array.height; x > 0; x--)
	{
		var slot = i >> (x * 5);
		while (array.lengths[slot] <= i)
		{
			slot++;
		}
		if (slot > 0)
		{
			i -= array.lengths[slot - 1];
		}
		array = array.table[slot];
	}
	return array.table[i];
}


// Sets the value at the index i. Only the nodes leading to i will get
// copied and updated.
function set(i, item, array)
{
	if (i < 0 || length(array) <= i)
	{
		return array;
	}
	return unsafeSet(i, item, array);
}


function unsafeSet(i, item, array)
{
	array = nodeCopy(array);

	if (array.height === 0)
	{
		array.table[i] = item;
	}
	else
	{
		var slot = getSlot(i, array);
		if (slot > 0)
		{
			i -= array.lengths[slot - 1];
		}
		array.table[slot] = unsafeSet(i, item, array.table[slot]);
	}
	return array;
}


function initialize(len, f)
{
	if (len <= 0)
	{
		return empty;
	}
	var h = Math.floor( Math.log(len) / Math.log(M) );
	return initialize_(f, h, 0, len);
}

function initialize_(f, h, from, to)
{
	if (h === 0)
	{
		var table = new Array((to - from) % (M + 1));
		for (var i = 0; i < table.length; i++)
		{
		  table[i] = f(from + i);
		}
		return {
			ctor: '_Array',
			height: 0,
			table: table
		};
	}

	var step = Math.pow(M, h);
	var table = new Array(Math.ceil((to - from) / step));
	var lengths = new Array(table.length);
	for (var i = 0; i < table.length; i++)
	{
		table[i] = initialize_(f, h - 1, from + (i * step), Math.min(from + ((i + 1) * step), to));
		lengths[i] = length(table[i]) + (i > 0 ? lengths[i-1] : 0);
	}
	return {
		ctor: '_Array',
		height: h,
		table: table,
		lengths: lengths
	};
}

function fromList(list)
{
	if (list.ctor === '[]')
	{
		return empty;
	}

	// Allocate M sized blocks (table) and write list elements to it.
	var table = new Array(M);
	var nodes = [];
	var i = 0;

	while (list.ctor !== '[]')
	{
		table[i] = list._0;
		list = list._1;
		i++;

		// table is full, so we can push a leaf containing it into the
		// next node.
		if (i === M)
		{
			var leaf = {
				ctor: '_Array',
				height: 0,
				table: table
			};
			fromListPush(leaf, nodes);
			table = new Array(M);
			i = 0;
		}
	}

	// Maybe there is something left on the table.
	if (i > 0)
	{
		var leaf = {
			ctor: '_Array',
			height: 0,
			table: table.splice(0, i)
		};
		fromListPush(leaf, nodes);
	}

	// Go through all of the nodes and eventually push them into higher nodes.
	for (var h = 0; h < nodes.length - 1; h++)
	{
		if (nodes[h].table.length > 0)
		{
			fromListPush(nodes[h], nodes);
		}
	}

	var head = nodes[nodes.length - 1];
	if (head.height > 0 && head.table.length === 1)
	{
		return head.table[0];
	}
	else
	{
		return head;
	}
}

// Push a node into a higher node as a child.
function fromListPush(toPush, nodes)
{
	var h = toPush.height;

	// Maybe the node on this height does not exist.
	if (nodes.length === h)
	{
		var node = {
			ctor: '_Array',
			height: h + 1,
			table: [],
			lengths: []
		};
		nodes.push(node);
	}

	nodes[h].table.push(toPush);
	var len = length(toPush);
	if (nodes[h].lengths.length > 0)
	{
		len += nodes[h].lengths[nodes[h].lengths.length - 1];
	}
	nodes[h].lengths.push(len);

	if (nodes[h].table.length === M)
	{
		fromListPush(nodes[h], nodes);
		nodes[h] = {
			ctor: '_Array',
			height: h + 1,
			table: [],
			lengths: []
		};
	}
}

// Pushes an item via push_ to the bottom right of a tree.
function push(item, a)
{
	var pushed = push_(item, a);
	if (pushed !== null)
	{
		return pushed;
	}

	var newTree = create(item, a.height);
	return siblise(a, newTree);
}

// Recursively tries to push an item to the bottom-right most
// tree possible. If there is no space left for the item,
// null will be returned.
function push_(item, a)
{
	// Handle resursion stop at leaf level.
	if (a.height === 0)
	{
		if (a.table.length < M)
		{
			var newA = {
				ctor: '_Array',
				height: 0,
				table: a.table.slice()
			};
			newA.table.push(item);
			return newA;
		}
		else
		{
		  return null;
		}
	}

	// Recursively push
	var pushed = push_(item, botRight(a));

	// There was space in the bottom right tree, so the slot will
	// be updated.
	if (pushed !== null)
	{
		var newA = nodeCopy(a);
		newA.table[newA.table.length - 1] = pushed;
		newA.lengths[newA.lengths.length - 1]++;
		return newA;
	}

	// When there was no space left, check if there is space left
	// for a new slot with a tree which contains only the item
	// at the bottom.
	if (a.table.length < M)
	{
		var newSlot = create(item, a.height - 1);
		var newA = nodeCopy(a);
		newA.table.push(newSlot);
		newA.lengths.push(newA.lengths[newA.lengths.length - 1] + length(newSlot));
		return newA;
	}
	else
	{
		return null;
	}
}

// Converts an array into a list of elements.
function toList(a)
{
	return toList_(_elm_lang$core$Native_List.Nil, a);
}

function toList_(list, a)
{
	for (var i = a.table.length - 1; i >= 0; i--)
	{
		list =
			a.height === 0
				? _elm_lang$core$Native_List.Cons(a.table[i], list)
				: toList_(list, a.table[i]);
	}
	return list;
}

// Maps a function over the elements of an array.
function map(f, a)
{
	var newA = {
		ctor: '_Array',
		height: a.height,
		table: new Array(a.table.length)
	};
	if (a.height > 0)
	{
		newA.lengths = a.lengths;
	}
	for (var i = 0; i < a.table.length; i++)
	{
		newA.table[i] =
			a.height === 0
				? f(a.table[i])
				: map(f, a.table[i]);
	}
	return newA;
}

// Maps a function over the elements with their index as first argument.
function indexedMap(f, a)
{
	return indexedMap_(f, a, 0);
}

function indexedMap_(f, a, from)
{
	var newA = {
		ctor: '_Array',
		height: a.height,
		table: new Array(a.table.length)
	};
	if (a.height > 0)
	{
		newA.lengths = a.lengths;
	}
	for (var i = 0; i < a.table.length; i++)
	{
		newA.table[i] =
			a.height === 0
				? A2(f, from + i, a.table[i])
				: indexedMap_(f, a.table[i], i == 0 ? from : from + a.lengths[i - 1]);
	}
	return newA;
}

function foldl(f, b, a)
{
	if (a.height === 0)
	{
		for (var i = 0; i < a.table.length; i++)
		{
			b = A2(f, a.table[i], b);
		}
	}
	else
	{
		for (var i = 0; i < a.table.length; i++)
		{
			b = foldl(f, b, a.table[i]);
		}
	}
	return b;
}

function foldr(f, b, a)
{
	if (a.height === 0)
	{
		for (var i = a.table.length; i--; )
		{
			b = A2(f, a.table[i], b);
		}
	}
	else
	{
		for (var i = a.table.length; i--; )
		{
			b = foldr(f, b, a.table[i]);
		}
	}
	return b;
}

// TODO: currently, it slices the right, then the left. This can be
// optimized.
function slice(from, to, a)
{
	if (from < 0)
	{
		from += length(a);
	}
	if (to < 0)
	{
		to += length(a);
	}
	return sliceLeft(from, sliceRight(to, a));
}

function sliceRight(to, a)
{
	if (to === length(a))
	{
		return a;
	}

	// Handle leaf level.
	if (a.height === 0)
	{
		var newA = { ctor:'_Array', height:0 };
		newA.table = a.table.slice(0, to);
		return newA;
	}

	// Slice the right recursively.
	var right = getSlot(to, a);
	var sliced = sliceRight(to - (right > 0 ? a.lengths[right - 1] : 0), a.table[right]);

	// Maybe the a node is not even needed, as sliced contains the whole slice.
	if (right === 0)
	{
		return sliced;
	}

	// Create new node.
	var newA = {
		ctor: '_Array',
		height: a.height,
		table: a.table.slice(0, right),
		lengths: a.lengths.slice(0, right)
	};
	if (sliced.table.length > 0)
	{
		newA.table[right] = sliced;
		newA.lengths[right] = length(sliced) + (right > 0 ? newA.lengths[right - 1] : 0);
	}
	return newA;
}

function sliceLeft(from, a)
{
	if (from === 0)
	{
		return a;
	}

	// Handle leaf level.
	if (a.height === 0)
	{
		var newA = { ctor:'_Array', height:0 };
		newA.table = a.table.slice(from, a.table.length + 1);
		return newA;
	}

	// Slice the left recursively.
	var left = getSlot(from, a);
	var sliced = sliceLeft(from - (left > 0 ? a.lengths[left - 1] : 0), a.table[left]);

	// Maybe the a node is not even needed, as sliced contains the whole slice.
	if (left === a.table.length - 1)
	{
		return sliced;
	}

	// Create new node.
	var newA = {
		ctor: '_Array',
		height: a.height,
		table: a.table.slice(left, a.table.length + 1),
		lengths: new Array(a.table.length - left)
	};
	newA.table[0] = sliced;
	var len = 0;
	for (var i = 0; i < newA.table.length; i++)
	{
		len += length(newA.table[i]);
		newA.lengths[i] = len;
	}

	return newA;
}

// Appends two trees.
function append(a,b)
{
	if (a.table.length === 0)
	{
		return b;
	}
	if (b.table.length === 0)
	{
		return a;
	}

	var c = append_(a, b);

	// Check if both nodes can be crunshed together.
	if (c[0].table.length + c[1].table.length <= M)
	{
		if (c[0].table.length === 0)
		{
			return c[1];
		}
		if (c[1].table.length === 0)
		{
			return c[0];
		}

		// Adjust .table and .lengths
		c[0].table = c[0].table.concat(c[1].table);
		if (c[0].height > 0)
		{
			var len = length(c[0]);
			for (var i = 0; i < c[1].lengths.length; i++)
			{
				c[1].lengths[i] += len;
			}
			c[0].lengths = c[0].lengths.concat(c[1].lengths);
		}

		return c[0];
	}

	if (c[0].height > 0)
	{
		var toRemove = calcToRemove(a, b);
		if (toRemove > E)
		{
			c = shuffle(c[0], c[1], toRemove);
		}
	}

	return siblise(c[0], c[1]);
}

// Returns an array of two nodes; right and left. One node _may_ be empty.
function append_(a, b)
{
	if (a.height === 0 && b.height === 0)
	{
		return [a, b];
	}

	if (a.height !== 1 || b.height !== 1)
	{
		if (a.height === b.height)
		{
			a = nodeCopy(a);
			b = nodeCopy(b);
			var appended = append_(botRight(a), botLeft(b));

			insertRight(a, appended[1]);
			insertLeft(b, appended[0]);
		}
		else if (a.height > b.height)
		{
			a = nodeCopy(a);
			var appended = append_(botRight(a), b);

			insertRight(a, appended[0]);
			b = parentise(appended[1], appended[1].height + 1);
		}
		else
		{
			b = nodeCopy(b);
			var appended = append_(a, botLeft(b));

			var left = appended[0].table.length === 0 ? 0 : 1;
			var right = left === 0 ? 1 : 0;
			insertLeft(b, appended[left]);
			a = parentise(appended[right], appended[right].height + 1);
		}
	}

	// Check if balancing is needed and return based on that.
	if (a.table.length === 0 || b.table.length === 0)
	{
		return [a, b];
	}

	var toRemove = calcToRemove(a, b);
	if (toRemove <= E)
	{
		return [a, b];
	}
	return shuffle(a, b, toRemove);
}

// Helperfunctions for append_. Replaces a child node at the side of the parent.
function insertRight(parent, node)
{
	var index = parent.table.length - 1;
	parent.table[index] = node;
	parent.lengths[index] = length(node);
	parent.lengths[index] += index > 0 ? parent.lengths[index - 1] : 0;
}

function insertLeft(parent, node)
{
	if (node.table.length > 0)
	{
		parent.table[0] = node;
		parent.lengths[0] = length(node);

		var len = length(parent.table[0]);
		for (var i = 1; i < parent.lengths.length; i++)
		{
			len += length(parent.table[i]);
			parent.lengths[i] = len;
		}
	}
	else
	{
		parent.table.shift();
		for (var i = 1; i < parent.lengths.length; i++)
		{
			parent.lengths[i] = parent.lengths[i] - parent.lengths[0];
		}
		parent.lengths.shift();
	}
}

// Returns the extra search steps for E. Refer to the paper.
function calcToRemove(a, b)
{
	var subLengths = 0;
	for (var i = 0; i < a.table.length; i++)
	{
		subLengths += a.table[i].table.length;
	}
	for (var i = 0; i < b.table.length; i++)
	{
		subLengths += b.table[i].table.length;
	}

	var toRemove = a.table.length + b.table.length;
	return toRemove - (Math.floor((subLengths - 1) / M) + 1);
}

// get2, set2 and saveSlot are helpers for accessing elements over two arrays.
function get2(a, b, index)
{
	return index < a.length
		? a[index]
		: b[index - a.length];
}

function set2(a, b, index, value)
{
	if (index < a.length)
	{
		a[index] = value;
	}
	else
	{
		b[index - a.length] = value;
	}
}

function saveSlot(a, b, index, slot)
{
	set2(a.table, b.table, index, slot);

	var l = (index === 0 || index === a.lengths.length)
		? 0
		: get2(a.lengths, a.lengths, index - 1);

	set2(a.lengths, b.lengths, index, l + length(slot));
}

// Creates a node or leaf with a given length at their arrays for perfomance.
// Is only used by shuffle.
function createNode(h, length)
{
	if (length < 0)
	{
		length = 0;
	}
	var a = {
		ctor: '_Array',
		height: h,
		table: new Array(length)
	};
	if (h > 0)
	{
		a.lengths = new Array(length);
	}
	return a;
}

// Returns an array of two balanced nodes.
function shuffle(a, b, toRemove)
{
	var newA = createNode(a.height, Math.min(M, a.table.length + b.table.length - toRemove));
	var newB = createNode(a.height, newA.table.length - (a.table.length + b.table.length - toRemove));

	// Skip the slots with size M. More precise: copy the slot references
	// to the new node
	var read = 0;
	while (get2(a.table, b.table, read).table.length % M === 0)
	{
		set2(newA.table, newB.table, read, get2(a.table, b.table, read));
		set2(newA.lengths, newB.lengths, read, get2(a.lengths, b.lengths, read));
		read++;
	}

	// Pulling items from left to right, caching in a slot before writing
	// it into the new nodes.
	var write = read;
	var slot = new createNode(a.height - 1, 0);
	var from = 0;

	// If the current slot is still containing data, then there will be at
	// least one more write, so we do not break this loop yet.
	while (read - write - (slot.table.length > 0 ? 1 : 0) < toRemove)
	{
		// Find out the max possible items for copying.
		var source = get2(a.table, b.table, read);
		var to = Math.min(M - slot.table.length, source.table.length);

		// Copy and adjust size table.
		slot.table = slot.table.concat(source.table.slice(from, to));
		if (slot.height > 0)
		{
			var len = slot.lengths.length;
			for (var i = len; i < len + to - from; i++)
			{
				slot.lengths[i] = length(slot.table[i]);
				slot.lengths[i] += (i > 0 ? slot.lengths[i - 1] : 0);
			}
		}

		from += to;

		// Only proceed to next slots[i] if the current one was
		// fully copied.
		if (source.table.length <= to)
		{
			read++; from = 0;
		}

		// Only create a new slot if the current one is filled up.
		if (slot.table.length === M)
		{
			saveSlot(newA, newB, write, slot);
			slot = createNode(a.height - 1, 0);
			write++;
		}
	}

	// Cleanup after the loop. Copy the last slot into the new nodes.
	if (slot.table.length > 0)
	{
		saveSlot(newA, newB, write, slot);
		write++;
	}

	// Shift the untouched slots to the left
	while (read < a.table.length + b.table.length )
	{
		saveSlot(newA, newB, write, get2(a.table, b.table, read));
		read++;
		write++;
	}

	return [newA, newB];
}

// Navigation functions
function botRight(a)
{
	return a.table[a.table.length - 1];
}
function botLeft(a)
{
	return a.table[0];
}

// Copies a node for updating. Note that you should not use this if
// only updating only one of "table" or "lengths" for performance reasons.
function nodeCopy(a)
{
	var newA = {
		ctor: '_Array',
		height: a.height,
		table: a.table.slice()
	};
	if (a.height > 0)
	{
		newA.lengths = a.lengths.slice();
	}
	return newA;
}

// Returns how many items are in the tree.
function length(array)
{
	if (array.height === 0)
	{
		return array.table.length;
	}
	else
	{
		return array.lengths[array.lengths.length - 1];
	}
}

// Calculates in which slot of "table" the item probably is, then
// find the exact slot via forward searching in  "lengths". Returns the index.
function getSlot(i, a)
{
	var slot = i >> (5 * a.height);
	while (a.lengths[slot] <= i)
	{
		slot++;
	}
	return slot;
}

// Recursively creates a tree with a given height containing
// only the given item.
function create(item, h)
{
	if (h === 0)
	{
		return {
			ctor: '_Array',
			height: 0,
			table: [item]
		};
	}
	return {
		ctor: '_Array',
		height: h,
		table: [create(item, h - 1)],
		lengths: [1]
	};
}

// Recursively creates a tree that contains the given tree.
function parentise(tree, h)
{
	if (h === tree.height)
	{
		return tree;
	}

	return {
		ctor: '_Array',
		height: h,
		table: [parentise(tree, h - 1)],
		lengths: [length(tree)]
	};
}

// Emphasizes blood brotherhood beneath two trees.
function siblise(a, b)
{
	return {
		ctor: '_Array',
		height: a.height + 1,
		table: [a, b],
		lengths: [length(a), length(a) + length(b)]
	};
}

function toJSArray(a)
{
	var jsArray = new Array(length(a));
	toJSArray_(jsArray, 0, a);
	return jsArray;
}

function toJSArray_(jsArray, i, a)
{
	for (var t = 0; t < a.table.length; t++)
	{
		if (a.height === 0)
		{
			jsArray[i + t] = a.table[t];
		}
		else
		{
			var inc = t === 0 ? 0 : a.lengths[t - 1];
			toJSArray_(jsArray, i + inc, a.table[t]);
		}
	}
}

function fromJSArray(jsArray)
{
	if (jsArray.length === 0)
	{
		return empty;
	}
	var h = Math.floor(Math.log(jsArray.length) / Math.log(M));
	return fromJSArray_(jsArray, h, 0, jsArray.length);
}

function fromJSArray_(jsArray, h, from, to)
{
	if (h === 0)
	{
		return {
			ctor: '_Array',
			height: 0,
			table: jsArray.slice(from, to)
		};
	}

	var step = Math.pow(M, h);
	var table = new Array(Math.ceil((to - from) / step));
	var lengths = new Array(table.length);
	for (var i = 0; i < table.length; i++)
	{
		table[i] = fromJSArray_(jsArray, h - 1, from + (i * step), Math.min(from + ((i + 1) * step), to));
		lengths[i] = length(table[i]) + (i > 0 ? lengths[i - 1] : 0);
	}
	return {
		ctor: '_Array',
		height: h,
		table: table,
		lengths: lengths
	};
}

return {
	empty: empty,
	fromList: fromList,
	toList: toList,
	initialize: F2(initialize),
	append: F2(append),
	push: F2(push),
	slice: F3(slice),
	get: F2(get),
	set: F3(set),
	map: F2(map),
	indexedMap: F2(indexedMap),
	foldl: F3(foldl),
	foldr: F3(foldr),
	length: length,

	toJSArray: toJSArray,
	fromJSArray: fromJSArray
};

}();
var _elm_lang$core$Array$append = _elm_lang$core$Native_Array.append;
var _elm_lang$core$Array$length = _elm_lang$core$Native_Array.length;
var _elm_lang$core$Array$isEmpty = function (array) {
	return _elm_lang$core$Native_Utils.eq(
		_elm_lang$core$Array$length(array),
		0);
};
var _elm_lang$core$Array$slice = _elm_lang$core$Native_Array.slice;
var _elm_lang$core$Array$set = _elm_lang$core$Native_Array.set;
var _elm_lang$core$Array$get = F2(
	function (i, array) {
		return ((_elm_lang$core$Native_Utils.cmp(0, i) < 1) && (_elm_lang$core$Native_Utils.cmp(
			i,
			_elm_lang$core$Native_Array.length(array)) < 0)) ? _elm_lang$core$Maybe$Just(
			A2(_elm_lang$core$Native_Array.get, i, array)) : _elm_lang$core$Maybe$Nothing;
	});
var _elm_lang$core$Array$push = _elm_lang$core$Native_Array.push;
var _elm_lang$core$Array$empty = _elm_lang$core$Native_Array.empty;
var _elm_lang$core$Array$filter = F2(
	function (isOkay, arr) {
		var update = F2(
			function (x, xs) {
				return isOkay(x) ? A2(_elm_lang$core$Native_Array.push, x, xs) : xs;
			});
		return A3(_elm_lang$core$Native_Array.foldl, update, _elm_lang$core$Native_Array.empty, arr);
	});
var _elm_lang$core$Array$foldr = _elm_lang$core$Native_Array.foldr;
var _elm_lang$core$Array$foldl = _elm_lang$core$Native_Array.foldl;
var _elm_lang$core$Array$indexedMap = _elm_lang$core$Native_Array.indexedMap;
var _elm_lang$core$Array$map = _elm_lang$core$Native_Array.map;
var _elm_lang$core$Array$toIndexedList = function (array) {
	return A3(
		_elm_lang$core$List$map2,
		F2(
			function (v0, v1) {
				return {ctor: '_Tuple2', _0: v0, _1: v1};
			}),
		A2(
			_elm_lang$core$List$range,
			0,
			_elm_lang$core$Native_Array.length(array) - 1),
		_elm_lang$core$Native_Array.toList(array));
};
var _elm_lang$core$Array$toList = _elm_lang$core$Native_Array.toList;
var _elm_lang$core$Array$fromList = _elm_lang$core$Native_Array.fromList;
var _elm_lang$core$Array$initialize = _elm_lang$core$Native_Array.initialize;
var _elm_lang$core$Array$repeat = F2(
	function (n, e) {
		return A2(
			_elm_lang$core$Array$initialize,
			n,
			_elm_lang$core$Basics$always(e));
	});
var _elm_lang$core$Array$Array = {ctor: 'Array'};

//import Maybe, Native.Array, Native.List, Native.Utils, Result //

var _elm_lang$core$Native_Json = function() {


// CORE DECODERS

function succeed(msg)
{
	return {
		ctor: '<decoder>',
		tag: 'succeed',
		msg: msg
	};
}

function fail(msg)
{
	return {
		ctor: '<decoder>',
		tag: 'fail',
		msg: msg
	};
}

function decodePrimitive(tag)
{
	return {
		ctor: '<decoder>',
		tag: tag
	};
}

function decodeContainer(tag, decoder)
{
	return {
		ctor: '<decoder>',
		tag: tag,
		decoder: decoder
	};
}

function decodeNull(value)
{
	return {
		ctor: '<decoder>',
		tag: 'null',
		value: value
	};
}

function decodeField(field, decoder)
{
	return {
		ctor: '<decoder>',
		tag: 'field',
		field: field,
		decoder: decoder
	};
}

function decodeIndex(index, decoder)
{
	return {
		ctor: '<decoder>',
		tag: 'index',
		index: index,
		decoder: decoder
	};
}

function decodeKeyValuePairs(decoder)
{
	return {
		ctor: '<decoder>',
		tag: 'key-value',
		decoder: decoder
	};
}

function mapMany(f, decoders)
{
	return {
		ctor: '<decoder>',
		tag: 'map-many',
		func: f,
		decoders: decoders
	};
}

function andThen(callback, decoder)
{
	return {
		ctor: '<decoder>',
		tag: 'andThen',
		decoder: decoder,
		callback: callback
	};
}

function oneOf(decoders)
{
	return {
		ctor: '<decoder>',
		tag: 'oneOf',
		decoders: decoders
	};
}


// DECODING OBJECTS

function map1(f, d1)
{
	return mapMany(f, [d1]);
}

function map2(f, d1, d2)
{
	return mapMany(f, [d1, d2]);
}

function map3(f, d1, d2, d3)
{
	return mapMany(f, [d1, d2, d3]);
}

function map4(f, d1, d2, d3, d4)
{
	return mapMany(f, [d1, d2, d3, d4]);
}

function map5(f, d1, d2, d3, d4, d5)
{
	return mapMany(f, [d1, d2, d3, d4, d5]);
}

function map6(f, d1, d2, d3, d4, d5, d6)
{
	return mapMany(f, [d1, d2, d3, d4, d5, d6]);
}

function map7(f, d1, d2, d3, d4, d5, d6, d7)
{
	return mapMany(f, [d1, d2, d3, d4, d5, d6, d7]);
}

function map8(f, d1, d2, d3, d4, d5, d6, d7, d8)
{
	return mapMany(f, [d1, d2, d3, d4, d5, d6, d7, d8]);
}


// DECODE HELPERS

function ok(value)
{
	return { tag: 'ok', value: value };
}

function badPrimitive(type, value)
{
	return { tag: 'primitive', type: type, value: value };
}

function badIndex(index, nestedProblems)
{
	return { tag: 'index', index: index, rest: nestedProblems };
}

function badField(field, nestedProblems)
{
	return { tag: 'field', field: field, rest: nestedProblems };
}

function badIndex(index, nestedProblems)
{
	return { tag: 'index', index: index, rest: nestedProblems };
}

function badOneOf(problems)
{
	return { tag: 'oneOf', problems: problems };
}

function bad(msg)
{
	return { tag: 'fail', msg: msg };
}

function badToString(problem)
{
	var context = '_';
	while (problem)
	{
		switch (problem.tag)
		{
			case 'primitive':
				return 'Expecting ' + problem.type
					+ (context === '_' ? '' : ' at ' + context)
					+ ' but instead got: ' + jsToString(problem.value);

			case 'index':
				context += '[' + problem.index + ']';
				problem = problem.rest;
				break;

			case 'field':
				context += '.' + problem.field;
				problem = problem.rest;
				break;

			case 'index':
				context += '[' + problem.index + ']';
				problem = problem.rest;
				break;

			case 'oneOf':
				var problems = problem.problems;
				for (var i = 0; i < problems.length; i++)
				{
					problems[i] = badToString(problems[i]);
				}
				return 'I ran into the following problems'
					+ (context === '_' ? '' : ' at ' + context)
					+ ':\n\n' + problems.join('\n');

			case 'fail':
				return 'I ran into a `fail` decoder'
					+ (context === '_' ? '' : ' at ' + context)
					+ ': ' + problem.msg;
		}
	}
}

function jsToString(value)
{
	return value === undefined
		? 'undefined'
		: JSON.stringify(value);
}


// DECODE

function runOnString(decoder, string)
{
	var json;
	try
	{
		json = JSON.parse(string);
	}
	catch (e)
	{
		return _elm_lang$core$Result$Err('Given an invalid JSON: ' + e.message);
	}
	return run(decoder, json);
}

function run(decoder, value)
{
	var result = runHelp(decoder, value);
	return (result.tag === 'ok')
		? _elm_lang$core$Result$Ok(result.value)
		: _elm_lang$core$Result$Err(badToString(result));
}

function runHelp(decoder, value)
{
	switch (decoder.tag)
	{
		case 'bool':
			return (typeof value === 'boolean')
				? ok(value)
				: badPrimitive('a Bool', value);

		case 'int':
			if (typeof value !== 'number') {
				return badPrimitive('an Int', value);
			}

			if (-2147483647 < value && value < 2147483647 && (value | 0) === value) {
				return ok(value);
			}

			if (isFinite(value) && !(value % 1)) {
				return ok(value);
			}

			return badPrimitive('an Int', value);

		case 'float':
			return (typeof value === 'number')
				? ok(value)
				: badPrimitive('a Float', value);

		case 'string':
			return (typeof value === 'string')
				? ok(value)
				: (value instanceof String)
					? ok(value + '')
					: badPrimitive('a String', value);

		case 'null':
			return (value === null)
				? ok(decoder.value)
				: badPrimitive('null', value);

		case 'value':
			return ok(value);

		case 'list':
			if (!(value instanceof Array))
			{
				return badPrimitive('a List', value);
			}

			var list = _elm_lang$core$Native_List.Nil;
			for (var i = value.length; i--; )
			{
				var result = runHelp(decoder.decoder, value[i]);
				if (result.tag !== 'ok')
				{
					return badIndex(i, result)
				}
				list = _elm_lang$core$Native_List.Cons(result.value, list);
			}
			return ok(list);

		case 'array':
			if (!(value instanceof Array))
			{
				return badPrimitive('an Array', value);
			}

			var len = value.length;
			var array = new Array(len);
			for (var i = len; i--; )
			{
				var result = runHelp(decoder.decoder, value[i]);
				if (result.tag !== 'ok')
				{
					return badIndex(i, result);
				}
				array[i] = result.value;
			}
			return ok(_elm_lang$core$Native_Array.fromJSArray(array));

		case 'maybe':
			var result = runHelp(decoder.decoder, value);
			return (result.tag === 'ok')
				? ok(_elm_lang$core$Maybe$Just(result.value))
				: ok(_elm_lang$core$Maybe$Nothing);

		case 'field':
			var field = decoder.field;
			if (typeof value !== 'object' || value === null || !(field in value))
			{
				return badPrimitive('an object with a field named `' + field + '`', value);
			}

			var result = runHelp(decoder.decoder, value[field]);
			return (result.tag === 'ok') ? result : badField(field, result);

		case 'index':
			var index = decoder.index;
			if (!(value instanceof Array))
			{
				return badPrimitive('an array', value);
			}
			if (index >= value.length)
			{
				return badPrimitive('a longer array. Need index ' + index + ' but there are only ' + value.length + ' entries', value);
			}

			var result = runHelp(decoder.decoder, value[index]);
			return (result.tag === 'ok') ? result : badIndex(index, result);

		case 'key-value':
			if (typeof value !== 'object' || value === null || value instanceof Array)
			{
				return badPrimitive('an object', value);
			}

			var keyValuePairs = _elm_lang$core$Native_List.Nil;
			for (var key in value)
			{
				var result = runHelp(decoder.decoder, value[key]);
				if (result.tag !== 'ok')
				{
					return badField(key, result);
				}
				var pair = _elm_lang$core$Native_Utils.Tuple2(key, result.value);
				keyValuePairs = _elm_lang$core$Native_List.Cons(pair, keyValuePairs);
			}
			return ok(keyValuePairs);

		case 'map-many':
			var answer = decoder.func;
			var decoders = decoder.decoders;
			for (var i = 0; i < decoders.length; i++)
			{
				var result = runHelp(decoders[i], value);
				if (result.tag !== 'ok')
				{
					return result;
				}
				answer = answer(result.value);
			}
			return ok(answer);

		case 'andThen':
			var result = runHelp(decoder.decoder, value);
			return (result.tag !== 'ok')
				? result
				: runHelp(decoder.callback(result.value), value);

		case 'oneOf':
			var errors = [];
			var temp = decoder.decoders;
			while (temp.ctor !== '[]')
			{
				var result = runHelp(temp._0, value);

				if (result.tag === 'ok')
				{
					return result;
				}

				errors.push(result);

				temp = temp._1;
			}
			return badOneOf(errors);

		case 'fail':
			return bad(decoder.msg);

		case 'succeed':
			return ok(decoder.msg);
	}
}


// EQUALITY

function equality(a, b)
{
	if (a === b)
	{
		return true;
	}

	if (a.tag !== b.tag)
	{
		return false;
	}

	switch (a.tag)
	{
		case 'succeed':
		case 'fail':
			return a.msg === b.msg;

		case 'bool':
		case 'int':
		case 'float':
		case 'string':
		case 'value':
			return true;

		case 'null':
			return a.value === b.value;

		case 'list':
		case 'array':
		case 'maybe':
		case 'key-value':
			return equality(a.decoder, b.decoder);

		case 'field':
			return a.field === b.field && equality(a.decoder, b.decoder);

		case 'index':
			return a.index === b.index && equality(a.decoder, b.decoder);

		case 'map-many':
			if (a.func !== b.func)
			{
				return false;
			}
			return listEquality(a.decoders, b.decoders);

		case 'andThen':
			return a.callback === b.callback && equality(a.decoder, b.decoder);

		case 'oneOf':
			return listEquality(a.decoders, b.decoders);
	}
}

function listEquality(aDecoders, bDecoders)
{
	var len = aDecoders.length;
	if (len !== bDecoders.length)
	{
		return false;
	}
	for (var i = 0; i < len; i++)
	{
		if (!equality(aDecoders[i], bDecoders[i]))
		{
			return false;
		}
	}
	return true;
}


// ENCODE

function encode(indentLevel, value)
{
	return JSON.stringify(value, null, indentLevel);
}

function identity(value)
{
	return value;
}

function encodeObject(keyValuePairs)
{
	var obj = {};
	while (keyValuePairs.ctor !== '[]')
	{
		var pair = keyValuePairs._0;
		obj[pair._0] = pair._1;
		keyValuePairs = keyValuePairs._1;
	}
	return obj;
}

return {
	encode: F2(encode),
	runOnString: F2(runOnString),
	run: F2(run),

	decodeNull: decodeNull,
	decodePrimitive: decodePrimitive,
	decodeContainer: F2(decodeContainer),

	decodeField: F2(decodeField),
	decodeIndex: F2(decodeIndex),

	map1: F2(map1),
	map2: F3(map2),
	map3: F4(map3),
	map4: F5(map4),
	map5: F6(map5),
	map6: F7(map6),
	map7: F8(map7),
	map8: F9(map8),
	decodeKeyValuePairs: decodeKeyValuePairs,

	andThen: F2(andThen),
	fail: fail,
	succeed: succeed,
	oneOf: oneOf,

	identity: identity,
	encodeNull: null,
	encodeArray: _elm_lang$core$Native_Array.toJSArray,
	encodeList: _elm_lang$core$Native_List.toArray,
	encodeObject: encodeObject,

	equality: equality
};

}();

var _elm_lang$core$Json_Encode$list = _elm_lang$core$Native_Json.encodeList;
var _elm_lang$core$Json_Encode$array = _elm_lang$core$Native_Json.encodeArray;
var _elm_lang$core$Json_Encode$object = _elm_lang$core$Native_Json.encodeObject;
var _elm_lang$core$Json_Encode$null = _elm_lang$core$Native_Json.encodeNull;
var _elm_lang$core$Json_Encode$bool = _elm_lang$core$Native_Json.identity;
var _elm_lang$core$Json_Encode$float = _elm_lang$core$Native_Json.identity;
var _elm_lang$core$Json_Encode$int = _elm_lang$core$Native_Json.identity;
var _elm_lang$core$Json_Encode$string = _elm_lang$core$Native_Json.identity;
var _elm_lang$core$Json_Encode$encode = _elm_lang$core$Native_Json.encode;
var _elm_lang$core$Json_Encode$Value = {ctor: 'Value'};

var _elm_lang$core$Json_Decode$null = _elm_lang$core$Native_Json.decodeNull;
var _elm_lang$core$Json_Decode$value = _elm_lang$core$Native_Json.decodePrimitive('value');
var _elm_lang$core$Json_Decode$andThen = _elm_lang$core$Native_Json.andThen;
var _elm_lang$core$Json_Decode$fail = _elm_lang$core$Native_Json.fail;
var _elm_lang$core$Json_Decode$succeed = _elm_lang$core$Native_Json.succeed;
var _elm_lang$core$Json_Decode$lazy = function (thunk) {
	return A2(
		_elm_lang$core$Json_Decode$andThen,
		thunk,
		_elm_lang$core$Json_Decode$succeed(
			{ctor: '_Tuple0'}));
};
var _elm_lang$core$Json_Decode$decodeValue = _elm_lang$core$Native_Json.run;
var _elm_lang$core$Json_Decode$decodeString = _elm_lang$core$Native_Json.runOnString;
var _elm_lang$core$Json_Decode$map8 = _elm_lang$core$Native_Json.map8;
var _elm_lang$core$Json_Decode$map7 = _elm_lang$core$Native_Json.map7;
var _elm_lang$core$Json_Decode$map6 = _elm_lang$core$Native_Json.map6;
var _elm_lang$core$Json_Decode$map5 = _elm_lang$core$Native_Json.map5;
var _elm_lang$core$Json_Decode$map4 = _elm_lang$core$Native_Json.map4;
var _elm_lang$core$Json_Decode$map3 = _elm_lang$core$Native_Json.map3;
var _elm_lang$core$Json_Decode$map2 = _elm_lang$core$Native_Json.map2;
var _elm_lang$core$Json_Decode$map = _elm_lang$core$Native_Json.map1;
var _elm_lang$core$Json_Decode$oneOf = _elm_lang$core$Native_Json.oneOf;
var _elm_lang$core$Json_Decode$maybe = function (decoder) {
	return A2(_elm_lang$core$Native_Json.decodeContainer, 'maybe', decoder);
};
var _elm_lang$core$Json_Decode$index = _elm_lang$core$Native_Json.decodeIndex;
var _elm_lang$core$Json_Decode$field = _elm_lang$core$Native_Json.decodeField;
var _elm_lang$core$Json_Decode$at = F2(
	function (fields, decoder) {
		return A3(_elm_lang$core$List$foldr, _elm_lang$core$Json_Decode$field, decoder, fields);
	});
var _elm_lang$core$Json_Decode$keyValuePairs = _elm_lang$core$Native_Json.decodeKeyValuePairs;
var _elm_lang$core$Json_Decode$dict = function (decoder) {
	return A2(
		_elm_lang$core$Json_Decode$map,
		_elm_lang$core$Dict$fromList,
		_elm_lang$core$Json_Decode$keyValuePairs(decoder));
};
var _elm_lang$core$Json_Decode$array = function (decoder) {
	return A2(_elm_lang$core$Native_Json.decodeContainer, 'array', decoder);
};
var _elm_lang$core$Json_Decode$list = function (decoder) {
	return A2(_elm_lang$core$Native_Json.decodeContainer, 'list', decoder);
};
var _elm_lang$core$Json_Decode$nullable = function (decoder) {
	return _elm_lang$core$Json_Decode$oneOf(
		{
			ctor: '::',
			_0: _elm_lang$core$Json_Decode$null(_elm_lang$core$Maybe$Nothing),
			_1: {
				ctor: '::',
				_0: A2(_elm_lang$core$Json_Decode$map, _elm_lang$core$Maybe$Just, decoder),
				_1: {ctor: '[]'}
			}
		});
};
var _elm_lang$core$Json_Decode$float = _elm_lang$core$Native_Json.decodePrimitive('float');
var _elm_lang$core$Json_Decode$int = _elm_lang$core$Native_Json.decodePrimitive('int');
var _elm_lang$core$Json_Decode$bool = _elm_lang$core$Native_Json.decodePrimitive('bool');
var _elm_lang$core$Json_Decode$string = _elm_lang$core$Native_Json.decodePrimitive('string');
var _elm_lang$core$Json_Decode$Decoder = {ctor: 'Decoder'};

var _elm_lang$core$Task$onError = _elm_lang$core$Native_Scheduler.onError;
var _elm_lang$core$Task$andThen = _elm_lang$core$Native_Scheduler.andThen;
var _elm_lang$core$Task$spawnCmd = F2(
	function (router, _p0) {
		var _p1 = _p0;
		return _elm_lang$core$Native_Scheduler.spawn(
			A2(
				_elm_lang$core$Task$andThen,
				_elm_lang$core$Platform$sendToApp(router),
				_p1._0));
	});
var _elm_lang$core$Task$fail = _elm_lang$core$Native_Scheduler.fail;
var _elm_lang$core$Task$mapError = F2(
	function (convert, task) {
		return A2(
			_elm_lang$core$Task$onError,
			function (_p2) {
				return _elm_lang$core$Task$fail(
					convert(_p2));
			},
			task);
	});
var _elm_lang$core$Task$succeed = _elm_lang$core$Native_Scheduler.succeed;
var _elm_lang$core$Task$map = F2(
	function (func, taskA) {
		return A2(
			_elm_lang$core$Task$andThen,
			function (a) {
				return _elm_lang$core$Task$succeed(
					func(a));
			},
			taskA);
	});
var _elm_lang$core$Task$map2 = F3(
	function (func, taskA, taskB) {
		return A2(
			_elm_lang$core$Task$andThen,
			function (a) {
				return A2(
					_elm_lang$core$Task$andThen,
					function (b) {
						return _elm_lang$core$Task$succeed(
							A2(func, a, b));
					},
					taskB);
			},
			taskA);
	});
var _elm_lang$core$Task$map3 = F4(
	function (func, taskA, taskB, taskC) {
		return A2(
			_elm_lang$core$Task$andThen,
			function (a) {
				return A2(
					_elm_lang$core$Task$andThen,
					function (b) {
						return A2(
							_elm_lang$core$Task$andThen,
							function (c) {
								return _elm_lang$core$Task$succeed(
									A3(func, a, b, c));
							},
							taskC);
					},
					taskB);
			},
			taskA);
	});
var _elm_lang$core$Task$map4 = F5(
	function (func, taskA, taskB, taskC, taskD) {
		return A2(
			_elm_lang$core$Task$andThen,
			function (a) {
				return A2(
					_elm_lang$core$Task$andThen,
					function (b) {
						return A2(
							_elm_lang$core$Task$andThen,
							function (c) {
								return A2(
									_elm_lang$core$Task$andThen,
									function (d) {
										return _elm_lang$core$Task$succeed(
											A4(func, a, b, c, d));
									},
									taskD);
							},
							taskC);
					},
					taskB);
			},
			taskA);
	});
var _elm_lang$core$Task$map5 = F6(
	function (func, taskA, taskB, taskC, taskD, taskE) {
		return A2(
			_elm_lang$core$Task$andThen,
			function (a) {
				return A2(
					_elm_lang$core$Task$andThen,
					function (b) {
						return A2(
							_elm_lang$core$Task$andThen,
							function (c) {
								return A2(
									_elm_lang$core$Task$andThen,
									function (d) {
										return A2(
											_elm_lang$core$Task$andThen,
											function (e) {
												return _elm_lang$core$Task$succeed(
													A5(func, a, b, c, d, e));
											},
											taskE);
									},
									taskD);
							},
							taskC);
					},
					taskB);
			},
			taskA);
	});
var _elm_lang$core$Task$sequence = function (tasks) {
	var _p3 = tasks;
	if (_p3.ctor === '[]') {
		return _elm_lang$core$Task$succeed(
			{ctor: '[]'});
	} else {
		return A3(
			_elm_lang$core$Task$map2,
			F2(
				function (x, y) {
					return {ctor: '::', _0: x, _1: y};
				}),
			_p3._0,
			_elm_lang$core$Task$sequence(_p3._1));
	}
};
var _elm_lang$core$Task$onEffects = F3(
	function (router, commands, state) {
		return A2(
			_elm_lang$core$Task$map,
			function (_p4) {
				return {ctor: '_Tuple0'};
			},
			_elm_lang$core$Task$sequence(
				A2(
					_elm_lang$core$List$map,
					_elm_lang$core$Task$spawnCmd(router),
					commands)));
	});
var _elm_lang$core$Task$init = _elm_lang$core$Task$succeed(
	{ctor: '_Tuple0'});
var _elm_lang$core$Task$onSelfMsg = F3(
	function (_p7, _p6, _p5) {
		return _elm_lang$core$Task$succeed(
			{ctor: '_Tuple0'});
	});
var _elm_lang$core$Task$command = _elm_lang$core$Native_Platform.leaf('Task');
var _elm_lang$core$Task$Perform = function (a) {
	return {ctor: 'Perform', _0: a};
};
var _elm_lang$core$Task$perform = F2(
	function (toMessage, task) {
		return _elm_lang$core$Task$command(
			_elm_lang$core$Task$Perform(
				A2(_elm_lang$core$Task$map, toMessage, task)));
	});
var _elm_lang$core$Task$attempt = F2(
	function (resultToMessage, task) {
		return _elm_lang$core$Task$command(
			_elm_lang$core$Task$Perform(
				A2(
					_elm_lang$core$Task$onError,
					function (_p8) {
						return _elm_lang$core$Task$succeed(
							resultToMessage(
								_elm_lang$core$Result$Err(_p8)));
					},
					A2(
						_elm_lang$core$Task$andThen,
						function (_p9) {
							return _elm_lang$core$Task$succeed(
								resultToMessage(
									_elm_lang$core$Result$Ok(_p9)));
						},
						task))));
	});
var _elm_lang$core$Task$cmdMap = F2(
	function (tagger, _p10) {
		var _p11 = _p10;
		return _elm_lang$core$Task$Perform(
			A2(_elm_lang$core$Task$map, tagger, _p11._0));
	});
_elm_lang$core$Native_Platform.effectManagers['Task'] = {pkg: 'elm-lang/core', init: _elm_lang$core$Task$init, onEffects: _elm_lang$core$Task$onEffects, onSelfMsg: _elm_lang$core$Task$onSelfMsg, tag: 'cmd', cmdMap: _elm_lang$core$Task$cmdMap};

//import Native.Scheduler //

var _elm_lang$core$Native_Time = function() {

var now = _elm_lang$core$Native_Scheduler.nativeBinding(function(callback)
{
	callback(_elm_lang$core$Native_Scheduler.succeed(Date.now()));
});

function setInterval_(interval, task)
{
	return _elm_lang$core$Native_Scheduler.nativeBinding(function(callback)
	{
		var id = setInterval(function() {
			_elm_lang$core$Native_Scheduler.rawSpawn(task);
		}, interval);

		return function() { clearInterval(id); };
	});
}

return {
	now: now,
	setInterval_: F2(setInterval_)
};

}();
var _elm_lang$core$Time$setInterval = _elm_lang$core$Native_Time.setInterval_;
var _elm_lang$core$Time$spawnHelp = F3(
	function (router, intervals, processes) {
		var _p0 = intervals;
		if (_p0.ctor === '[]') {
			return _elm_lang$core$Task$succeed(processes);
		} else {
			var _p1 = _p0._0;
			var spawnRest = function (id) {
				return A3(
					_elm_lang$core$Time$spawnHelp,
					router,
					_p0._1,
					A3(_elm_lang$core$Dict$insert, _p1, id, processes));
			};
			var spawnTimer = _elm_lang$core$Native_Scheduler.spawn(
				A2(
					_elm_lang$core$Time$setInterval,
					_p1,
					A2(_elm_lang$core$Platform$sendToSelf, router, _p1)));
			return A2(_elm_lang$core$Task$andThen, spawnRest, spawnTimer);
		}
	});
var _elm_lang$core$Time$addMySub = F2(
	function (_p2, state) {
		var _p3 = _p2;
		var _p6 = _p3._1;
		var _p5 = _p3._0;
		var _p4 = A2(_elm_lang$core$Dict$get, _p5, state);
		if (_p4.ctor === 'Nothing') {
			return A3(
				_elm_lang$core$Dict$insert,
				_p5,
				{
					ctor: '::',
					_0: _p6,
					_1: {ctor: '[]'}
				},
				state);
		} else {
			return A3(
				_elm_lang$core$Dict$insert,
				_p5,
				{ctor: '::', _0: _p6, _1: _p4._0},
				state);
		}
	});
var _elm_lang$core$Time$inMilliseconds = function (t) {
	return t;
};
var _elm_lang$core$Time$millisecond = 1;
var _elm_lang$core$Time$second = 1000 * _elm_lang$core$Time$millisecond;
var _elm_lang$core$Time$minute = 60 * _elm_lang$core$Time$second;
var _elm_lang$core$Time$hour = 60 * _elm_lang$core$Time$minute;
var _elm_lang$core$Time$inHours = function (t) {
	return t / _elm_lang$core$Time$hour;
};
var _elm_lang$core$Time$inMinutes = function (t) {
	return t / _elm_lang$core$Time$minute;
};
var _elm_lang$core$Time$inSeconds = function (t) {
	return t / _elm_lang$core$Time$second;
};
var _elm_lang$core$Time$now = _elm_lang$core$Native_Time.now;
var _elm_lang$core$Time$onSelfMsg = F3(
	function (router, interval, state) {
		var _p7 = A2(_elm_lang$core$Dict$get, interval, state.taggers);
		if (_p7.ctor === 'Nothing') {
			return _elm_lang$core$Task$succeed(state);
		} else {
			var tellTaggers = function (time) {
				return _elm_lang$core$Task$sequence(
					A2(
						_elm_lang$core$List$map,
						function (tagger) {
							return A2(
								_elm_lang$core$Platform$sendToApp,
								router,
								tagger(time));
						},
						_p7._0));
			};
			return A2(
				_elm_lang$core$Task$andThen,
				function (_p8) {
					return _elm_lang$core$Task$succeed(state);
				},
				A2(_elm_lang$core$Task$andThen, tellTaggers, _elm_lang$core$Time$now));
		}
	});
var _elm_lang$core$Time$subscription = _elm_lang$core$Native_Platform.leaf('Time');
var _elm_lang$core$Time$State = F2(
	function (a, b) {
		return {taggers: a, processes: b};
	});
var _elm_lang$core$Time$init = _elm_lang$core$Task$succeed(
	A2(_elm_lang$core$Time$State, _elm_lang$core$Dict$empty, _elm_lang$core$Dict$empty));
var _elm_lang$core$Time$onEffects = F3(
	function (router, subs, _p9) {
		var _p10 = _p9;
		var rightStep = F3(
			function (_p12, id, _p11) {
				var _p13 = _p11;
				return {
					ctor: '_Tuple3',
					_0: _p13._0,
					_1: _p13._1,
					_2: A2(
						_elm_lang$core$Task$andThen,
						function (_p14) {
							return _p13._2;
						},
						_elm_lang$core$Native_Scheduler.kill(id))
				};
			});
		var bothStep = F4(
			function (interval, taggers, id, _p15) {
				var _p16 = _p15;
				return {
					ctor: '_Tuple3',
					_0: _p16._0,
					_1: A3(_elm_lang$core$Dict$insert, interval, id, _p16._1),
					_2: _p16._2
				};
			});
		var leftStep = F3(
			function (interval, taggers, _p17) {
				var _p18 = _p17;
				return {
					ctor: '_Tuple3',
					_0: {ctor: '::', _0: interval, _1: _p18._0},
					_1: _p18._1,
					_2: _p18._2
				};
			});
		var newTaggers = A3(_elm_lang$core$List$foldl, _elm_lang$core$Time$addMySub, _elm_lang$core$Dict$empty, subs);
		var _p19 = A6(
			_elm_lang$core$Dict$merge,
			leftStep,
			bothStep,
			rightStep,
			newTaggers,
			_p10.processes,
			{
				ctor: '_Tuple3',
				_0: {ctor: '[]'},
				_1: _elm_lang$core$Dict$empty,
				_2: _elm_lang$core$Task$succeed(
					{ctor: '_Tuple0'})
			});
		var spawnList = _p19._0;
		var existingDict = _p19._1;
		var killTask = _p19._2;
		return A2(
			_elm_lang$core$Task$andThen,
			function (newProcesses) {
				return _elm_lang$core$Task$succeed(
					A2(_elm_lang$core$Time$State, newTaggers, newProcesses));
			},
			A2(
				_elm_lang$core$Task$andThen,
				function (_p20) {
					return A3(_elm_lang$core$Time$spawnHelp, router, spawnList, existingDict);
				},
				killTask));
	});
var _elm_lang$core$Time$Every = F2(
	function (a, b) {
		return {ctor: 'Every', _0: a, _1: b};
	});
var _elm_lang$core$Time$every = F2(
	function (interval, tagger) {
		return _elm_lang$core$Time$subscription(
			A2(_elm_lang$core$Time$Every, interval, tagger));
	});
var _elm_lang$core$Time$subMap = F2(
	function (f, _p21) {
		var _p22 = _p21;
		return A2(
			_elm_lang$core$Time$Every,
			_p22._0,
			function (_p23) {
				return f(
					_p22._1(_p23));
			});
	});
_elm_lang$core$Native_Platform.effectManagers['Time'] = {pkg: 'elm-lang/core', init: _elm_lang$core$Time$init, onEffects: _elm_lang$core$Time$onEffects, onSelfMsg: _elm_lang$core$Time$onSelfMsg, tag: 'sub', subMap: _elm_lang$core$Time$subMap};

var _lorenzo$elm_webdriver$Native_Webdriver = function() {
  var path = require('path');
  var fs = require('fs');
  var webdriverio = requireWebdriverio(process.cwd());

  var nativeBinding = _elm_lang$core$Native_Scheduler.nativeBinding;
  var succeed = _elm_lang$core$Native_Scheduler.succeed;
  var fail = _elm_lang$core$Native_Scheduler.fail;
  var tuple2 = _elm_lang$core$Native_Utils.Tuple2;
  var unit = {ctor: '_Tuple0'};
  var arrayFromList = _elm_lang$core$Native_List.toArray;

	function requireWebdriverio(cwd) {
		try {
			fs.accessSync(path.join(cwd, 'node_modules'));
			return require(path.resolve(cwd, 'node_modules', 'webdriverio'));
		} catch (e) {
			var lastSlashIndex = cwd.lastIndexOf('/');
      if (e.code === 'MODULE_NOT_FOUND' || lastSlashIndex === 0) {
        throw e;
			}
			var previousDir = cwd.slice(0, lastSlashIndex);
      return requireWebdriverio(previousDir);
		}
	}

  function catchPromise(callback, context, promise) {
      return promise.catch(function (error) {
        handleError(error, callback, context);
      });
  }

  function unitReturningExecute(callback, promise, context) {
      return catchPromise(callback, context, promise.then(function () {
        callback(succeed(unit));
      }));
  }

  function arity1ReturningExecute(callback, promise, context) {
      return catchPromise(callback, context, promise.then(function (a) {
        callback(succeed(a));
      }));
  }

  function maybeReturningExecute(callback, promise, context) {
      return catchPromise(callback, context, promise.then(function (a) {
        if (a !== null && typeof a === "object" && 'value' in a) {
          a = a.value;
        }

        if (a === null) {
          callback(succeed(_elm_lang$core$Maybe$Nothing));
        } else {
          callback(succeed(_elm_lang$core$Maybe$Just(a)));
        }
      }));
  }

  function open(options) {
    return nativeBinding(function (callback) {
      webdriverio.remote(options).init().then(function (browser) {
        callback(succeed(tuple2(browser.sessionId, this)));
      });
    });
  }

  function url(address, client) {
    return nativeBinding(function (callback) {
      var promise = client
        .url(address)
        .catch(function (error) {
          callback(fail({
            ctor: 'ConnectionError',
            _0: {
              errorType: error.type,
              message: error.message,
            },
            _1: error.screenshot,
          }));
        })
        unitReturningExecute(callback, promise, {});
    });
  }

  function click(selector, client) {
    return nativeBinding(function (c) {
      unitReturningExecute(c, client.click(selector), {selector: selector});
    });
  }

  function moveToObjectWithOffset(selector, x, y, client) {
    if (x.ctor === "Nothing") {
      x = undefined;
    } else {
      x = x._0;
    }

    if (y.ctor === "Nothing") {
      y = undefined;
    } else {
      y = y._0;
    }

    return nativeBinding(function (c) {
      unitReturningExecute(c, client.moveToObject(selector, x, y), {selector: selector});
    });
  }

  function close(client) {
    return nativeBinding(function (c) {
      unitReturningExecute(c, client.close(), {});
    });
  }

  function debug(client) {
    return nativeBinding(function (c) {
      unitReturningExecute(c, client.debug(), {});
    });
  }

  function setValue(selector, value, client) {
    return nativeBinding(function (c) {
      unitReturningExecute(c, client.setValue(selector, value), {selector: selector});
    });
  }

  function addValue(selector, value, client) {
    return nativeBinding(function (c) {
      unitReturningExecute(c, client.addValue(selector, value), {selector: selector});
    });
  }

  function clearElement(selector, client) {
    return nativeBinding(function (c) {
      unitReturningExecute(c, client.clearElement(selector), {selector: selector});
    });
  }

  function selectByIndex(selector, index, client) {
    return nativeBinding(function (c) {
      unitReturningExecute(c, client.selectByIndex(selector, index), {selector: selector});
    });
  }

  function selectByValue(selector, value, client) {
    return nativeBinding(function (c) {
      unitReturningExecute(c, client.selectByValue(selector, value), {selector: selector});
    });
  }

  function selectByText(selector, text, client) {
    return nativeBinding(function (c) {
      unitReturningExecute(c, client.selectByVisibleText(selector, text), {selector: selector});
    });
  }

  function selectByAttribute(selector, attribute, value, client) {
    return nativeBinding(function (c) {
      unitReturningExecute(c, client.selectByAttribute(selector, attribute, value), {selector: selector});
    });
  }

  function submitForm(selector, client) {
    return nativeBinding(function (c) {
      unitReturningExecute(c, client.submitForm(selector), {selector: selector});
    });
  }

  function waitForExist(selector, ms, reverse, client) {
    return nativeBinding(function (c) {
      unitReturningExecute(c, client.waitForExist(selector, ms, reverse), {selector: selector});
    });
  }

  function waitForVisible(selector, ms, reverse, client) {
    return nativeBinding(function (c) {
      unitReturningExecute(c, client.waitForVisible(selector, ms, reverse), {selector: selector});
    });
  }

  function waitForText(selector, ms, reverse, client) {
    return nativeBinding(function (c) {
      unitReturningExecute(c, client.waitForText(selector, ms, reverse), {selector: selector});
    });
  }


  function waitForSelected(selector, ms, reverse, client) {
    return nativeBinding(function (c) {
      unitReturningExecute(c, client.waitForSelected(selector, ms, reverse), {selector: selector});
    });
  }

  function waitForValue(selector, ms, reverse, client) {
    return nativeBinding(function (c) {
      unitReturningExecute(c, client.waitForValue(selector, ms, reverse), {selector: selector});
    });
  }

  function waitForEnabled(selector, ms, reverse, client) {
    return nativeBinding(function (c) {
      unitReturningExecute(c, client.waitForEnabled(selector, ms, reverse), {selector: selector});
    });
  }

  function end(client) {
    return nativeBinding(function (c) {
      unitReturningExecute(c, client.end(), {});
    });
  }

  function pause(ms, client) {
    return nativeBinding(function (c) {
      unitReturningExecute(c, client.pause(ms), {});
    });
  }

  function scrollToElement(selector, offsetX, offsetY, client) {
    return nativeBinding(function (c) {
      unitReturningExecute(c, client.scroll(selector, x, y), {selector: selector});
    });
  }

  function scrollWindow(x, y, client) {
    return nativeBinding(function (c) {
      unitReturningExecute(c, client.scroll(x, y), {});
    });
  }

  function pageScreenshot(client) {
    return nativeBinding(function (c) {
      arity1ReturningExecute(c, client.saveScreenshot().then(function (screenshot) {
        return screenshot.value;
      }), {});
    });
  }

  function savePageScreenshot(file, client) {
    return nativeBinding(function (c) {
      unitReturningExecute(c, client.saveScreenshot(file), {});
    });
  }

  function viewportScreenshot(client) {
    return nativeBinding(function (c) {
      arity1ReturningExecute(c, client.screenshot().then(function (screenshot) {
        return screenshot.value;
      }), {});
    });
  }


  function frame(index, client) {
    return nativeBinding(function (c) {
      unitReturningExecute(c, client.frame(index), {});
    });
  }

  function back(client) {
    return nativeBinding(function (c) {
      unitReturningExecute(c, client.back(), {});
    });
  }

  function forward(client) {
    return nativeBinding(function (c) {
      unitReturningExecute(c, client.forward(), {});
    });
  }

  function getUrl(client) {
    return nativeBinding(function (c) {
      arity1ReturningExecute(c, client.getUrl(), {});
    });
  }

  function getCookie(name, client) {
    return nativeBinding(function (c) {
      maybeReturningExecute(c, client.getCookie(name), {});
    });
  }

  function setCookie(name, value, client) {
    return nativeBinding(function (c) {
      unitReturningExecute(c, client.setCookie({name: name, value: value}), {});
    });
  }

  function deleteCookie(name, client) {
    return nativeBinding(function (c) {
      unitReturningExecute(c, client.deleteCookie(name), {});
    });
  }

  function getAttribute(selector, name, client) {
    return nativeBinding(function (c) {
      maybeReturningExecute(c, client.getAttribute(selector, name), {selector: selector});
    });
  }

  function getCssProperty(selector, name, client) {
    return nativeBinding(function (c) {
      maybeReturningExecute(c, client.getCssProperty(selector, name), {selector: selector});
    });
  }

  function getHTML(selector, client) {
    return nativeBinding(function (c) {
      arity1ReturningExecute(c, client.getHTML(selector), {selector: selector});
    });
  }

  function getSource(client) {
    return nativeBinding(function (c) {
      arity1ReturningExecute(c, client.getSource(), {});
    });
  }

  function getTitle(client) {
    return nativeBinding(function (c) {
      arity1ReturningExecute(c, client.getTitle(), {});
    });
  }

  function getText(selector, client) {
    return nativeBinding(function (c) {
      arity1ReturningExecute(c, client.getText(selector), {selector: selector});
    });
  }

  function getValue(selector, client) {
    return nativeBinding(function (c) {
      arity1ReturningExecute(c, client.getValue(selector), {selector: selector});
    });
  }

  function isExisting(selector, client) {
    return nativeBinding(function (c) {
      arity1ReturningExecute(c, client.isExisting(selector), {selector: selector});
    });
  }

  function isEnabled(selector, client) {
    return nativeBinding(function (c) {
      arity1ReturningExecute(c, client.isEnabled(selector), {selector: selector});
    });
  }

  function isVisible(selector, client) {
    return nativeBinding(function (c) {
      arity1ReturningExecute(c, client.isVisible(selector), {selector: selector});
    });
  }

  function isSelected(selector, client) {
    return nativeBinding(function (c) {
      arity1ReturningExecute(c, client.isSelected(selector), {selector: selector});
    });
  }

  function isVisibleWithinViewport(selector, client) {
    return nativeBinding(function (c) {
      arity1ReturningExecute(c, client.isVisibleWithinViewport(selector), {selector: selector});
    });
  }

  function triggerClick(selector, client) {
    return nativeBinding(function (c) {
      var promise = client.selectorExecute(selector, function (elements) {
        for (var i = 0; i < elements.length; i++) {
          elements[i].click();
        }
      });
      unitReturningExecute(c, promise, {selector: selector});
    });
  }

  function getElementSize(selector, client) {
    return nativeBinding(function (c) {
      arity1ReturningExecute(c, client.getElementSize(selector), {selector: selector});
    });
  }

  function getLocation(selector, client) {
    return nativeBinding(function (c) {
      arity1ReturningExecute(c, client.getLocation(selector), {selector: selector});
    });
  }

  function getLocationInView(selector, client) {
    return nativeBinding(function (c) {
      arity1ReturningExecute(c, client.getLocationInView(selector), {selector: selector});
    });
  }

  function countElements(selector, client) {
    return nativeBinding(function (c) {
      var promise = client.selectorExecute(selector, function (elements) {
        return elements.length;
      });
      arity1ReturningExecute(c, promise, {selector: selector});
    });
  }

  function customCommand(name, args, client) {
    return nativeBinding(function (c) {
      if (typeof client[name]  === "undefined") {
        return handleError({type: "InvalidCommand", "message" : "Unknown custom command: < " + name + " >"}, c,  {});
      }

      arity1ReturningExecute(c, client[name].call(client, args), {});
    });
  }

  function executeScriptArity0(script, client) {
    return nativeBinding(function (c) {
      unitReturningExecute(c, client.execute(script), {});
    });
  }

  function chooseFile(selector, localPath, client) {
    return nativeBinding(function (c) {
      unitReturningExecute(c, client.chooseFile(selector, localPath), {selector: selector});
    });
  }

  function buttonUp(button, client) {
    return nativeBinding(function (c) {
      unitReturningExecute(c, client.buttonUp(button), {});
    });
  }

  function buttonDown(button, client) {
    return nativeBinding(function (c) {
      unitReturningExecute(c, client.buttonDown(button), {});
    });
  }

  function windowResize(width, height, client) {
    return nativeBinding(function (c) {
      unitReturningExecute(c, client.windowHandleSize({width: width, height: height}), {});
    });
  }

  function keys(keys, client) {
    return nativeBinding(function (c) {
      unitReturningExecute(c, client.keys(arrayFromList(keys)), {});
    });
  }

  function handleError(error, callback, context) {
    var tag = {
      ctor: "UnknownError",
      _0: {
        errorType: error.type,
        message: error.message
      }
    };

    switch (error.type) {
        case "NoSuchElement" :
            tag.ctor = "MissingElement";
            context.selector = context.selector || "";
            break;

        case "WaitUntilTimeoutError" :
            tag.ctor = "FailedElementPrecondition";
            context.selector = context.selector || "";
            break;
        case "RuntimeError" :
            if (error.message.indexOf("Element is not clickable") === 0) {
              tag.ctor = "UnreachableElement";
            }
            context.selector = context.selector || "";
            tag._0.screenshot = error.screenshot;

        case "InvalidCommand" :
            tag.ctor = error.type;
    }

    tag._0 = Object.assign(tag._0, context);
    callback(fail(tag));
  }

  return {
    open: open,
    url: F2(url),
    click: F2(click),
    moveToObjectWithOffset: F4(moveToObjectWithOffset),
    close: close,
    debug: debug,
    setValue: F3(setValue),
    addValue: F3(addValue),
    clearValue: F2(clearElement),
    selectByIndex: F3(selectByIndex),
    selectByValue: F3(selectByValue),
    selectByText: F3(selectByText),
    selectByAttribute: F4(selectByAttribute),
    submitForm: F2(submitForm),
    setCookie: F3(setCookie),
    deleteCookie: F2(deleteCookie),
    waitForExist: F4(waitForExist),
    waitForValue: F4(waitForValue),
    waitForSelected: F4(waitForSelected),
    waitForText: F4(waitForText),
    waitForVisible: F4(waitForVisible),
    waitForEnabled: F4(waitForEnabled),
    end: end,
    pause: F2(pause),
    scrollToElement: F4(scrollToElement),
    scrollWindow: F3(scrollWindow),
    viewportScreenshot: viewportScreenshot,
    pageScreenshot: pageScreenshot,
    savePageScreenshot: F2(savePageScreenshot),
    frame: F2(frame),
    triggerClick: F2(triggerClick),
    back: back,
    forward: forward,
    getUrl: getUrl,
    getCookie: F2(getCookie),
    getAttribute: F3(getAttribute),
    getCssProperty: F3(getCssProperty),
    getHTML: F2(getHTML),
    getSource: getSource,
    getTitle: getTitle,
    getText: F2(getText),
    getValue: F2(getValue),
    isExisting: F2(isExisting),
    isEnabled: F2(isEnabled),
    isVisible: F2(isVisible),
    isVisibleWithinViewport: F2(isVisibleWithinViewport),
    isSelected: F2(isSelected),
    getElementSize: F2(getElementSize),
    getLocation: F2(getLocation),
    getLocationInView: F2(getLocationInView),
    countElements: F2(countElements),
    customCommand: F3(customCommand),
    executeScriptArity0: F2(executeScriptArity0),
    chooseFile: F3(chooseFile),
    buttonUp: F2(buttonUp),
    buttonDown: F2(buttonDown),
    windowResize: F3(windowResize),
    keys: F2(keys)
  };
}();

var _lorenzo$elm_webdriver$Webdriver_LowLevel$windowResize = _lorenzo$elm_webdriver$Native_Webdriver.windowResize;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$chooseFile = _lorenzo$elm_webdriver$Native_Webdriver.chooseFile;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$executeScriptArity0 = _lorenzo$elm_webdriver$Native_Webdriver.executeScriptArity0;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$customCommand = _lorenzo$elm_webdriver$Native_Webdriver.customCommand;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$countElements = _lorenzo$elm_webdriver$Native_Webdriver.countElements;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$optionIsSelected = _lorenzo$elm_webdriver$Native_Webdriver.isSelected;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$elementVisibleWithinViewport = _lorenzo$elm_webdriver$Native_Webdriver.isVisibleWithinViewport;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$elementVisible = _lorenzo$elm_webdriver$Native_Webdriver.isVisible;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$elementEnabled = _lorenzo$elm_webdriver$Native_Webdriver.isEnabled;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$elementExists = _lorenzo$elm_webdriver$Native_Webdriver.isExisting;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$getValue = _lorenzo$elm_webdriver$Native_Webdriver.getValue;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$getTitle = _lorenzo$elm_webdriver$Native_Webdriver.getTitle;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$getText = _lorenzo$elm_webdriver$Native_Webdriver.getText;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$getPageHTML = _lorenzo$elm_webdriver$Native_Webdriver.getSource;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$getElementViewPosition = _lorenzo$elm_webdriver$Native_Webdriver.getLocationInView;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$getElementPosition = _lorenzo$elm_webdriver$Native_Webdriver.getLocation;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$getElementHTML = _lorenzo$elm_webdriver$Native_Webdriver.getHTML;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$getElementSize = _lorenzo$elm_webdriver$Native_Webdriver.getElementSize;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$getCssProperty = _lorenzo$elm_webdriver$Native_Webdriver.getCssProperty;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$getAttribute = _lorenzo$elm_webdriver$Native_Webdriver.getAttribute;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$getCookie = _lorenzo$elm_webdriver$Native_Webdriver.getCookie;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$cookieExists = F2(
	function (name, browser) {
		return A2(
			_elm_lang$core$Task$map,
			function (res) {
				return _elm_lang$core$Native_Utils.eq(res, _elm_lang$core$Maybe$Nothing) ? false : true;
			},
			A2(_lorenzo$elm_webdriver$Webdriver_LowLevel$getCookie, name, browser));
	});
var _lorenzo$elm_webdriver$Webdriver_LowLevel$getUrl = _lorenzo$elm_webdriver$Native_Webdriver.getUrl;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$forward = _lorenzo$elm_webdriver$Native_Webdriver.forward;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$back = _lorenzo$elm_webdriver$Native_Webdriver.back;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$triggerClick = _lorenzo$elm_webdriver$Native_Webdriver.triggerClick;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$switchToFrame = _lorenzo$elm_webdriver$Native_Webdriver.frame;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$viewportScreenshot = _lorenzo$elm_webdriver$Native_Webdriver.viewportScreenshot;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$savePageScreenshot = _lorenzo$elm_webdriver$Native_Webdriver.savePageScreenshot;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$pageScreenshot = _lorenzo$elm_webdriver$Native_Webdriver.pageScreenshot;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$scrollWindow = _lorenzo$elm_webdriver$Native_Webdriver.scrollWindow;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$scrollToElementOffset = _lorenzo$elm_webdriver$Native_Webdriver.scrollToElement;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$scrollToElement = F2(
	function (selector, browser) {
		return A4(_lorenzo$elm_webdriver$Webdriver_LowLevel$scrollToElementOffset, selector, 0, 0, browser);
	});
var _lorenzo$elm_webdriver$Webdriver_LowLevel$pause = _lorenzo$elm_webdriver$Native_Webdriver.pause;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$end = _lorenzo$elm_webdriver$Native_Webdriver.end;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$waitForNotEnabled = F3(
	function (selector, ms, browser) {
		return A4(_lorenzo$elm_webdriver$Native_Webdriver.waitForEnabled, selector, ms, true, browser);
	});
var _lorenzo$elm_webdriver$Webdriver_LowLevel$waitForEnabled = F3(
	function (selector, ms, browser) {
		return A4(_lorenzo$elm_webdriver$Native_Webdriver.waitForEnabled, selector, ms, false, browser);
	});
var _lorenzo$elm_webdriver$Webdriver_LowLevel$waitForNoText = F3(
	function (selector, ms, browser) {
		return A4(_lorenzo$elm_webdriver$Native_Webdriver.waitForText, selector, ms, true, browser);
	});
var _lorenzo$elm_webdriver$Webdriver_LowLevel$waitForText = F3(
	function (selector, ms, browser) {
		return A4(_lorenzo$elm_webdriver$Native_Webdriver.waitForText, selector, ms, false, browser);
	});
var _lorenzo$elm_webdriver$Webdriver_LowLevel$waitForNotSelected = F3(
	function (selector, ms, browser) {
		return A4(_lorenzo$elm_webdriver$Native_Webdriver.waitForSelected, selector, ms, true, browser);
	});
var _lorenzo$elm_webdriver$Webdriver_LowLevel$waitForSelected = F3(
	function (selector, ms, browser) {
		return A4(_lorenzo$elm_webdriver$Native_Webdriver.waitForSelected, selector, ms, false, browser);
	});
var _lorenzo$elm_webdriver$Webdriver_LowLevel$waitForNoValue = F3(
	function (selector, ms, browser) {
		return A4(_lorenzo$elm_webdriver$Native_Webdriver.waitForValue, selector, ms, true, browser);
	});
var _lorenzo$elm_webdriver$Webdriver_LowLevel$waitForValue = F3(
	function (selector, ms, browser) {
		return A4(_lorenzo$elm_webdriver$Native_Webdriver.waitForValue, selector, ms, false, browser);
	});
var _lorenzo$elm_webdriver$Webdriver_LowLevel$waitForNotVisible = F3(
	function (selector, ms, browser) {
		return A4(_lorenzo$elm_webdriver$Native_Webdriver.waitForVisible, selector, ms, true, browser);
	});
var _lorenzo$elm_webdriver$Webdriver_LowLevel$waitForVisible = F3(
	function (selector, ms, browser) {
		return A4(_lorenzo$elm_webdriver$Native_Webdriver.waitForVisible, selector, ms, false, browser);
	});
var _lorenzo$elm_webdriver$Webdriver_LowLevel$waitForNotExist = F3(
	function (selector, ms, browser) {
		return A4(_lorenzo$elm_webdriver$Native_Webdriver.waitForExist, selector, ms, true, browser);
	});
var _lorenzo$elm_webdriver$Webdriver_LowLevel$waitForExist = F3(
	function (selector, ms, browser) {
		return A4(_lorenzo$elm_webdriver$Native_Webdriver.waitForExist, selector, ms, false, browser);
	});
var _lorenzo$elm_webdriver$Webdriver_LowLevel$deleteCookie = _lorenzo$elm_webdriver$Native_Webdriver.deleteCookie;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$setCookie = _lorenzo$elm_webdriver$Native_Webdriver.setCookie;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$submitForm = _lorenzo$elm_webdriver$Native_Webdriver.submitForm;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$selectByAttribute = _lorenzo$elm_webdriver$Native_Webdriver.selectByAttribute;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$selectByText = _lorenzo$elm_webdriver$Native_Webdriver.selectByText;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$selectByValue = _lorenzo$elm_webdriver$Native_Webdriver.selectByValue;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$selectByIndex = _lorenzo$elm_webdriver$Native_Webdriver.selectByIndex;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$clearValue = _lorenzo$elm_webdriver$Native_Webdriver.clearElement;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$appendValue = _lorenzo$elm_webdriver$Native_Webdriver.addValue;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$setValue = _lorenzo$elm_webdriver$Native_Webdriver.setValue;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$debug = _lorenzo$elm_webdriver$Native_Webdriver.debug;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$close = _lorenzo$elm_webdriver$Native_Webdriver.close;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$moveToWithOffset = _lorenzo$elm_webdriver$Native_Webdriver.moveToObjectWithOffset;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$moveTo = function (selector) {
	return A3(_lorenzo$elm_webdriver$Webdriver_LowLevel$moveToWithOffset, selector, _elm_lang$core$Maybe$Nothing, _elm_lang$core$Maybe$Nothing);
};
var _lorenzo$elm_webdriver$Webdriver_LowLevel$click = _lorenzo$elm_webdriver$Native_Webdriver.click;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$url = _lorenzo$elm_webdriver$Native_Webdriver.url;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$open = _lorenzo$elm_webdriver$Native_Webdriver.open;
var _lorenzo$elm_webdriver$Webdriver_LowLevel$keyToString = function (key) {
	var _p0 = key;
	if (_p0.ctor === 'ArrowDown') {
		return 'ArrowDown';
	} else {
		return 'Enter';
	}
};
var _lorenzo$elm_webdriver$Webdriver_LowLevel$keys = function (keys) {
	return _lorenzo$elm_webdriver$Native_Webdriver.keys(
		A2(_elm_lang$core$List$map, _lorenzo$elm_webdriver$Webdriver_LowLevel$keyToString, keys));
};
var _lorenzo$elm_webdriver$Webdriver_LowLevel$buttonToInt = function (button) {
	var _p1 = button;
	switch (_p1.ctor) {
		case 'Left':
			return 0;
		case 'Middle':
			return 1;
		default:
			return 2;
	}
};
var _lorenzo$elm_webdriver$Webdriver_LowLevel$buttonUp = function (button) {
	return _lorenzo$elm_webdriver$Native_Webdriver.buttonUp(
		_lorenzo$elm_webdriver$Webdriver_LowLevel$buttonToInt(button));
};
var _lorenzo$elm_webdriver$Webdriver_LowLevel$buttonDown = function (button) {
	return _lorenzo$elm_webdriver$Native_Webdriver.buttonDown(
		_lorenzo$elm_webdriver$Webdriver_LowLevel$buttonToInt(button));
};
var _lorenzo$elm_webdriver$Webdriver_LowLevel$Options = function (a) {
	return {desiredCapabilities: a};
};
var _lorenzo$elm_webdriver$Webdriver_LowLevel$Capabilities = function (a) {
	return {browserName: a};
};
var _lorenzo$elm_webdriver$Webdriver_LowLevel$Browser = {ctor: 'Browser'};
var _lorenzo$elm_webdriver$Webdriver_LowLevel$Never = {ctor: 'Never'};
var _lorenzo$elm_webdriver$Webdriver_LowLevel$InvalidCommand = function (a) {
	return {ctor: 'InvalidCommand', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_LowLevel$UnknownError = function (a) {
	return {ctor: 'UnknownError', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_LowLevel$FailedElementPrecondition = function (a) {
	return {ctor: 'FailedElementPrecondition', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_LowLevel$TooManyElements = function (a) {
	return {ctor: 'TooManyElements', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_LowLevel$UnreachableElement = function (a) {
	return {ctor: 'UnreachableElement', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_LowLevel$MissingElement = function (a) {
	return {ctor: 'MissingElement', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_LowLevel$ConnectionError = function (a) {
	return {ctor: 'ConnectionError', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_LowLevel$Right = {ctor: 'Right'};
var _lorenzo$elm_webdriver$Webdriver_LowLevel$Middle = {ctor: 'Middle'};
var _lorenzo$elm_webdriver$Webdriver_LowLevel$Left = {ctor: 'Left'};
var _lorenzo$elm_webdriver$Webdriver_LowLevel$Enter = {ctor: 'Enter'};
var _lorenzo$elm_webdriver$Webdriver_LowLevel$ArrowDown = {ctor: 'ArrowDown'};

var _lorenzo$elm_webdriver$Webdriver_Step$getMetaProperty = F2(
	function (getter, step) {
		var _p0 = step;
		switch (_p0.ctor) {
			case 'ReturningUnit':
				return getter(_p0._0);
			case 'BranchMaybe':
				return getter(_p0._0);
			case 'BranchString':
				return getter(_p0._0);
			case 'BranchBool':
				return getter(_p0._0);
			case 'BranchGeometry':
				return getter(_p0._0);
			case 'BranchInt':
				return getter(_p0._0);
			case 'BranchTask':
				return getter(_p0._0);
			case 'BranchWebdriver':
				return getter(_p0._0);
			case 'AssertionMaybe':
				return getter(_p0._0);
			case 'AssertionString':
				return getter(_p0._0);
			case 'AssertionBool':
				return getter(_p0._0);
			case 'AssertionGeometry':
				return getter(_p0._0);
			case 'AssertionInt':
				return getter(_p0._0);
			case 'AssertionTask':
				return getter(_p0._0);
			default:
				return getter(_p0._0);
		}
	});
var _lorenzo$elm_webdriver$Webdriver_Step$stepName = function (step) {
	return A2(
		_lorenzo$elm_webdriver$Webdriver_Step$getMetaProperty,
		function (_) {
			return _.name;
		},
		step);
};
var _lorenzo$elm_webdriver$Webdriver_Step$initMeta = function (name) {
	return {name: name, withScreenshot: false};
};
var _lorenzo$elm_webdriver$Webdriver_Step$Meta = F2(
	function (a, b) {
		return {name: a, withScreenshot: b};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$AssertionWebdriver = F2(
	function (a, b) {
		return {ctor: 'AssertionWebdriver', _0: a, _1: b};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$AssertionTask = F2(
	function (a, b) {
		return {ctor: 'AssertionTask', _0: a, _1: b};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$AssertionInt = F3(
	function (a, b, c) {
		return {ctor: 'AssertionInt', _0: a, _1: b, _2: c};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$AssertionGeometry = F3(
	function (a, b, c) {
		return {ctor: 'AssertionGeometry', _0: a, _1: b, _2: c};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$AssertionBool = F3(
	function (a, b, c) {
		return {ctor: 'AssertionBool', _0: a, _1: b, _2: c};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$AssertionString = F3(
	function (a, b, c) {
		return {ctor: 'AssertionString', _0: a, _1: b, _2: c};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$AssertionMaybe = F3(
	function (a, b, c) {
		return {ctor: 'AssertionMaybe', _0: a, _1: b, _2: c};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$BranchWebdriver = F2(
	function (a, b) {
		return {ctor: 'BranchWebdriver', _0: a, _1: b};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$BranchTask = F2(
	function (a, b) {
		return {ctor: 'BranchTask', _0: a, _1: b};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$BranchInt = F3(
	function (a, b, c) {
		return {ctor: 'BranchInt', _0: a, _1: b, _2: c};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$BranchGeometry = F3(
	function (a, b, c) {
		return {ctor: 'BranchGeometry', _0: a, _1: b, _2: c};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$BranchBool = F3(
	function (a, b, c) {
		return {ctor: 'BranchBool', _0: a, _1: b, _2: c};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$BranchString = F3(
	function (a, b, c) {
		return {ctor: 'BranchString', _0: a, _1: b, _2: c};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$BranchMaybe = F3(
	function (a, b, c) {
		return {ctor: 'BranchMaybe', _0: a, _1: b, _2: c};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$ReturningUnit = F2(
	function (a, b) {
		return {ctor: 'ReturningUnit', _0: a, _1: b};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$setMetaProperty = F2(
	function (setter, step) {
		var _p1 = step;
		switch (_p1.ctor) {
			case 'ReturningUnit':
				return A2(
					_lorenzo$elm_webdriver$Webdriver_Step$ReturningUnit,
					setter(_p1._0),
					_p1._1);
			case 'BranchMaybe':
				return A3(
					_lorenzo$elm_webdriver$Webdriver_Step$BranchMaybe,
					setter(_p1._0),
					_p1._1,
					_p1._2);
			case 'BranchString':
				return A3(
					_lorenzo$elm_webdriver$Webdriver_Step$BranchString,
					setter(_p1._0),
					_p1._1,
					_p1._2);
			case 'BranchBool':
				return A3(
					_lorenzo$elm_webdriver$Webdriver_Step$BranchBool,
					setter(_p1._0),
					_p1._1,
					_p1._2);
			case 'BranchGeometry':
				return A3(
					_lorenzo$elm_webdriver$Webdriver_Step$BranchGeometry,
					setter(_p1._0),
					_p1._1,
					_p1._2);
			case 'BranchInt':
				return A3(
					_lorenzo$elm_webdriver$Webdriver_Step$BranchInt,
					setter(_p1._0),
					_p1._1,
					_p1._2);
			case 'BranchTask':
				return A2(
					_lorenzo$elm_webdriver$Webdriver_Step$BranchTask,
					setter(_p1._0),
					_p1._1);
			case 'BranchWebdriver':
				return A2(
					_lorenzo$elm_webdriver$Webdriver_Step$BranchWebdriver,
					setter(_p1._0),
					_p1._1);
			case 'AssertionMaybe':
				return A3(
					_lorenzo$elm_webdriver$Webdriver_Step$AssertionMaybe,
					setter(_p1._0),
					_p1._1,
					_p1._2);
			case 'AssertionString':
				return A3(
					_lorenzo$elm_webdriver$Webdriver_Step$AssertionString,
					setter(_p1._0),
					_p1._1,
					_p1._2);
			case 'AssertionBool':
				return A3(
					_lorenzo$elm_webdriver$Webdriver_Step$AssertionBool,
					setter(_p1._0),
					_p1._1,
					_p1._2);
			case 'AssertionGeometry':
				return A3(
					_lorenzo$elm_webdriver$Webdriver_Step$AssertionGeometry,
					setter(_p1._0),
					_p1._1,
					_p1._2);
			case 'AssertionInt':
				return A3(
					_lorenzo$elm_webdriver$Webdriver_Step$AssertionInt,
					setter(_p1._0),
					_p1._1,
					_p1._2);
			case 'AssertionTask':
				return A2(
					_lorenzo$elm_webdriver$Webdriver_Step$AssertionTask,
					setter(_p1._0),
					_p1._1);
			default:
				return A2(
					_lorenzo$elm_webdriver$Webdriver_Step$AssertionWebdriver,
					setter(_p1._0),
					_p1._1);
		}
	});
var _lorenzo$elm_webdriver$Webdriver_Step$withName = F2(
	function (name, step) {
		return A2(
			_lorenzo$elm_webdriver$Webdriver_Step$setMetaProperty,
			function (meta) {
				return _elm_lang$core$Native_Utils.update(
					meta,
					{name: name});
			},
			step);
	});
var _lorenzo$elm_webdriver$Webdriver_Step$withScreenshot = F2(
	function (enable, step) {
		return A2(
			_lorenzo$elm_webdriver$Webdriver_Step$setMetaProperty,
			function (meta) {
				return _elm_lang$core$Native_Utils.update(
					meta,
					{withScreenshot: enable});
			},
			step);
	});
var _lorenzo$elm_webdriver$Webdriver_Step$Keys = function (a) {
	return {ctor: 'Keys', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_Step$WindowResize = F2(
	function (a, b) {
		return {ctor: 'WindowResize', _0: a, _1: b};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$End = {ctor: 'End'};
var _lorenzo$elm_webdriver$Webdriver_Step$Close = {ctor: 'Close'};
var _lorenzo$elm_webdriver$Webdriver_Step$TriggerClick = function (a) {
	return {ctor: 'TriggerClick', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_Step$SwitchFrame = function (a) {
	return {ctor: 'SwitchFrame', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_Step$SavePagecreenshot = function (a) {
	return {ctor: 'SavePagecreenshot', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_Step$Scroll = F2(
	function (a, b) {
		return {ctor: 'Scroll', _0: a, _1: b};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$ScrollTo = F3(
	function (a, b, c) {
		return {ctor: 'ScrollTo', _0: a, _1: b, _2: c};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$Pause = function (a) {
	return {ctor: 'Pause', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_Step$WaitForDebug = {ctor: 'WaitForDebug'};
var _lorenzo$elm_webdriver$Webdriver_Step$WaitForNotEnabled = F2(
	function (a, b) {
		return {ctor: 'WaitForNotEnabled', _0: a, _1: b};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$WaitForEnabled = F2(
	function (a, b) {
		return {ctor: 'WaitForEnabled', _0: a, _1: b};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$WaitForNoText = F2(
	function (a, b) {
		return {ctor: 'WaitForNoText', _0: a, _1: b};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$WaitForText = F2(
	function (a, b) {
		return {ctor: 'WaitForText', _0: a, _1: b};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$WaitForNotSelected = F2(
	function (a, b) {
		return {ctor: 'WaitForNotSelected', _0: a, _1: b};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$WaitForSelected = F2(
	function (a, b) {
		return {ctor: 'WaitForSelected', _0: a, _1: b};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$WaitForNoValue = F2(
	function (a, b) {
		return {ctor: 'WaitForNoValue', _0: a, _1: b};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$WaitForValue = F2(
	function (a, b) {
		return {ctor: 'WaitForValue', _0: a, _1: b};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$WaitForNotVisible = F2(
	function (a, b) {
		return {ctor: 'WaitForNotVisible', _0: a, _1: b};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$WaitForVisible = F2(
	function (a, b) {
		return {ctor: 'WaitForVisible', _0: a, _1: b};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$WaitForNotExist = F2(
	function (a, b) {
		return {ctor: 'WaitForNotExist', _0: a, _1: b};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$WaitForExist = F2(
	function (a, b) {
		return {ctor: 'WaitForExist', _0: a, _1: b};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$Submit = function (a) {
	return {ctor: 'Submit', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_Step$DeleteCookie = function (a) {
	return {ctor: 'DeleteCookie', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_Step$SetCookie = F2(
	function (a, b) {
		return {ctor: 'SetCookie', _0: a, _1: b};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$SelectByAttribute = F3(
	function (a, b, c) {
		return {ctor: 'SelectByAttribute', _0: a, _1: b, _2: c};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$SelectByText = F2(
	function (a, b) {
		return {ctor: 'SelectByText', _0: a, _1: b};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$SelectByIndex = F2(
	function (a, b) {
		return {ctor: 'SelectByIndex', _0: a, _1: b};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$SelectByValue = F2(
	function (a, b) {
		return {ctor: 'SelectByValue', _0: a, _1: b};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$SetValue = F2(
	function (a, b) {
		return {ctor: 'SetValue', _0: a, _1: b};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$ClearValue = function (a) {
	return {ctor: 'ClearValue', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_Step$AppendValue = F2(
	function (a, b) {
		return {ctor: 'AppendValue', _0: a, _1: b};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$MoveToWithOffset = F3(
	function (a, b, c) {
		return {ctor: 'MoveToWithOffset', _0: a, _1: b, _2: c};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$MoveTo = function (a) {
	return {ctor: 'MoveTo', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_Step$Click = function (a) {
	return {ctor: 'Click', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_Step$Visit = function (a) {
	return {ctor: 'Visit', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_Step$GetValue = function (a) {
	return {ctor: 'GetValue', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_Step$getValue = function (selector) {
	return _lorenzo$elm_webdriver$Webdriver_Step$GetValue(selector);
};
var _lorenzo$elm_webdriver$Webdriver_Step$GetText = function (a) {
	return {ctor: 'GetText', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_Step$getText = function (selector) {
	return _lorenzo$elm_webdriver$Webdriver_Step$GetText(selector);
};
var _lorenzo$elm_webdriver$Webdriver_Step$GetTitle = {ctor: 'GetTitle'};
var _lorenzo$elm_webdriver$Webdriver_Step$getTitle = _lorenzo$elm_webdriver$Webdriver_Step$GetTitle;
var _lorenzo$elm_webdriver$Webdriver_Step$GetSource = {ctor: 'GetSource'};
var _lorenzo$elm_webdriver$Webdriver_Step$getPageHTML = _lorenzo$elm_webdriver$Webdriver_Step$GetSource;
var _lorenzo$elm_webdriver$Webdriver_Step$GetHtml = function (a) {
	return {ctor: 'GetHtml', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_Step$getElementHTML = function (selector) {
	return _lorenzo$elm_webdriver$Webdriver_Step$GetHtml(selector);
};
var _lorenzo$elm_webdriver$Webdriver_Step$GetUrl = {ctor: 'GetUrl'};
var _lorenzo$elm_webdriver$Webdriver_Step$getUrl = _lorenzo$elm_webdriver$Webdriver_Step$GetUrl;
var _lorenzo$elm_webdriver$Webdriver_Step$GetCss = F2(
	function (a, b) {
		return {ctor: 'GetCss', _0: a, _1: b};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$getCssProperty = F2(
	function (selector, name) {
		return A2(_lorenzo$elm_webdriver$Webdriver_Step$GetCss, selector, name);
	});
var _lorenzo$elm_webdriver$Webdriver_Step$GetCookie = function (a) {
	return {ctor: 'GetCookie', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_Step$getCookie = function (name) {
	return _lorenzo$elm_webdriver$Webdriver_Step$GetCookie(name);
};
var _lorenzo$elm_webdriver$Webdriver_Step$GetAttribute = F2(
	function (a, b) {
		return {ctor: 'GetAttribute', _0: a, _1: b};
	});
var _lorenzo$elm_webdriver$Webdriver_Step$getAttribute = F2(
	function (selector, name) {
		return A2(_lorenzo$elm_webdriver$Webdriver_Step$GetAttribute, selector, name);
	});
var _lorenzo$elm_webdriver$Webdriver_Step$OptionSelected = function (a) {
	return {ctor: 'OptionSelected', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_Step$optionIsSelected = function (selector) {
	return _lorenzo$elm_webdriver$Webdriver_Step$OptionSelected(selector);
};
var _lorenzo$elm_webdriver$Webdriver_Step$ElementViewportVisible = function (a) {
	return {ctor: 'ElementViewportVisible', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_Step$elementVisibleWithinViewport = function (selector) {
	return _lorenzo$elm_webdriver$Webdriver_Step$ElementViewportVisible(selector);
};
var _lorenzo$elm_webdriver$Webdriver_Step$ElementVisible = function (a) {
	return {ctor: 'ElementVisible', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_Step$elementVisible = function (selector) {
	return _lorenzo$elm_webdriver$Webdriver_Step$ElementVisible(selector);
};
var _lorenzo$elm_webdriver$Webdriver_Step$ElementEnabled = function (a) {
	return {ctor: 'ElementEnabled', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_Step$elementEnabled = function (selector) {
	return _lorenzo$elm_webdriver$Webdriver_Step$ElementEnabled(selector);
};
var _lorenzo$elm_webdriver$Webdriver_Step$ElementExists = function (a) {
	return {ctor: 'ElementExists', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_Step$elementExists = function (selector) {
	return _lorenzo$elm_webdriver$Webdriver_Step$ElementExists(selector);
};
var _lorenzo$elm_webdriver$Webdriver_Step$CookieNotExists = function (a) {
	return {ctor: 'CookieNotExists', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_Step$cookieNotExists = function (name) {
	return _lorenzo$elm_webdriver$Webdriver_Step$CookieNotExists(name);
};
var _lorenzo$elm_webdriver$Webdriver_Step$CookieExists = function (a) {
	return {ctor: 'CookieExists', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_Step$cookieExists = function (name) {
	return _lorenzo$elm_webdriver$Webdriver_Step$CookieExists(name);
};
var _lorenzo$elm_webdriver$Webdriver_Step$GetElementSize = function (a) {
	return {ctor: 'GetElementSize', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_Step$getElementSize = function (selector) {
	return _lorenzo$elm_webdriver$Webdriver_Step$GetElementSize(selector);
};
var _lorenzo$elm_webdriver$Webdriver_Step$GetElementViewPosition = function (a) {
	return {ctor: 'GetElementViewPosition', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_Step$getElementViewPosition = function (selector) {
	return _lorenzo$elm_webdriver$Webdriver_Step$GetElementViewPosition(selector);
};
var _lorenzo$elm_webdriver$Webdriver_Step$GetElementPosition = function (a) {
	return {ctor: 'GetElementPosition', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_Step$getElementPosition = function (selector) {
	return _lorenzo$elm_webdriver$Webdriver_Step$GetElementPosition(selector);
};
var _lorenzo$elm_webdriver$Webdriver_Step$CountElements = function (a) {
	return {ctor: 'CountElements', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_Step$countElements = function (selector) {
	return _lorenzo$elm_webdriver$Webdriver_Step$CountElements(selector);
};

var _lorenzo$elm_webdriver$Webdriver$toSeconds = function (ms) {
	return A2(
		_elm_lang$core$Basics_ops['++'],
		_elm_lang$core$Basics$toString(
			_elm_lang$core$Basics$toFloat(ms) / 1000),
		's');
};
var _lorenzo$elm_webdriver$Webdriver$toUnitStep = function (name) {
	return _lorenzo$elm_webdriver$Webdriver_Step$ReturningUnit(
		_lorenzo$elm_webdriver$Webdriver_Step$initMeta(name));
};
var _lorenzo$elm_webdriver$Webdriver$visit = function (url) {
	return A2(
		_lorenzo$elm_webdriver$Webdriver$toUnitStep,
		A2(_elm_lang$core$Basics_ops['++'], 'Visit ', url),
		_lorenzo$elm_webdriver$Webdriver_Step$Visit(url));
};
var _lorenzo$elm_webdriver$Webdriver$click = function (selector) {
	return A2(
		_lorenzo$elm_webdriver$Webdriver$toUnitStep,
		A2(
			_elm_lang$core$Basics_ops['++'],
			'Click <',
			A2(_elm_lang$core$Basics_ops['++'], selector, '>')),
		_lorenzo$elm_webdriver$Webdriver_Step$Click(selector));
};
var _lorenzo$elm_webdriver$Webdriver$moveTo = function (selector) {
	return A2(
		_lorenzo$elm_webdriver$Webdriver$toUnitStep,
		A2(
			_elm_lang$core$Basics_ops['++'],
			'Move the mouse to <',
			A2(_elm_lang$core$Basics_ops['++'], selector, '>')),
		_lorenzo$elm_webdriver$Webdriver_Step$MoveTo(selector));
};
var _lorenzo$elm_webdriver$Webdriver$moveToWithOffset = F3(
	function (selector, xOffset, yOffset) {
		return A2(
			_lorenzo$elm_webdriver$Webdriver$toUnitStep,
			A2(
				_elm_lang$core$Basics_ops['++'],
				'Move the mouse to <',
				A2(
					_elm_lang$core$Basics_ops['++'],
					selector,
					A2(
						_elm_lang$core$Basics_ops['++'],
						'> with offset (',
						A2(
							_elm_lang$core$Basics_ops['++'],
							_elm_lang$core$Basics$toString(xOffset),
							A2(
								_elm_lang$core$Basics_ops['++'],
								',',
								A2(
									_elm_lang$core$Basics_ops['++'],
									_elm_lang$core$Basics$toString(yOffset),
									')')))))),
			A3(_lorenzo$elm_webdriver$Webdriver_Step$MoveToWithOffset, selector, xOffset, yOffset));
	});
var _lorenzo$elm_webdriver$Webdriver$close = A2(_lorenzo$elm_webdriver$Webdriver$toUnitStep, 'Close the window', _lorenzo$elm_webdriver$Webdriver_Step$Close);
var _lorenzo$elm_webdriver$Webdriver$setValue = F2(
	function (selector, value) {
		return A2(
			_lorenzo$elm_webdriver$Webdriver$toUnitStep,
			A2(
				_elm_lang$core$Basics_ops['++'],
				'Set the value \'',
				A2(
					_elm_lang$core$Basics_ops['++'],
					value,
					A2(
						_elm_lang$core$Basics_ops['++'],
						'\' to <',
						A2(_elm_lang$core$Basics_ops['++'], selector, '>')))),
			A2(_lorenzo$elm_webdriver$Webdriver_Step$SetValue, selector, value));
	});
var _lorenzo$elm_webdriver$Webdriver$appendValue = F2(
	function (selector, value) {
		return A2(
			_lorenzo$elm_webdriver$Webdriver$toUnitStep,
			A2(
				_elm_lang$core$Basics_ops['++'],
				'Append the value \'',
				A2(
					_elm_lang$core$Basics_ops['++'],
					value,
					A2(
						_elm_lang$core$Basics_ops['++'],
						'\' to <',
						A2(_elm_lang$core$Basics_ops['++'], selector, '>')))),
			A2(_lorenzo$elm_webdriver$Webdriver_Step$AppendValue, selector, value));
	});
var _lorenzo$elm_webdriver$Webdriver$clearValue = function (selector) {
	return A2(
		_lorenzo$elm_webdriver$Webdriver$toUnitStep,
		A2(
			_elm_lang$core$Basics_ops['++'],
			'Clear the value of <',
			A2(_elm_lang$core$Basics_ops['++'], selector, '>')),
		_lorenzo$elm_webdriver$Webdriver_Step$ClearValue(selector));
};
var _lorenzo$elm_webdriver$Webdriver$selectByIndex = F2(
	function (selector, index) {
		return A2(
			_lorenzo$elm_webdriver$Webdriver$toUnitStep,
			A2(
				_elm_lang$core$Basics_ops['++'],
				'Select the option with index \'',
				A2(
					_elm_lang$core$Basics_ops['++'],
					_elm_lang$core$Basics$toString(index),
					A2(
						_elm_lang$core$Basics_ops['++'],
						'\' in <',
						A2(_elm_lang$core$Basics_ops['++'], selector, '>')))),
			A2(_lorenzo$elm_webdriver$Webdriver_Step$SelectByIndex, selector, index));
	});
var _lorenzo$elm_webdriver$Webdriver$selectByValue = F2(
	function (selector, value) {
		return A2(
			_lorenzo$elm_webdriver$Webdriver$toUnitStep,
			A2(
				_elm_lang$core$Basics_ops['++'],
				'Select the option with value \'',
				A2(
					_elm_lang$core$Basics_ops['++'],
					value,
					A2(
						_elm_lang$core$Basics_ops['++'],
						'\' in <',
						A2(_elm_lang$core$Basics_ops['++'], selector, '>')))),
			A2(_lorenzo$elm_webdriver$Webdriver_Step$SelectByValue, selector, value));
	});
var _lorenzo$elm_webdriver$Webdriver$selectByText = F2(
	function (selector, text) {
		return A2(
			_lorenzo$elm_webdriver$Webdriver$toUnitStep,
			A2(
				_elm_lang$core$Basics_ops['++'],
				'Select the option with visible text \'',
				A2(
					_elm_lang$core$Basics_ops['++'],
					text,
					A2(
						_elm_lang$core$Basics_ops['++'],
						'\' in <',
						A2(_elm_lang$core$Basics_ops['++'], selector, '>')))),
			A2(_lorenzo$elm_webdriver$Webdriver_Step$SelectByText, selector, text));
	});
var _lorenzo$elm_webdriver$Webdriver$selectByAttribute = F3(
	function (selector, attr, value) {
		return A2(
			_lorenzo$elm_webdriver$Webdriver$toUnitStep,
			A2(
				_elm_lang$core$Basics_ops['++'],
				'Select the option with attribute \'',
				A2(
					_elm_lang$core$Basics_ops['++'],
					attr,
					A2(
						_elm_lang$core$Basics_ops['++'],
						'=',
						A2(
							_elm_lang$core$Basics_ops['++'],
							value,
							A2(
								_elm_lang$core$Basics_ops['++'],
								'\'  in <',
								A2(_elm_lang$core$Basics_ops['++'], selector, '>')))))),
			A3(_lorenzo$elm_webdriver$Webdriver_Step$SelectByAttribute, selector, attr, value));
	});
var _lorenzo$elm_webdriver$Webdriver$submitForm = function (selector) {
	return A2(
		_lorenzo$elm_webdriver$Webdriver$toUnitStep,
		A2(
			_elm_lang$core$Basics_ops['++'],
			'Submit the form <',
			A2(_elm_lang$core$Basics_ops['++'], selector, '>')),
		_lorenzo$elm_webdriver$Webdriver_Step$Submit(selector));
};
var _lorenzo$elm_webdriver$Webdriver$setCookie = F2(
	function (name, value) {
		return A2(
			_lorenzo$elm_webdriver$Webdriver$toUnitStep,
			A2(
				_elm_lang$core$Basics_ops['++'],
				'Set the cookie \'',
				A2(
					_elm_lang$core$Basics_ops['++'],
					name,
					A2(
						_elm_lang$core$Basics_ops['++'],
						'\' with value \'',
						A2(_elm_lang$core$Basics_ops['++'], value, '\'')))),
			A2(_lorenzo$elm_webdriver$Webdriver_Step$SetCookie, name, value));
	});
var _lorenzo$elm_webdriver$Webdriver$deleteCookie = function (name) {
	return A2(
		_lorenzo$elm_webdriver$Webdriver$toUnitStep,
		A2(
			_elm_lang$core$Basics_ops['++'],
			'Delete the cookie \'',
			A2(_elm_lang$core$Basics_ops['++'], name, '\'')),
		_lorenzo$elm_webdriver$Webdriver_Step$DeleteCookie(name));
};
var _lorenzo$elm_webdriver$Webdriver$waitForExist = F2(
	function (selector, timeout) {
		return A2(
			_lorenzo$elm_webdriver$Webdriver$toUnitStep,
			A2(
				_elm_lang$core$Basics_ops['++'],
				'Wait ',
				A2(
					_elm_lang$core$Basics_ops['++'],
					_lorenzo$elm_webdriver$Webdriver$toSeconds(timeout),
					A2(
						_elm_lang$core$Basics_ops['++'],
						' for <',
						A2(_elm_lang$core$Basics_ops['++'], selector, '> to be present')))),
			A2(_lorenzo$elm_webdriver$Webdriver_Step$WaitForExist, selector, timeout));
	});
var _lorenzo$elm_webdriver$Webdriver$waitForNotExist = F2(
	function (selector, timeout) {
		return A2(
			_lorenzo$elm_webdriver$Webdriver$toUnitStep,
			A2(
				_elm_lang$core$Basics_ops['++'],
				'Wait ',
				A2(
					_elm_lang$core$Basics_ops['++'],
					_lorenzo$elm_webdriver$Webdriver$toSeconds(timeout),
					A2(
						_elm_lang$core$Basics_ops['++'],
						's for <',
						A2(_elm_lang$core$Basics_ops['++'], selector, '> to be absent')))),
			A2(_lorenzo$elm_webdriver$Webdriver_Step$WaitForNotExist, selector, timeout));
	});
var _lorenzo$elm_webdriver$Webdriver$waitForVisible = F2(
	function (selector, timeout) {
		return A2(
			_lorenzo$elm_webdriver$Webdriver$toUnitStep,
			A2(
				_elm_lang$core$Basics_ops['++'],
				'Wait ',
				A2(
					_elm_lang$core$Basics_ops['++'],
					_lorenzo$elm_webdriver$Webdriver$toSeconds(timeout),
					A2(
						_elm_lang$core$Basics_ops['++'],
						's for <',
						A2(_elm_lang$core$Basics_ops['++'], selector, '> to be visible')))),
			A2(_lorenzo$elm_webdriver$Webdriver_Step$WaitForVisible, selector, timeout));
	});
var _lorenzo$elm_webdriver$Webdriver$waitForNotVisible = F2(
	function (selector, timeout) {
		return A2(
			_lorenzo$elm_webdriver$Webdriver$toUnitStep,
			A2(
				_elm_lang$core$Basics_ops['++'],
				'Wait ',
				A2(
					_elm_lang$core$Basics_ops['++'],
					_lorenzo$elm_webdriver$Webdriver$toSeconds(timeout),
					A2(
						_elm_lang$core$Basics_ops['++'],
						's for <',
						A2(_elm_lang$core$Basics_ops['++'], selector, '> to be not visible')))),
			A2(_lorenzo$elm_webdriver$Webdriver_Step$WaitForNotVisible, selector, timeout));
	});
var _lorenzo$elm_webdriver$Webdriver$waitForValue = F2(
	function (selector, timeout) {
		return A2(
			_lorenzo$elm_webdriver$Webdriver$toUnitStep,
			A2(
				_elm_lang$core$Basics_ops['++'],
				'Wait ',
				A2(
					_elm_lang$core$Basics_ops['++'],
					_lorenzo$elm_webdriver$Webdriver$toSeconds(timeout),
					A2(
						_elm_lang$core$Basics_ops['++'],
						's for <',
						A2(_elm_lang$core$Basics_ops['++'], selector, '> to have a value')))),
			A2(_lorenzo$elm_webdriver$Webdriver_Step$WaitForValue, selector, timeout));
	});
var _lorenzo$elm_webdriver$Webdriver$waitForNoValue = F2(
	function (selector, timeout) {
		return A2(
			_lorenzo$elm_webdriver$Webdriver$toUnitStep,
			A2(
				_elm_lang$core$Basics_ops['++'],
				'Wait ',
				A2(
					_elm_lang$core$Basics_ops['++'],
					_lorenzo$elm_webdriver$Webdriver$toSeconds(timeout),
					A2(
						_elm_lang$core$Basics_ops['++'],
						's for <',
						A2(_elm_lang$core$Basics_ops['++'], selector, '> to have no value')))),
			A2(_lorenzo$elm_webdriver$Webdriver_Step$WaitForNoValue, selector, timeout));
	});
var _lorenzo$elm_webdriver$Webdriver$waitForSelected = F2(
	function (selector, timeout) {
		return A2(
			_lorenzo$elm_webdriver$Webdriver$toUnitStep,
			A2(
				_elm_lang$core$Basics_ops['++'],
				'Wait ',
				A2(
					_elm_lang$core$Basics_ops['++'],
					_lorenzo$elm_webdriver$Webdriver$toSeconds(timeout),
					A2(
						_elm_lang$core$Basics_ops['++'],
						's for <',
						A2(_elm_lang$core$Basics_ops['++'], selector, '> to be selected')))),
			A2(_lorenzo$elm_webdriver$Webdriver_Step$WaitForSelected, selector, timeout));
	});
var _lorenzo$elm_webdriver$Webdriver$waitForNotSelected = F2(
	function (selector, timeout) {
		return A2(
			_lorenzo$elm_webdriver$Webdriver$toUnitStep,
			A2(
				_elm_lang$core$Basics_ops['++'],
				'Wait ',
				A2(
					_elm_lang$core$Basics_ops['++'],
					_lorenzo$elm_webdriver$Webdriver$toSeconds(timeout),
					A2(
						_elm_lang$core$Basics_ops['++'],
						's for <',
						A2(_elm_lang$core$Basics_ops['++'], selector, '> to not be selected')))),
			A2(_lorenzo$elm_webdriver$Webdriver_Step$WaitForNotSelected, selector, timeout));
	});
var _lorenzo$elm_webdriver$Webdriver$waitForText = F2(
	function (selector, timeout) {
		return A2(
			_lorenzo$elm_webdriver$Webdriver$toUnitStep,
			A2(
				_elm_lang$core$Basics_ops['++'],
				'Wait ',
				A2(
					_elm_lang$core$Basics_ops['++'],
					_lorenzo$elm_webdriver$Webdriver$toSeconds(timeout),
					A2(
						_elm_lang$core$Basics_ops['++'],
						's for <',
						A2(_elm_lang$core$Basics_ops['++'], selector, '> to have text')))),
			A2(_lorenzo$elm_webdriver$Webdriver_Step$WaitForText, selector, timeout));
	});
var _lorenzo$elm_webdriver$Webdriver$waitForNoText = F2(
	function (selector, timeout) {
		return A2(
			_lorenzo$elm_webdriver$Webdriver$toUnitStep,
			A2(
				_elm_lang$core$Basics_ops['++'],
				'Wait ',
				A2(
					_elm_lang$core$Basics_ops['++'],
					_lorenzo$elm_webdriver$Webdriver$toSeconds(timeout),
					A2(
						_elm_lang$core$Basics_ops['++'],
						's for <',
						A2(_elm_lang$core$Basics_ops['++'], selector, '> to have no text')))),
			A2(_lorenzo$elm_webdriver$Webdriver_Step$WaitForNoText, selector, timeout));
	});
var _lorenzo$elm_webdriver$Webdriver$waitForEnabled = F2(
	function (selector, timeout) {
		return A2(
			_lorenzo$elm_webdriver$Webdriver$toUnitStep,
			A2(
				_elm_lang$core$Basics_ops['++'],
				'Wait ',
				A2(
					_elm_lang$core$Basics_ops['++'],
					_lorenzo$elm_webdriver$Webdriver$toSeconds(timeout),
					A2(
						_elm_lang$core$Basics_ops['++'],
						's for <',
						A2(_elm_lang$core$Basics_ops['++'], selector, '> to be enabled')))),
			A2(_lorenzo$elm_webdriver$Webdriver_Step$WaitForEnabled, selector, timeout));
	});
var _lorenzo$elm_webdriver$Webdriver$waitForNotEnabled = F2(
	function (selector, timeout) {
		return A2(
			_lorenzo$elm_webdriver$Webdriver$toUnitStep,
			A2(
				_elm_lang$core$Basics_ops['++'],
				'Wait ',
				A2(
					_elm_lang$core$Basics_ops['++'],
					_lorenzo$elm_webdriver$Webdriver$toSeconds(timeout),
					A2(
						_elm_lang$core$Basics_ops['++'],
						's for <',
						A2(_elm_lang$core$Basics_ops['++'], selector, '> to not be enabled')))),
			A2(_lorenzo$elm_webdriver$Webdriver_Step$WaitForNotEnabled, selector, timeout));
	});
var _lorenzo$elm_webdriver$Webdriver$end = A2(_lorenzo$elm_webdriver$Webdriver$toUnitStep, 'End the session', _lorenzo$elm_webdriver$Webdriver_Step$End);
var _lorenzo$elm_webdriver$Webdriver$pause = function (ms) {
	return A2(
		_lorenzo$elm_webdriver$Webdriver$toUnitStep,
		A2(
			_elm_lang$core$Basics_ops['++'],
			'Pause the exexution for ',
			_lorenzo$elm_webdriver$Webdriver$toSeconds(ms)),
		_lorenzo$elm_webdriver$Webdriver_Step$Pause(ms));
};
var _lorenzo$elm_webdriver$Webdriver$scrollToElement = function (selector) {
	return A2(
		_lorenzo$elm_webdriver$Webdriver$toUnitStep,
		A2(
			_elm_lang$core$Basics_ops['++'],
			'Scroll to <',
			A2(_elm_lang$core$Basics_ops['++'], selector, '>')),
		A3(_lorenzo$elm_webdriver$Webdriver_Step$ScrollTo, selector, 0, 0));
};
var _lorenzo$elm_webdriver$Webdriver$scrollToElementOffset = F3(
	function (selector, x, y) {
		return A2(
			_lorenzo$elm_webdriver$Webdriver$toUnitStep,
			A2(
				_elm_lang$core$Basics_ops['++'],
				'Scroll to <',
				A2(
					_elm_lang$core$Basics_ops['++'],
					selector,
					A2(
						_elm_lang$core$Basics_ops['++'],
						'> with offset (',
						A2(
							_elm_lang$core$Basics_ops['++'],
							_elm_lang$core$Basics$toString(x),
							A2(
								_elm_lang$core$Basics_ops['++'],
								',',
								A2(
									_elm_lang$core$Basics_ops['++'],
									_elm_lang$core$Basics$toString(y),
									')')))))),
			A3(_lorenzo$elm_webdriver$Webdriver_Step$ScrollTo, selector, x, y));
	});
var _lorenzo$elm_webdriver$Webdriver$scrollWindow = F2(
	function (x, y) {
		return A2(
			_lorenzo$elm_webdriver$Webdriver$toUnitStep,
			A2(
				_elm_lang$core$Basics_ops['++'],
				'Scroll to (',
				A2(
					_elm_lang$core$Basics_ops['++'],
					_elm_lang$core$Basics$toString(x),
					A2(
						_elm_lang$core$Basics_ops['++'],
						',',
						A2(
							_elm_lang$core$Basics_ops['++'],
							_elm_lang$core$Basics$toString(y),
							')')))),
			A2(_lorenzo$elm_webdriver$Webdriver_Step$Scroll, x, y));
	});
var _lorenzo$elm_webdriver$Webdriver$savePageScreenshot = function (filename) {
	return A2(
		_lorenzo$elm_webdriver$Webdriver$toUnitStep,
		'Save page screenshot',
		_lorenzo$elm_webdriver$Webdriver_Step$SavePagecreenshot(filename));
};
var _lorenzo$elm_webdriver$Webdriver$switchToFrame = function (index) {
	return A2(
		_lorenzo$elm_webdriver$Webdriver$toUnitStep,
		A2(
			_elm_lang$core$Basics_ops['++'],
			'Switch to frame <',
			A2(
				_elm_lang$core$Basics_ops['++'],
				_elm_lang$core$Basics$toString(index),
				'>')),
		_lorenzo$elm_webdriver$Webdriver_Step$SwitchFrame(index));
};
var _lorenzo$elm_webdriver$Webdriver$triggerClick = function (selector) {
	return A2(
		_lorenzo$elm_webdriver$Webdriver$toUnitStep,
		A2(
			_elm_lang$core$Basics_ops['++'],
			'Trigger a JS click for <',
			A2(_elm_lang$core$Basics_ops['++'], selector, '>')),
		_lorenzo$elm_webdriver$Webdriver_Step$TriggerClick(selector));
};
var _lorenzo$elm_webdriver$Webdriver$waitForDebug = A2(_lorenzo$elm_webdriver$Webdriver$toUnitStep, 'Wait for user to debug in browser', _lorenzo$elm_webdriver$Webdriver_Step$WaitForDebug);
var _lorenzo$elm_webdriver$Webdriver$windowResize = F2(
	function (width, height) {
		return A2(
			_lorenzo$elm_webdriver$Webdriver$toUnitStep,
			A2(
				_elm_lang$core$Basics_ops['++'],
				'Resize window to width: ',
				A2(
					_elm_lang$core$Basics_ops['++'],
					_elm_lang$core$Basics$toString(width),
					A2(
						_elm_lang$core$Basics_ops['++'],
						' and height: ',
						_elm_lang$core$Basics$toString(height)))),
			A2(_lorenzo$elm_webdriver$Webdriver_Step$WindowResize, width, height));
	});
var _lorenzo$elm_webdriver$Webdriver$keys = function (keys) {
	return A2(
		_lorenzo$elm_webdriver$Webdriver$toUnitStep,
		A2(
			_elm_lang$core$Basics_ops['++'],
			'Input keys: ',
			A3(
				_elm_lang$core$List$foldl,
				F2(
					function (s1, s2) {
						return A2(
							_elm_lang$core$Basics_ops['++'],
							s1,
							A2(_elm_lang$core$Basics_ops['++'], ' ', s2));
					}),
				'',
				A2(_elm_lang$core$List$map, _lorenzo$elm_webdriver$Webdriver_LowLevel$keyToString, keys))),
		_lorenzo$elm_webdriver$Webdriver_Step$Keys(keys));
};
var _lorenzo$elm_webdriver$Webdriver$basicOptions = {
	desiredCapabilities: {browserName: 'firefox'}
};
var _lorenzo$elm_webdriver$Webdriver$withScreenshot = _lorenzo$elm_webdriver$Webdriver_Step$withScreenshot;
var _lorenzo$elm_webdriver$Webdriver$withName = _lorenzo$elm_webdriver$Webdriver_Step$withName;
var _lorenzo$elm_webdriver$Webdriver$stepName = _lorenzo$elm_webdriver$Webdriver_Step$stepName;

var _lorenzo$elm_webdriver$Webdriver_Assert$sequenceCommands = F3(
	function (name, partiallyAppliedTasks, assert) {
		var task = function (browser) {
			return A2(
				_elm_lang$core$Task$map,
				assert,
				_elm_lang$core$Task$sequence(
					A2(
						_elm_lang$core$List$map,
						function (t) {
							return t(browser);
						},
						partiallyAppliedTasks)));
		};
		return A2(
			_lorenzo$elm_webdriver$Webdriver_Step$AssertionWebdriver,
			_lorenzo$elm_webdriver$Webdriver_Step$initMeta(name),
			task);
	});
var _lorenzo$elm_webdriver$Webdriver_Assert$driverCommand = F3(
	function (name, partiallyAppliedTask, assert) {
		var task = function (browser) {
			return A2(
				_elm_lang$core$Task$map,
				assert,
				partiallyAppliedTask(browser));
		};
		return A2(
			_lorenzo$elm_webdriver$Webdriver_Step$AssertionWebdriver,
			_lorenzo$elm_webdriver$Webdriver_Step$initMeta(name),
			task);
	});
var _lorenzo$elm_webdriver$Webdriver_Assert$task = F2(
	function (name, theTask) {
		return A2(
			_lorenzo$elm_webdriver$Webdriver_Step$AssertionTask,
			_lorenzo$elm_webdriver$Webdriver_Step$initMeta(name),
			theTask);
	});
var _lorenzo$elm_webdriver$Webdriver_Assert$elementViewPosition = F2(
	function (selector, fn) {
		return A3(
			_lorenzo$elm_webdriver$Webdriver_Step$AssertionGeometry,
			_lorenzo$elm_webdriver$Webdriver_Step$initMeta(
				A2(
					_elm_lang$core$Basics_ops['++'],
					'Check the position of the element < ',
					A2(_elm_lang$core$Basics_ops['++'], selector, ' > relative to the viewport'))),
			_lorenzo$elm_webdriver$Webdriver_Step$getElementViewPosition(selector),
			fn);
	});
var _lorenzo$elm_webdriver$Webdriver_Assert$elementPosition = F2(
	function (selector, fn) {
		return A3(
			_lorenzo$elm_webdriver$Webdriver_Step$AssertionGeometry,
			_lorenzo$elm_webdriver$Webdriver_Step$initMeta(
				A2(
					_elm_lang$core$Basics_ops['++'],
					'Check the position of the element < ',
					A2(_elm_lang$core$Basics_ops['++'], selector, ' >'))),
			_lorenzo$elm_webdriver$Webdriver_Step$getElementPosition(selector),
			fn);
	});
var _lorenzo$elm_webdriver$Webdriver_Assert$elementSize = F2(
	function (selector, fn) {
		return A3(
			_lorenzo$elm_webdriver$Webdriver_Step$AssertionGeometry,
			_lorenzo$elm_webdriver$Webdriver_Step$initMeta(
				A2(
					_elm_lang$core$Basics_ops['++'],
					'Check the size of the element < ',
					A2(_elm_lang$core$Basics_ops['++'], selector, ' >'))),
			_lorenzo$elm_webdriver$Webdriver_Step$getElementSize(selector),
			fn);
	});
var _lorenzo$elm_webdriver$Webdriver_Assert$optionSelected = function (selector) {
	return A3(
		_lorenzo$elm_webdriver$Webdriver_Step$AssertionBool,
		_lorenzo$elm_webdriver$Webdriver_Step$initMeta(
			A2(
				_elm_lang$core$Basics_ops['++'],
				'Check for the option < ',
				A2(_elm_lang$core$Basics_ops['++'], selector, ' > to be selected'))),
		_lorenzo$elm_webdriver$Webdriver_Step$optionIsSelected(selector),
		function (res) {
			return res ? _elm_community$elm_test$Expect$pass : _elm_community$elm_test$Expect$fail('The option is not selected');
		});
};
var _lorenzo$elm_webdriver$Webdriver_Assert$visibleWithinViewport = function (selector) {
	return A3(
		_lorenzo$elm_webdriver$Webdriver_Step$AssertionBool,
		_lorenzo$elm_webdriver$Webdriver_Step$initMeta(
			A2(
				_elm_lang$core$Basics_ops['++'],
				'Check for the element < ',
				A2(_elm_lang$core$Basics_ops['++'], selector, ' > to be visible within the viewport'))),
		_lorenzo$elm_webdriver$Webdriver_Step$elementVisibleWithinViewport(selector),
		function (res) {
			return res ? _elm_community$elm_test$Expect$pass : _elm_community$elm_test$Expect$fail(
				A2(
					_elm_lang$core$Basics_ops['++'],
					'The input element \'',
					A2(_elm_lang$core$Basics_ops['++'], selector, '\' was expected to be visible within the viewport')));
		});
};
var _lorenzo$elm_webdriver$Webdriver_Assert$visible = function (selector) {
	return A3(
		_lorenzo$elm_webdriver$Webdriver_Step$AssertionBool,
		_lorenzo$elm_webdriver$Webdriver_Step$initMeta(
			A2(
				_elm_lang$core$Basics_ops['++'],
				'Check for the element < ',
				A2(_elm_lang$core$Basics_ops['++'], selector, ' > to be visible'))),
		_lorenzo$elm_webdriver$Webdriver_Step$elementVisible(selector),
		function (res) {
			return res ? _elm_community$elm_test$Expect$pass : _elm_community$elm_test$Expect$fail('The element is not visible');
		});
};
var _lorenzo$elm_webdriver$Webdriver_Assert$inputEnabled = function (selector) {
	return A3(
		_lorenzo$elm_webdriver$Webdriver_Step$AssertionBool,
		_lorenzo$elm_webdriver$Webdriver_Step$initMeta(
			A2(
				_elm_lang$core$Basics_ops['++'],
				'Check for the input < ',
				A2(_elm_lang$core$Basics_ops['++'], selector, ' > to be enabled'))),
		_lorenzo$elm_webdriver$Webdriver_Step$elementEnabled(selector),
		function (res) {
			return res ? _elm_community$elm_test$Expect$pass : _elm_community$elm_test$Expect$fail('The input element is not enabled');
		});
};
var _lorenzo$elm_webdriver$Webdriver_Assert$exists = function (selector) {
	return A3(
		_lorenzo$elm_webdriver$Webdriver_Step$AssertionBool,
		_lorenzo$elm_webdriver$Webdriver_Step$initMeta(
			A2(
				_elm_lang$core$Basics_ops['++'],
				'Check for the element < ',
				A2(_elm_lang$core$Basics_ops['++'], selector, ' > to exist'))),
		_lorenzo$elm_webdriver$Webdriver_Step$elementExists(selector),
		function (res) {
			return res ? _elm_community$elm_test$Expect$pass : _elm_community$elm_test$Expect$fail('The element does not exist');
		});
};
var _lorenzo$elm_webdriver$Webdriver_Assert$inputValue = F2(
	function (selector, fn) {
		return A3(
			_lorenzo$elm_webdriver$Webdriver_Step$AssertionString,
			_lorenzo$elm_webdriver$Webdriver_Step$initMeta(
				A2(
					_elm_lang$core$Basics_ops['++'],
					'Check the value for the input < ',
					A2(_elm_lang$core$Basics_ops['++'], selector, ' >'))),
			_lorenzo$elm_webdriver$Webdriver_Step$getValue(selector),
			fn);
	});
var _lorenzo$elm_webdriver$Webdriver_Assert$elementText = F2(
	function (selector, fn) {
		return A3(
			_lorenzo$elm_webdriver$Webdriver_Step$AssertionString,
			_lorenzo$elm_webdriver$Webdriver_Step$initMeta(
				A2(
					_elm_lang$core$Basics_ops['++'],
					'Check the text for the element < ',
					A2(_elm_lang$core$Basics_ops['++'], selector, ' >'))),
			_lorenzo$elm_webdriver$Webdriver_Step$getText(selector),
			fn);
	});
var _lorenzo$elm_webdriver$Webdriver_Assert$elementHTML = F2(
	function (selector, fn) {
		return A3(
			_lorenzo$elm_webdriver$Webdriver_Step$AssertionString,
			_lorenzo$elm_webdriver$Webdriver_Step$initMeta(
				A2(
					_elm_lang$core$Basics_ops['++'],
					'Check the HTML for the element < ',
					A2(_elm_lang$core$Basics_ops['++'], selector, ' >'))),
			_lorenzo$elm_webdriver$Webdriver_Step$getElementHTML(selector),
			fn);
	});
var _lorenzo$elm_webdriver$Webdriver_Assert$css = F3(
	function (selector, name, fn) {
		return A3(
			_lorenzo$elm_webdriver$Webdriver_Step$AssertionMaybe,
			_lorenzo$elm_webdriver$Webdriver_Step$initMeta(
				A2(
					_elm_lang$core$Basics_ops['++'],
					'Check the < ',
					A2(
						_elm_lang$core$Basics_ops['++'],
						name,
						A2(
							_elm_lang$core$Basics_ops['++'],
							' > css property of the element < ',
							A2(_elm_lang$core$Basics_ops['++'], selector, ' >'))))),
			A2(_lorenzo$elm_webdriver$Webdriver_Step$getCssProperty, selector, name),
			function (res) {
				var _p0 = res;
				if (_p0.ctor === 'Just') {
					return fn(_p0._0);
				} else {
					return _elm_community$elm_test$Expect$fail('The css property is not present');
				}
			});
	});
var _lorenzo$elm_webdriver$Webdriver_Assert$attribute = F3(
	function (selector, name, fn) {
		return A3(
			_lorenzo$elm_webdriver$Webdriver_Step$AssertionMaybe,
			_lorenzo$elm_webdriver$Webdriver_Step$initMeta(
				A2(
					_elm_lang$core$Basics_ops['++'],
					'Check the <',
					A2(
						_elm_lang$core$Basics_ops['++'],
						name,
						A2(
							_elm_lang$core$Basics_ops['++'],
							'> attribute of the element < ',
							A2(_elm_lang$core$Basics_ops['++'], selector, ' >'))))),
			A2(_lorenzo$elm_webdriver$Webdriver_Step$getAttribute, selector, name),
			function (res) {
				var _p1 = res;
				if (_p1.ctor === 'Just') {
					return fn(_p1._0);
				} else {
					return _elm_community$elm_test$Expect$fail('The attribute is not present');
				}
			});
	});
var _lorenzo$elm_webdriver$Webdriver_Assert$elementCount = F2(
	function (selector, fn) {
		return A3(
			_lorenzo$elm_webdriver$Webdriver_Step$AssertionInt,
			_lorenzo$elm_webdriver$Webdriver_Step$initMeta(
				A2(
					_elm_lang$core$Basics_ops['++'],
					'Check the number of elements in < ',
					A2(_elm_lang$core$Basics_ops['++'], selector, ' >'))),
			_lorenzo$elm_webdriver$Webdriver_Step$countElements(selector),
			fn);
	});
var _lorenzo$elm_webdriver$Webdriver_Assert$pageHTML = function (fn) {
	return A3(
		_lorenzo$elm_webdriver$Webdriver_Step$AssertionString,
		_lorenzo$elm_webdriver$Webdriver_Step$initMeta('Check the page HTML source'),
		_lorenzo$elm_webdriver$Webdriver_Step$getPageHTML,
		fn);
};
var _lorenzo$elm_webdriver$Webdriver_Assert$title = function (fn) {
	return A3(
		_lorenzo$elm_webdriver$Webdriver_Step$AssertionString,
		_lorenzo$elm_webdriver$Webdriver_Step$initMeta('Check the page title'),
		_lorenzo$elm_webdriver$Webdriver_Step$getTitle,
		fn);
};
var _lorenzo$elm_webdriver$Webdriver_Assert$url = function (fn) {
	return A3(
		_lorenzo$elm_webdriver$Webdriver_Step$AssertionString,
		_lorenzo$elm_webdriver$Webdriver_Step$initMeta('Check the current URL'),
		_lorenzo$elm_webdriver$Webdriver_Step$getUrl,
		fn);
};
var _lorenzo$elm_webdriver$Webdriver_Assert$cookieNotExists = function (name) {
	return A3(
		_lorenzo$elm_webdriver$Webdriver_Step$AssertionBool,
		_lorenzo$elm_webdriver$Webdriver_Step$initMeta(
			A2(
				_elm_lang$core$Basics_ops['++'],
				'Check the cookie <',
				A2(_elm_lang$core$Basics_ops['++'], name, '> presence'))),
		_lorenzo$elm_webdriver$Webdriver_Step$cookieNotExists(name),
		_elm_community$elm_test$Expect$true('The cookie was present'));
};
var _lorenzo$elm_webdriver$Webdriver_Assert$cookieExists = function (name) {
	return A3(
		_lorenzo$elm_webdriver$Webdriver_Step$AssertionBool,
		_lorenzo$elm_webdriver$Webdriver_Step$initMeta(
			A2(
				_elm_lang$core$Basics_ops['++'],
				'Check the cookie <',
				A2(_elm_lang$core$Basics_ops['++'], name, '> prensence'))),
		_lorenzo$elm_webdriver$Webdriver_Step$cookieExists(name),
		_elm_community$elm_test$Expect$true('The cookie is not present.'));
};
var _lorenzo$elm_webdriver$Webdriver_Assert$cookie = F2(
	function (name, f) {
		return A3(
			_lorenzo$elm_webdriver$Webdriver_Step$AssertionMaybe,
			_lorenzo$elm_webdriver$Webdriver_Step$initMeta(
				A2(
					_elm_lang$core$Basics_ops['++'],
					'Check the cookie <',
					A2(_elm_lang$core$Basics_ops['++'], name, '> value'))),
			_lorenzo$elm_webdriver$Webdriver_Step$getCookie(name),
			function (res) {
				var _p2 = res;
				if (_p2.ctor === 'Just') {
					return f(_p2._0);
				} else {
					return _elm_community$elm_test$Expect$fail('The cookie does not exist');
				}
			});
	});

var _lorenzo$elm_webdriver$Webdriver_Process$toMessage = function (task) {
	var _p0 = task;
	if (_p0.ctor === 'Err') {
		return _p0._0;
	} else {
		return _p0._0;
	}
};
var _lorenzo$elm_webdriver$Webdriver_Process$processIntStep = F2(
	function (step, browser) {
		var _p1 = step;
		return A2(_lorenzo$elm_webdriver$Webdriver_LowLevel$countElements, _p1._0, browser);
	});
var _lorenzo$elm_webdriver$Webdriver_Process$validateSelector = F2(
	function (selector, browser) {
		return A2(
			_elm_lang$core$Task$andThen,
			function (count) {
				return (_elm_lang$core$Native_Utils.cmp(count, 1) > 0) ? _elm_lang$core$Task$fail(
					_lorenzo$elm_webdriver$Webdriver_LowLevel$TooManyElements(
						{
							errorType: 'TooManyElements',
							message: A2(
								_elm_lang$core$Basics_ops['++'],
								'The selector returned ',
								A2(
									_elm_lang$core$Basics_ops['++'],
									_elm_lang$core$Basics$toString(count),
									' elements, expecting 1')),
							selector: selector
						})) : _elm_lang$core$Task$succeed(
					{ctor: '_Tuple0'});
			},
			A2(_lorenzo$elm_webdriver$Webdriver_LowLevel$countElements, selector, browser));
	});
var _lorenzo$elm_webdriver$Webdriver_Process$existAutoWait = F2(
	function (selector, browser) {
		return A3(_lorenzo$elm_webdriver$Webdriver_LowLevel$waitForExist, selector, 5000, browser);
	});
var _lorenzo$elm_webdriver$Webdriver_Process$autoWait = F2(
	function (selector, browser) {
		return A3(_lorenzo$elm_webdriver$Webdriver_LowLevel$waitForVisible, selector, 5000, browser);
	});
var _lorenzo$elm_webdriver$Webdriver_Process_ops = _lorenzo$elm_webdriver$Webdriver_Process_ops || {};
_lorenzo$elm_webdriver$Webdriver_Process_ops['#>'] = F2(
	function (t1, t2) {
		return A3(
			_elm_lang$core$Task$map2,
			F2(
				function (v0, v1) {
					return {ctor: '_Tuple2', _0: v0, _1: v1};
				}),
			t1,
			t2);
	});
var _lorenzo$elm_webdriver$Webdriver_Process_ops = _lorenzo$elm_webdriver$Webdriver_Process_ops || {};
_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'] = F2(
	function (t1, t2) {
		return A2(
			_elm_lang$core$Task$andThen,
			function (_p2) {
				return t2;
			},
			t1);
	});
var _lorenzo$elm_webdriver$Webdriver_Process$inputAutoWait = F2(
	function (selector, browser) {
		return A2(
			_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
			A2(_lorenzo$elm_webdriver$Webdriver_Process$autoWait, selector, browser),
			A3(_lorenzo$elm_webdriver$Webdriver_LowLevel$waitForEnabled, selector, 5000, browser));
	});
var _lorenzo$elm_webdriver$Webdriver_Process$processStringStep = F2(
	function (step, browser) {
		var _p3 = step;
		switch (_p3.ctor) {
			case 'GetUrl':
				return _lorenzo$elm_webdriver$Webdriver_LowLevel$getUrl(browser);
			case 'GetHtml':
				var _p4 = _p3._0;
				return A2(
					_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
					A2(
						_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
						A2(_lorenzo$elm_webdriver$Webdriver_Process$existAutoWait, _p4, browser),
						A2(_lorenzo$elm_webdriver$Webdriver_Process$validateSelector, _p4, browser)),
					A2(_lorenzo$elm_webdriver$Webdriver_LowLevel$getElementHTML, _p4, browser));
			case 'GetSource':
				return _lorenzo$elm_webdriver$Webdriver_LowLevel$getPageHTML(browser);
			case 'GetTitle':
				return _lorenzo$elm_webdriver$Webdriver_LowLevel$getTitle(browser);
			case 'GetText':
				var _p5 = _p3._0;
				return A2(
					_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
					A2(
						_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
						A2(_lorenzo$elm_webdriver$Webdriver_Process$existAutoWait, _p5, browser),
						A2(_lorenzo$elm_webdriver$Webdriver_Process$validateSelector, _p5, browser)),
					A2(_lorenzo$elm_webdriver$Webdriver_LowLevel$getText, _p5, browser));
			default:
				var _p6 = _p3._0;
				return A2(
					_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
					A2(
						_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
						A2(_lorenzo$elm_webdriver$Webdriver_Process$existAutoWait, _p6, browser),
						A2(_lorenzo$elm_webdriver$Webdriver_Process$validateSelector, _p6, browser)),
					A2(_lorenzo$elm_webdriver$Webdriver_LowLevel$getValue, _p6, browser));
		}
	});
var _lorenzo$elm_webdriver$Webdriver_Process$processMaybeStep = F2(
	function (step, browser) {
		var _p7 = step;
		switch (_p7.ctor) {
			case 'GetCookie':
				return A2(_lorenzo$elm_webdriver$Webdriver_LowLevel$getCookie, _p7._0, browser);
			case 'GetAttribute':
				var _p8 = _p7._0;
				return A2(
					_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
					A2(
						_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
						A2(_lorenzo$elm_webdriver$Webdriver_Process$existAutoWait, _p8, browser),
						A2(_lorenzo$elm_webdriver$Webdriver_Process$validateSelector, _p8, browser)),
					A3(_lorenzo$elm_webdriver$Webdriver_LowLevel$getAttribute, _p8, _p7._1, browser));
			default:
				var _p9 = _p7._0;
				return A2(
					_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
					A2(
						_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
						A2(_lorenzo$elm_webdriver$Webdriver_Process$existAutoWait, _p9, browser),
						A2(_lorenzo$elm_webdriver$Webdriver_Process$validateSelector, _p9, browser)),
					A3(_lorenzo$elm_webdriver$Webdriver_LowLevel$getCssProperty, _p9, _p7._1, browser));
		}
	});
var _lorenzo$elm_webdriver$Webdriver_Process$processBoolStep = F2(
	function (step, browser) {
		var _p10 = step;
		switch (_p10.ctor) {
			case 'CookieExists':
				return A2(_lorenzo$elm_webdriver$Webdriver_LowLevel$cookieExists, _p10._0, browser);
			case 'CookieNotExists':
				return A2(
					_elm_lang$core$Task$map,
					_elm_lang$core$Basics$not,
					A2(_lorenzo$elm_webdriver$Webdriver_LowLevel$cookieExists, _p10._0, browser));
			case 'ElementExists':
				return A2(_lorenzo$elm_webdriver$Webdriver_LowLevel$elementExists, _p10._0, browser);
			case 'ElementEnabled':
				var _p11 = _p10._0;
				return A2(
					_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
					A2(_lorenzo$elm_webdriver$Webdriver_Process$existAutoWait, _p11, browser),
					A2(_lorenzo$elm_webdriver$Webdriver_LowLevel$elementEnabled, _p11, browser));
			case 'ElementVisible':
				var _p12 = _p10._0;
				return A2(
					_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
					A2(_lorenzo$elm_webdriver$Webdriver_Process$existAutoWait, _p12, browser),
					A2(_lorenzo$elm_webdriver$Webdriver_LowLevel$elementVisible, _p12, browser));
			case 'ElementViewportVisible':
				var _p13 = _p10._0;
				return A2(
					_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
					A2(_lorenzo$elm_webdriver$Webdriver_Process$existAutoWait, _p13, browser),
					A2(_lorenzo$elm_webdriver$Webdriver_LowLevel$elementVisibleWithinViewport, _p13, browser));
			default:
				var _p14 = _p10._0;
				return A2(
					_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
					A2(_lorenzo$elm_webdriver$Webdriver_Process$existAutoWait, _p14, browser),
					A2(_lorenzo$elm_webdriver$Webdriver_LowLevel$optionIsSelected, _p14, browser));
		}
	});
var _lorenzo$elm_webdriver$Webdriver_Process$processGeometryStep = F2(
	function (step, browser) {
		var _p15 = step;
		switch (_p15.ctor) {
			case 'GetElementSize':
				var _p18 = _p15._0;
				return A2(
					_elm_lang$core$Task$map,
					function (_p16) {
						var _p17 = _p16;
						return {ctor: '_Tuple2', _0: _p17.width, _1: _p17.height};
					},
					A2(
						_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
						A2(
							_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
							A2(_lorenzo$elm_webdriver$Webdriver_Process$existAutoWait, _p18, browser),
							A2(_lorenzo$elm_webdriver$Webdriver_Process$validateSelector, _p18, browser)),
						A2(_lorenzo$elm_webdriver$Webdriver_LowLevel$getElementSize, _p18, browser)));
			case 'GetElementPosition':
				var _p21 = _p15._0;
				return A2(
					_elm_lang$core$Task$map,
					function (_p19) {
						var _p20 = _p19;
						return {ctor: '_Tuple2', _0: _p20.x, _1: _p20.y};
					},
					A2(
						_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
						A2(
							_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
							A2(_lorenzo$elm_webdriver$Webdriver_Process$existAutoWait, _p21, browser),
							A2(_lorenzo$elm_webdriver$Webdriver_Process$validateSelector, _p21, browser)),
						A2(_lorenzo$elm_webdriver$Webdriver_LowLevel$getElementPosition, _p21, browser)));
			default:
				var _p24 = _p15._0;
				return A2(
					_elm_lang$core$Task$map,
					function (_p22) {
						var _p23 = _p22;
						return {ctor: '_Tuple2', _0: _p23.x, _1: _p23.y};
					},
					A2(
						_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
						A2(
							_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
							A2(_lorenzo$elm_webdriver$Webdriver_Process$existAutoWait, _p24, browser),
							A2(_lorenzo$elm_webdriver$Webdriver_Process$validateSelector, _p24, browser)),
						A2(_lorenzo$elm_webdriver$Webdriver_LowLevel$getElementViewPosition, _p24, browser)));
		}
	});
var _lorenzo$elm_webdriver$Webdriver_Process$processStep = F2(
	function (step, browser) {
		var _p25 = step;
		switch (_p25.ctor) {
			case 'Visit':
				return A2(_lorenzo$elm_webdriver$Webdriver_LowLevel$url, _p25._0, browser);
			case 'Click':
				var _p26 = _p25._0;
				return A2(
					_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
					A2(
						_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
						A2(_lorenzo$elm_webdriver$Webdriver_Process$validateSelector, _p26, browser),
						A2(_lorenzo$elm_webdriver$Webdriver_Process$autoWait, _p26, browser)),
					A2(_lorenzo$elm_webdriver$Webdriver_LowLevel$click, _p26, browser));
			case 'MoveTo':
				var _p27 = _p25._0;
				return A2(
					_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
					A2(
						_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
						A2(_lorenzo$elm_webdriver$Webdriver_Process$validateSelector, _p27, browser),
						A2(_lorenzo$elm_webdriver$Webdriver_Process$autoWait, _p27, browser)),
					A2(_lorenzo$elm_webdriver$Webdriver_LowLevel$moveTo, _p27, browser));
			case 'MoveToWithOffset':
				var _p28 = _p25._0;
				return A2(
					_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
					A2(
						_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
						A2(_lorenzo$elm_webdriver$Webdriver_Process$validateSelector, _p28, browser),
						A2(_lorenzo$elm_webdriver$Webdriver_Process$autoWait, _p28, browser)),
					A4(
						_lorenzo$elm_webdriver$Webdriver_LowLevel$moveToWithOffset,
						_p28,
						_elm_lang$core$Maybe$Just(_p25._1),
						_elm_lang$core$Maybe$Just(_p25._2),
						browser));
			case 'SetValue':
				var _p29 = _p25._0;
				return A2(
					_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
					A2(
						_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
						A2(_lorenzo$elm_webdriver$Webdriver_Process$inputAutoWait, _p29, browser),
						A2(_lorenzo$elm_webdriver$Webdriver_Process$validateSelector, _p29, browser)),
					A3(_lorenzo$elm_webdriver$Webdriver_LowLevel$setValue, _p29, _p25._1, browser));
			case 'AppendValue':
				var _p30 = _p25._0;
				return A2(
					_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
					A2(
						_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
						A2(_lorenzo$elm_webdriver$Webdriver_Process$validateSelector, _p30, browser),
						A2(_lorenzo$elm_webdriver$Webdriver_Process$inputAutoWait, _p30, browser)),
					A3(_lorenzo$elm_webdriver$Webdriver_LowLevel$appendValue, _p30, _p25._1, browser));
			case 'ClearValue':
				var _p31 = _p25._0;
				return A2(
					_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
					A2(
						_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
						A2(_lorenzo$elm_webdriver$Webdriver_Process$validateSelector, _p31, browser),
						A2(_lorenzo$elm_webdriver$Webdriver_Process$inputAutoWait, _p31, browser)),
					A2(_lorenzo$elm_webdriver$Webdriver_LowLevel$clearValue, _p31, browser));
			case 'SelectByValue':
				var _p32 = _p25._0;
				return A2(
					_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
					A2(
						_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
						A2(_lorenzo$elm_webdriver$Webdriver_Process$validateSelector, _p32, browser),
						A2(_lorenzo$elm_webdriver$Webdriver_Process$inputAutoWait, _p32, browser)),
					A3(_lorenzo$elm_webdriver$Webdriver_LowLevel$selectByValue, _p32, _p25._1, browser));
			case 'SelectByIndex':
				var _p33 = _p25._0;
				return A2(
					_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
					A2(
						_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
						A2(_lorenzo$elm_webdriver$Webdriver_Process$validateSelector, _p33, browser),
						A2(_lorenzo$elm_webdriver$Webdriver_Process$inputAutoWait, _p33, browser)),
					A3(_lorenzo$elm_webdriver$Webdriver_LowLevel$selectByIndex, _p33, _p25._1, browser));
			case 'SelectByText':
				var _p34 = _p25._0;
				return A2(
					_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
					A2(
						_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
						A2(_lorenzo$elm_webdriver$Webdriver_Process$validateSelector, _p34, browser),
						A2(_lorenzo$elm_webdriver$Webdriver_Process$inputAutoWait, _p34, browser)),
					A3(_lorenzo$elm_webdriver$Webdriver_LowLevel$selectByText, _p34, _p25._1, browser));
			case 'SelectByAttribute':
				var _p35 = _p25._0;
				return A2(
					_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
					A2(
						_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
						A2(_lorenzo$elm_webdriver$Webdriver_Process$validateSelector, _p35, browser),
						A2(_lorenzo$elm_webdriver$Webdriver_Process$inputAutoWait, _p35, browser)),
					A4(_lorenzo$elm_webdriver$Webdriver_LowLevel$selectByAttribute, _p35, _p25._1, _p25._2, browser));
			case 'Submit':
				var _p36 = _p25._0;
				return A2(
					_lorenzo$elm_webdriver$Webdriver_Process_ops['&>'],
					A2(_lorenzo$elm_webdriver$Webdriver_Process$validateSelector, _p36, browser),
					A2(_lorenzo$elm_webdriver$Webdriver_LowLevel$submitForm, _p36, browser));
			case 'SetCookie':
				return A3(_lorenzo$elm_webdriver$Webdriver_LowLevel$setCookie, _p25._0, _p25._1, browser);
			case 'DeleteCookie':
				return A2(_lorenzo$elm_webdriver$Webdriver_LowLevel$deleteCookie, _p25._0, browser);
			case 'WaitForExist':
				return A3(_lorenzo$elm_webdriver$Webdriver_LowLevel$waitForExist, _p25._0, _p25._1, browser);
			case 'WaitForNotExist':
				return A3(_lorenzo$elm_webdriver$Webdriver_LowLevel$waitForNotExist, _p25._0, _p25._1, browser);
			case 'WaitForVisible':
				return A3(_lorenzo$elm_webdriver$Webdriver_LowLevel$waitForVisible, _p25._0, _p25._1, browser);
			case 'WaitForNotVisible':
				return A3(_lorenzo$elm_webdriver$Webdriver_LowLevel$waitForNotVisible, _p25._0, _p25._1, browser);
			case 'WaitForValue':
				return A3(_lorenzo$elm_webdriver$Webdriver_LowLevel$waitForValue, _p25._0, _p25._1, browser);
			case 'WaitForNoValue':
				return A3(_lorenzo$elm_webdriver$Webdriver_LowLevel$waitForNoValue, _p25._0, _p25._1, browser);
			case 'WaitForSelected':
				return A3(_lorenzo$elm_webdriver$Webdriver_LowLevel$waitForSelected, _p25._0, _p25._1, browser);
			case 'WaitForNotSelected':
				return A3(_lorenzo$elm_webdriver$Webdriver_LowLevel$waitForNotSelected, _p25._0, _p25._1, browser);
			case 'WaitForText':
				return A3(_lorenzo$elm_webdriver$Webdriver_LowLevel$waitForText, _p25._0, _p25._1, browser);
			case 'WaitForNoText':
				return A3(_lorenzo$elm_webdriver$Webdriver_LowLevel$waitForNoText, _p25._0, _p25._1, browser);
			case 'WaitForEnabled':
				return A3(_lorenzo$elm_webdriver$Webdriver_LowLevel$waitForEnabled, _p25._0, _p25._1, browser);
			case 'WaitForNotEnabled':
				return A3(_lorenzo$elm_webdriver$Webdriver_LowLevel$waitForNotEnabled, _p25._0, _p25._1, browser);
			case 'WaitForDebug':
				return _lorenzo$elm_webdriver$Webdriver_LowLevel$debug(browser);
			case 'Pause':
				return A2(_lorenzo$elm_webdriver$Webdriver_LowLevel$pause, _p25._0, browser);
			case 'Scroll':
				return A3(_lorenzo$elm_webdriver$Webdriver_LowLevel$scrollWindow, _p25._0, _p25._1, browser);
			case 'ScrollTo':
				return A4(_lorenzo$elm_webdriver$Webdriver_LowLevel$scrollToElementOffset, _p25._0, _p25._1, _p25._2, browser);
			case 'SavePagecreenshot':
				return A2(_lorenzo$elm_webdriver$Webdriver_LowLevel$savePageScreenshot, _p25._0, browser);
			case 'SwitchFrame':
				return A2(_lorenzo$elm_webdriver$Webdriver_LowLevel$switchToFrame, _p25._0, browser);
			case 'TriggerClick':
				return A2(_lorenzo$elm_webdriver$Webdriver_LowLevel$triggerClick, _p25._0, browser);
			case 'End':
				return _lorenzo$elm_webdriver$Webdriver_LowLevel$end(browser);
			case 'Close':
				return _lorenzo$elm_webdriver$Webdriver_LowLevel$close(browser);
			case 'WindowResize':
				return A3(_lorenzo$elm_webdriver$Webdriver_LowLevel$windowResize, _p25._0, _p25._1, browser);
			default:
				return A2(_lorenzo$elm_webdriver$Webdriver_LowLevel$keys, _p25._0, browser);
		}
	});
var _lorenzo$elm_webdriver$Webdriver_Process$errorMessage = function (error) {
	var _p37 = error;
	switch (_p37.ctor) {
		case 'ConnectionError':
			return A2(_elm_lang$core$Basics_ops['++'], 'Could not connect to server:\n\n', _p37._0.message);
		case 'MissingElement':
			return A2(
				_elm_lang$core$Basics_ops['++'],
				'The element you are trying to reach the element <',
				A2(
					_elm_lang$core$Basics_ops['++'],
					_p37._0.selector,
					A2(_elm_lang$core$Basics_ops['++'], '>, but  it is missing.\n\n', _p37._0.message)));
		case 'UnreachableElement':
			return A2(
				_elm_lang$core$Basics_ops['++'],
				'The element you are trying to reach the element <',
				A2(
					_elm_lang$core$Basics_ops['++'],
					_p37._0.selector,
					A2(_elm_lang$core$Basics_ops['++'], '>, but it is not visible.\n\n', _p37._0.message)));
		case 'TooManyElements':
			return _p37._0.message;
		case 'FailedElementPrecondition':
			return A2(
				_elm_lang$core$Basics_ops['++'],
				'Tried to use the selector <',
				A2(
					_elm_lang$core$Basics_ops['++'],
					_p37._0.selector,
					A2(_elm_lang$core$Basics_ops['++'], '>, but it is not valid.\n\n', _p37._0.message)));
		case 'UnknownError':
			return A2(_elm_lang$core$Basics_ops['++'], 'Oops, something wrong happened.\n\n', _p37._0.message);
		case 'InvalidCommand':
			return _p37._0.message;
		default:
			return '';
	}
};
var _lorenzo$elm_webdriver$Webdriver_Process$init = function (actions) {
	return {ctor: '_Tuple2', _0: _elm_lang$core$Maybe$Nothing, _1: actions};
};
var _lorenzo$elm_webdriver$Webdriver_Process$Meta = F2(
	function (a, b) {
		return {name: a, withScreenshot: b};
	});
var _lorenzo$elm_webdriver$Webdriver_Process$Finish = {ctor: 'Finish'};
var _lorenzo$elm_webdriver$Webdriver_Process$finishSession = function (browser) {
	return A2(
		_elm_lang$core$Task$attempt,
		_lorenzo$elm_webdriver$Webdriver_Process$toMessage,
		A2(
			_elm_lang$core$Task$mapError,
			_elm_lang$core$Basics$always(_lorenzo$elm_webdriver$Webdriver_Process$Finish),
			A2(
				_elm_lang$core$Task$map,
				_elm_lang$core$Basics$always(_lorenzo$elm_webdriver$Webdriver_Process$Finish),
				_lorenzo$elm_webdriver$Webdriver_LowLevel$end(browser))));
};
var _lorenzo$elm_webdriver$Webdriver_Process$OnError = F3(
	function (a, b, c) {
		return {ctor: 'OnError', _0: a, _1: b, _2: c};
	});
var _lorenzo$elm_webdriver$Webdriver_Process$screenshotOnError = F3(
	function (browser, desc, task) {
		return A2(
			_elm_lang$core$Task$onError,
			function (error) {
				return A2(
					_elm_lang$core$Task$andThen,
					function (screenshot) {
						return _elm_lang$core$Task$fail(
							A3(
								_lorenzo$elm_webdriver$Webdriver_Process$OnError,
								desc,
								error,
								_elm_lang$core$Maybe$Just(screenshot)));
					},
					A2(
						_elm_lang$core$Task$onError,
						function (error) {
							return _elm_lang$core$Task$fail(
								A3(_lorenzo$elm_webdriver$Webdriver_Process$OnError, desc, error, _elm_lang$core$Maybe$Nothing));
						},
						_lorenzo$elm_webdriver$Webdriver_LowLevel$viewportScreenshot(browser)));
			},
			task);
	});
var _lorenzo$elm_webdriver$Webdriver_Process$ProcessBranch = F2(
	function (a, b) {
		return {ctor: 'ProcessBranch', _0: a, _1: b};
	});
var _lorenzo$elm_webdriver$Webdriver_Process$Process = function (a) {
	return {ctor: 'Process', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_Process$resolveBranch = F2(
	function (decider, _p38) {
		var _p39 = _p38;
		var _p41 = _p39._1;
		var _p40 = decider(_p39._0);
		if (_p40.ctor === '[]') {
			return _lorenzo$elm_webdriver$Webdriver_Process$Process(_p41);
		} else {
			return A2(_lorenzo$elm_webdriver$Webdriver_Process$ProcessBranch, _p41, _p40);
		}
	});
var _lorenzo$elm_webdriver$Webdriver_Process$Initiated = function (a) {
	return {ctor: 'Initiated', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_Process$startSession = function (options) {
	return A2(
		_elm_lang$core$Task$attempt,
		_lorenzo$elm_webdriver$Webdriver_Process$toMessage,
		A2(
			_elm_lang$core$Task$mapError,
			function (error) {
				return A3(_lorenzo$elm_webdriver$Webdriver_Process$OnError, 'Connecting to Selenium Server', error, _elm_lang$core$Maybe$Nothing);
			},
			A2(
				_elm_lang$core$Task$map,
				function (_p42) {
					var _p43 = _p42;
					return _lorenzo$elm_webdriver$Webdriver_Process$Initiated(_p43._1);
				},
				_lorenzo$elm_webdriver$Webdriver_LowLevel$open(options))));
};
var _lorenzo$elm_webdriver$Webdriver_Process$Start = function (a) {
	return {ctor: 'Start', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_Process$open = function (options) {
	return _lorenzo$elm_webdriver$Webdriver_Process$Start(options);
};
var _lorenzo$elm_webdriver$Webdriver_Process$None = {ctor: 'None'};
var _lorenzo$elm_webdriver$Webdriver_Process$Finalized = {ctor: 'Finalized'};
var _lorenzo$elm_webdriver$Webdriver_Process$Progress = F3(
	function (a, b, c) {
		return {ctor: 'Progress', _0: a, _1: b, _2: c};
	});
var _lorenzo$elm_webdriver$Webdriver_Process$Spawned = {ctor: 'Spawned'};
var _lorenzo$elm_webdriver$Webdriver_Process$StepResult = F2(
	function (a, b) {
		return {ctor: 'StepResult', _0: a, _1: b};
	});
var _lorenzo$elm_webdriver$Webdriver_Process$autoScreenshot = F4(
	function (browser, meta, toExpectation, task) {
		return meta.withScreenshot ? A2(
			_elm_lang$core$Task$map,
			function (_p44) {
				var _p45 = _p44;
				var _p46 = _p45._0;
				return {
					ctor: '_Tuple2',
					_0: _p46,
					_1: A2(
						_lorenzo$elm_webdriver$Webdriver_Process$StepResult,
						meta.name,
						{
							expectation: toExpectation(_p46),
							screenshot: _elm_lang$core$Maybe$Just(_p45._1)
						})
				};
			},
			A2(
				_lorenzo$elm_webdriver$Webdriver_Process_ops['#>'],
				task,
				_lorenzo$elm_webdriver$Webdriver_LowLevel$viewportScreenshot(browser))) : A2(
			_elm_lang$core$Task$map,
			function (res) {
				return {
					ctor: '_Tuple2',
					_0: res,
					_1: A2(
						_lorenzo$elm_webdriver$Webdriver_Process$StepResult,
						meta.name,
						{
							expectation: toExpectation(res),
							screenshot: _elm_lang$core$Maybe$Nothing
						})
				};
			},
			task);
	});
var _lorenzo$elm_webdriver$Webdriver_Process$convertAssertion = F4(
	function (browser, meta, assert, task) {
		return A2(
			_elm_lang$core$Task$attempt,
			_lorenzo$elm_webdriver$Webdriver_Process$toMessage,
			A2(
				_elm_lang$core$Task$map,
				_lorenzo$elm_webdriver$Webdriver_Process$Process,
				A2(
					_elm_lang$core$Task$map,
					_elm_lang$core$Tuple$second,
					A3(
						_lorenzo$elm_webdriver$Webdriver_Process$screenshotOnError,
						browser,
						meta.name,
						A4(
							_lorenzo$elm_webdriver$Webdriver_Process$autoScreenshot,
							browser,
							meta,
							function (_p47) {
								return _elm_lang$core$Maybe$Just(
									assert(_p47));
							},
							task)))));
	});
var _lorenzo$elm_webdriver$Webdriver_Process$performBranch = F4(
	function (meta, browser, decider, task) {
		return A2(
			_elm_lang$core$Task$attempt,
			_lorenzo$elm_webdriver$Webdriver_Process$toMessage,
			A2(
				_elm_lang$core$Task$map,
				_lorenzo$elm_webdriver$Webdriver_Process$resolveBranch(decider),
				A3(
					_lorenzo$elm_webdriver$Webdriver_Process$screenshotOnError,
					browser,
					meta.name,
					A4(
						_lorenzo$elm_webdriver$Webdriver_Process$autoScreenshot,
						browser,
						meta,
						_elm_lang$core$Basics$always(_elm_lang$core$Maybe$Nothing),
						task))));
	});
var _lorenzo$elm_webdriver$Webdriver_Process$process = F2(
	function (action, browser) {
		var command = function () {
			var _p48 = action;
			switch (_p48.ctor) {
				case 'AssertionString':
					return A4(
						_lorenzo$elm_webdriver$Webdriver_Process$convertAssertion,
						browser,
						_p48._0,
						_p48._2,
						A2(_lorenzo$elm_webdriver$Webdriver_Process$processStringStep, _p48._1, browser));
				case 'AssertionMaybe':
					return A4(
						_lorenzo$elm_webdriver$Webdriver_Process$convertAssertion,
						browser,
						_p48._0,
						_p48._2,
						A2(_lorenzo$elm_webdriver$Webdriver_Process$processMaybeStep, _p48._1, browser));
				case 'AssertionGeometry':
					return A4(
						_lorenzo$elm_webdriver$Webdriver_Process$convertAssertion,
						browser,
						_p48._0,
						_p48._2,
						A2(_lorenzo$elm_webdriver$Webdriver_Process$processGeometryStep, _p48._1, browser));
				case 'AssertionBool':
					return A4(
						_lorenzo$elm_webdriver$Webdriver_Process$convertAssertion,
						browser,
						_p48._0,
						_p48._2,
						A2(_lorenzo$elm_webdriver$Webdriver_Process$processBoolStep, _p48._1, browser));
				case 'AssertionInt':
					return A4(
						_lorenzo$elm_webdriver$Webdriver_Process$convertAssertion,
						browser,
						_p48._0,
						_p48._2,
						A2(_lorenzo$elm_webdriver$Webdriver_Process$processIntStep, _p48._1, browser));
				case 'AssertionTask':
					var _p50 = _p48._0;
					return A2(
						_elm_lang$core$Task$attempt,
						_lorenzo$elm_webdriver$Webdriver_Process$toMessage,
						A2(
							_elm_lang$core$Task$map,
							_lorenzo$elm_webdriver$Webdriver_Process$Process,
							A2(
								_elm_lang$core$Task$map,
								_elm_lang$core$Tuple$second,
								A3(
									_lorenzo$elm_webdriver$Webdriver_Process$screenshotOnError,
									browser,
									_p50.name,
									A4(
										_lorenzo$elm_webdriver$Webdriver_Process$autoScreenshot,
										browser,
										_p50,
										_elm_lang$core$Maybe$Just,
										A2(
											_elm_lang$core$Task$mapError,
											function (_p49) {
												return _lorenzo$elm_webdriver$Webdriver_LowLevel$Never;
											},
											_p48._1))))));
				case 'AssertionWebdriver':
					var _p51 = _p48._0;
					return A2(
						_elm_lang$core$Task$attempt,
						_lorenzo$elm_webdriver$Webdriver_Process$toMessage,
						A2(
							_elm_lang$core$Task$map,
							_lorenzo$elm_webdriver$Webdriver_Process$Process,
							A2(
								_elm_lang$core$Task$map,
								_elm_lang$core$Tuple$second,
								A3(
									_lorenzo$elm_webdriver$Webdriver_Process$screenshotOnError,
									browser,
									_p51.name,
									A4(
										_lorenzo$elm_webdriver$Webdriver_Process$autoScreenshot,
										browser,
										_p51,
										_elm_lang$core$Maybe$Just,
										_p48._1(browser))))));
				case 'ReturningUnit':
					var _p52 = _p48._0;
					return A2(
						_elm_lang$core$Task$attempt,
						_lorenzo$elm_webdriver$Webdriver_Process$toMessage,
						A2(
							_elm_lang$core$Task$map,
							_lorenzo$elm_webdriver$Webdriver_Process$Process,
							A2(
								_elm_lang$core$Task$map,
								_elm_lang$core$Tuple$second,
								A3(
									_lorenzo$elm_webdriver$Webdriver_Process$screenshotOnError,
									browser,
									_p52.name,
									A4(
										_lorenzo$elm_webdriver$Webdriver_Process$autoScreenshot,
										browser,
										_p52,
										_elm_lang$core$Basics$always(_elm_lang$core$Maybe$Nothing),
										A2(_lorenzo$elm_webdriver$Webdriver_Process$processStep, _p48._1, browser))))));
				case 'BranchMaybe':
					return A4(
						_lorenzo$elm_webdriver$Webdriver_Process$performBranch,
						_p48._0,
						browser,
						_p48._2,
						A2(_lorenzo$elm_webdriver$Webdriver_Process$processMaybeStep, _p48._1, browser));
				case 'BranchString':
					return A4(
						_lorenzo$elm_webdriver$Webdriver_Process$performBranch,
						_p48._0,
						browser,
						_p48._2,
						A2(_lorenzo$elm_webdriver$Webdriver_Process$processStringStep, _p48._1, browser));
				case 'BranchBool':
					return A4(
						_lorenzo$elm_webdriver$Webdriver_Process$performBranch,
						_p48._0,
						browser,
						_p48._2,
						A2(_lorenzo$elm_webdriver$Webdriver_Process$processBoolStep, _p48._1, browser));
				case 'BranchGeometry':
					return A4(
						_lorenzo$elm_webdriver$Webdriver_Process$performBranch,
						_p48._0,
						browser,
						_p48._2,
						A2(_lorenzo$elm_webdriver$Webdriver_Process$processGeometryStep, _p48._1, browser));
				case 'BranchInt':
					return A4(
						_lorenzo$elm_webdriver$Webdriver_Process$performBranch,
						_p48._0,
						browser,
						_p48._2,
						A2(_lorenzo$elm_webdriver$Webdriver_Process$processIntStep, _p48._1, browser));
				case 'BranchTask':
					var _p54 = _p48._0;
					return A2(
						_elm_lang$core$Task$attempt,
						_lorenzo$elm_webdriver$Webdriver_Process$toMessage,
						A2(
							_elm_lang$core$Task$map,
							_lorenzo$elm_webdriver$Webdriver_Process$resolveBranch(_elm_lang$core$Basics$identity),
							A3(
								_lorenzo$elm_webdriver$Webdriver_Process$screenshotOnError,
								browser,
								_p54.name,
								A4(
									_lorenzo$elm_webdriver$Webdriver_Process$autoScreenshot,
									browser,
									_p54,
									_elm_lang$core$Basics$always(_elm_lang$core$Maybe$Nothing),
									A2(
										_elm_lang$core$Task$mapError,
										function (_p53) {
											return _lorenzo$elm_webdriver$Webdriver_LowLevel$Never;
										},
										_p48._1)))));
				default:
					var _p55 = _p48._0;
					return A2(
						_elm_lang$core$Task$attempt,
						_lorenzo$elm_webdriver$Webdriver_Process$toMessage,
						A2(
							_elm_lang$core$Task$map,
							_lorenzo$elm_webdriver$Webdriver_Process$resolveBranch(_elm_lang$core$Basics$identity),
							A3(
								_lorenzo$elm_webdriver$Webdriver_Process$screenshotOnError,
								browser,
								_p55.name,
								A4(
									_lorenzo$elm_webdriver$Webdriver_Process$autoScreenshot,
									browser,
									_p55,
									_elm_lang$core$Basics$always(_elm_lang$core$Maybe$Nothing),
									_p48._1(browser)))));
			}
		}();
		return command;
	});
var _lorenzo$elm_webdriver$Webdriver_Process$update = F2(
	function (msg, model) {
		update:
		while (true) {
			var _p56 = {ctor: '_Tuple2', _0: model, _1: msg};
			_v16_8:
			do {
				switch (_p56._1.ctor) {
					case 'Start':
						return {
							ctor: '_Tuple3',
							_0: model,
							_1: _lorenzo$elm_webdriver$Webdriver_Process$startSession(_p56._1._0),
							_2: _lorenzo$elm_webdriver$Webdriver_Process$None
						};
					case 'Initiated':
						if (_p56._0.ctor === '_Tuple2') {
							var command = A2(
								_elm_lang$core$Task$perform,
								_lorenzo$elm_webdriver$Webdriver_Process$Process,
								_elm_lang$core$Task$succeed(
									A2(
										_lorenzo$elm_webdriver$Webdriver_Process$StepResult,
										'Begin session',
										{expectation: _elm_lang$core$Maybe$Nothing, screenshot: _elm_lang$core$Maybe$Nothing})));
							var newModel = {
								ctor: '_Tuple2',
								_0: _elm_lang$core$Maybe$Just(_p56._1._0),
								_1: _p56._0._1
							};
							return {ctor: '_Tuple3', _0: newModel, _1: command, _2: _lorenzo$elm_webdriver$Webdriver_Process$Spawned};
						} else {
							break _v16_8;
						}
					case 'Process':
						if ((_p56._0.ctor === '_Tuple2') && (_p56._0._0.ctor === 'Just')) {
							if (_p56._0._1.ctor === '[]') {
								return {
									ctor: '_Tuple3',
									_0: {
										ctor: '_Tuple2',
										_0: _elm_lang$core$Maybe$Nothing,
										_1: {ctor: '[]'}
									},
									_1: _lorenzo$elm_webdriver$Webdriver_Process$finishSession(_p56._0._0._0),
									_2: A3(_lorenzo$elm_webdriver$Webdriver_Process$Progress, 0, _p56._1._0, 'End Session')
								};
							} else {
								if ((_p56._0._1._0.ctor === 'ReturningUnit') && (_p56._0._1._0._1.ctor === 'End')) {
									return {
										ctor: '_Tuple3',
										_0: {
											ctor: '_Tuple2',
											_0: _elm_lang$core$Maybe$Nothing,
											_1: {ctor: '[]'}
										},
										_1: _lorenzo$elm_webdriver$Webdriver_Process$finishSession(_p56._0._0._0),
										_2: A3(_lorenzo$elm_webdriver$Webdriver_Process$Progress, 0, _p56._1._0, _p56._0._1._0._0.name)
									};
								} else {
									var _p59 = _p56._0._1._1;
									var _p58 = _p56._0._0._0;
									var _p57 = _p56._0._1._0;
									var newModel = {
										ctor: '_Tuple2',
										_0: _elm_lang$core$Maybe$Just(_p58),
										_1: _p59
									};
									var outMsg = A3(
										_lorenzo$elm_webdriver$Webdriver_Process$Progress,
										_elm_lang$core$List$length(_p59),
										_p56._1._0,
										_lorenzo$elm_webdriver$Webdriver_Step$stepName(_p57));
									return {
										ctor: '_Tuple3',
										_0: newModel,
										_1: A2(_lorenzo$elm_webdriver$Webdriver_Process$process, _p57, _p58),
										_2: outMsg
									};
								}
							}
						} else {
							break _v16_8;
						}
					case 'OnError':
						if ((_p56._0.ctor === '_Tuple2') && (_p56._0._0.ctor === 'Just')) {
							var message = A2(
								_lorenzo$elm_webdriver$Webdriver_Process$StepResult,
								_p56._1._0,
								{
									expectation: _elm_lang$core$Maybe$Just(
										_elm_community$elm_test$Expect$fail(
											_lorenzo$elm_webdriver$Webdriver_Process$errorMessage(_p56._1._1))),
									screenshot: _p56._1._2
								});
							var newMessage = _lorenzo$elm_webdriver$Webdriver_Process$Process(message);
							var _v17 = newMessage,
								_v18 = {
								ctor: '_Tuple2',
								_0: _elm_lang$core$Maybe$Just(_p56._0._0._0),
								_1: {ctor: '[]'}
							};
							msg = _v17;
							model = _v18;
							continue update;
						} else {
							break _v16_8;
						}
					case 'ProcessBranch':
						if (((_p56._0.ctor === '_Tuple2') && (_p56._0._0.ctor === 'Just')) && (_p56._1._1.ctor === '::')) {
							var _p61 = _p56._0._0._0;
							var _p60 = _p56._1._1._0;
							var newSteps = A2(_elm_lang$core$List$append, _p56._1._1._1, _p56._0._1);
							var outMsg = A3(
								_lorenzo$elm_webdriver$Webdriver_Process$Progress,
								_elm_lang$core$List$length(newSteps),
								_p56._1._0,
								_lorenzo$elm_webdriver$Webdriver_Step$stepName(_p60));
							var newModel = {
								ctor: '_Tuple2',
								_0: _elm_lang$core$Maybe$Just(_p61),
								_1: newSteps
							};
							return {
								ctor: '_Tuple3',
								_0: newModel,
								_1: A2(_lorenzo$elm_webdriver$Webdriver_Process$process, _p60, _p61),
								_2: outMsg
							};
						} else {
							break _v16_8;
						}
					default:
						if (_p56._0.ctor === '_Tuple2') {
							return {
								ctor: '_Tuple3',
								_0: {
									ctor: '_Tuple2',
									_0: _elm_lang$core$Maybe$Nothing,
									_1: {ctor: '[]'}
								},
								_1: _elm_lang$core$Platform_Cmd$none,
								_2: _lorenzo$elm_webdriver$Webdriver_Process$Finalized
							};
						} else {
							break _v16_8;
						}
				}
			} while(false);
			return {ctor: '_Tuple3', _0: model, _1: _elm_lang$core$Platform_Cmd$none, _2: _lorenzo$elm_webdriver$Webdriver_Process$None};
		}
	});

var _lorenzo$elm_webdriver$Webdriver_Runner$never = function (a) {
	never:
	while (true) {
		var _v0 = a;
		a = _v0;
		continue never;
	}
};
var _lorenzo$elm_webdriver$Webdriver_Runner$exitOutput = F3(
	function (summary, startTime, endTime) {
		var ellapsed = (endTime - startTime) / _elm_lang$core$Time$second;
		var epilog = A2(
			_elm_lang$core$Basics_ops['++'],
			_elm_lang$core$Basics$toString(summary.passed),
			A2(
				_elm_lang$core$Basics_ops['++'],
				' assertions passed. Took ',
				A2(
					_elm_lang$core$Basics_ops['++'],
					_elm_lang$core$Basics$toString(ellapsed),
					's in total.')));
		var statusWord = (_elm_lang$core$Native_Utils.cmp(summary.failed, 0) > 0) ? A2(
			_elm_lang$core$Basics_ops['++'],
			'Failed: ',
			A2(
				_elm_lang$core$Basics_ops['++'],
				_elm_lang$core$Basics$toString(summary.failed),
				' assertions failed, ')) : 'OK. ';
		return _elm_lang$core$Native_Utils.update(
			summary,
			{
				output: A2(
					_elm_lang$core$Basics_ops['++'],
					'\n\n',
					A2(_elm_lang$core$Basics_ops['++'], statusWord, epilog))
			});
	});
var _lorenzo$elm_webdriver$Webdriver_Runner$getFirstRunTime = F2(
	function (startTimes, $default) {
		return A2(
			_elm_lang$core$Maybe$withDefault,
			$default,
			_elm_lang$core$List$minimum(
				A2(
					_elm_lang$core$List$map,
					_elm_lang$core$Tuple$second,
					_elm_lang$core$Dict$toList(startTimes))));
	});
var _lorenzo$elm_webdriver$Webdriver_Runner$indentLines = function (str) {
	return A2(
		_elm_lang$core$String$join,
		'\n',
		A2(
			_elm_lang$core$List$map,
			F2(
				function (x, y) {
					return A2(_elm_lang$core$Basics_ops['++'], x, y);
				})('    '),
			A2(_elm_lang$core$String$split, '\n', str)));
};
var _lorenzo$elm_webdriver$Webdriver_Runner$fromResult = F4(
	function (description, expectation, screenshots, summary) {
		var _p0 = _elm_community$elm_test$Expect$getFailure(expectation);
		if (_p0.ctor === 'Nothing') {
			return _elm_lang$core$Native_Utils.update(
				summary,
				{
					output: A2(
						_elm_lang$core$Basics_ops['++'],
						summary.output,
						A2(
							_elm_lang$core$Basics_ops['++'],
							'✅  ',
							A2(_elm_lang$core$Basics_ops['++'], description, '\n'))),
					passed: summary.passed + 1,
					screenshots: A2(_elm_lang$core$List$append, summary.screenshots, screenshots)
				});
		} else {
			var _p1 = _p0._0.given;
			var heading = A2(
				_elm_lang$core$Basics_ops['++'],
				'❌  ',
				A2(_elm_lang$core$Basics_ops['++'], description, '\n'));
			var prefix = _elm_lang$core$String$isEmpty(_p1) ? heading : A2(
				_elm_lang$core$Basics_ops['++'],
				heading,
				A2(_elm_lang$core$Basics_ops['++'], _p1, '\n'));
			var newOutput = A2(
				_elm_lang$core$Basics_ops['++'],
				A2(
					_elm_lang$core$Basics_ops['++'],
					prefix,
					_lorenzo$elm_webdriver$Webdriver_Runner$indentLines(_p0._0.message)),
				'\n');
			return _elm_lang$core$Native_Utils.update(
				summary,
				{
					output: A2(_elm_lang$core$Basics_ops['++'], summary.output, newOutput),
					failed: summary.failed + 1,
					screenshots: A2(_elm_lang$core$List$append, summary.screenshots, screenshots)
				});
		}
	});
var _lorenzo$elm_webdriver$Webdriver_Runner$updateSummary = F2(
	function (_p2, summary) {
		var _p3 = _p2;
		var _p5 = _p3._0;
		var _p4 = {ctor: '_Tuple2', _0: _p3._1.expectation, _1: _p3._1.screenshot};
		_v3_3:
		do {
			if (_p4.ctor === '_Tuple2') {
				if (_p4._0.ctor === 'Just') {
					if (_p4._1.ctor === 'Nothing') {
						return A4(
							_lorenzo$elm_webdriver$Webdriver_Runner$fromResult,
							_p5,
							_p4._0._0,
							{ctor: '[]'},
							summary);
					} else {
						return A4(
							_lorenzo$elm_webdriver$Webdriver_Runner$fromResult,
							_p5,
							_p4._0._0,
							{
								ctor: '::',
								_0: _p4._1._0,
								_1: {ctor: '[]'}
							},
							summary);
					}
				} else {
					if (_p4._1.ctor === 'Just') {
						return _elm_lang$core$Native_Utils.update(
							summary,
							{
								screenshots: A2(
									_elm_lang$core$List$append,
									summary.screenshots,
									{
										ctor: '::',
										_0: _p4._1._0,
										_1: {ctor: '[]'}
									})
							});
					} else {
						break _v3_3;
					}
				}
			} else {
				break _v3_3;
			}
		} while(false);
		return summary;
	});
var _lorenzo$elm_webdriver$Webdriver_Runner$flattenRuns = F2(
	function (result, suite) {
		var _p6 = suite;
		if (_p6.ctor === 'Group') {
			return A2(
				_elm_lang$core$List$append,
				result,
				A2(
					_elm_lang$core$List$map,
					function (_p7) {
						var _p8 = _p7;
						return {
							ctor: '_Tuple2',
							_0: A2(
								_elm_lang$core$Basics_ops['++'],
								_p6._0,
								A2(_elm_lang$core$Basics_ops['++'], ' / ', _p8._0)),
							_1: _p8._1
						};
					},
					_elm_lang$core$List$concat(
						A2(
							_elm_lang$core$List$map,
							_lorenzo$elm_webdriver$Webdriver_Runner$flattenRuns(
								{ctor: '[]'}),
							_p6._1))));
		} else {
			return {
				ctor: '::',
				_0: {ctor: '_Tuple2', _0: _p6._0, _1: _p6._1},
				_1: result
			};
		}
	});
var _lorenzo$elm_webdriver$Webdriver_Runner$initStatus = function (total) {
	return {failed: false, total: total, remaining: total, nextStep: 'Waiting for start'};
};
var _lorenzo$elm_webdriver$Webdriver_Runner$newSummary = {
	output: '',
	passed: 0,
	failed: 0,
	screenshots: {ctor: '[]'}
};
var _lorenzo$elm_webdriver$Webdriver_Runner$initModel = F2(
	function (options, runs) {
		return {runs: runs, options: options, sessions: _elm_lang$core$Dict$empty, summaries: _elm_lang$core$Dict$empty, summary: _lorenzo$elm_webdriver$Webdriver_Runner$newSummary, initTimes: _elm_lang$core$Dict$empty, startTimes: _elm_lang$core$Dict$empty, statuses: _elm_lang$core$Dict$empty};
	});
var _lorenzo$elm_webdriver$Webdriver_Runner$encodeSummary = function (summary) {
	return _elm_lang$core$Json_Encode$object(
		{
			ctor: '::',
			_0: {
				ctor: '_Tuple2',
				_0: 'output',
				_1: _elm_lang$core$Json_Encode$string(summary.output)
			},
			_1: {
				ctor: '::',
				_0: {
					ctor: '_Tuple2',
					_0: 'passed',
					_1: _elm_lang$core$Json_Encode$int(summary.passed)
				},
				_1: {
					ctor: '::',
					_0: {
						ctor: '_Tuple2',
						_0: 'failed',
						_1: _elm_lang$core$Json_Encode$int(summary.failed)
					},
					_1: {
						ctor: '::',
						_0: {
							ctor: '_Tuple2',
							_0: 'screenshots',
							_1: _elm_lang$core$Json_Encode$list(
								A2(_elm_lang$core$List$map, _elm_lang$core$Json_Encode$string, summary.screenshots))
						},
						_1: {ctor: '[]'}
					}
				}
			}
		});
};
var _lorenzo$elm_webdriver$Webdriver_Runner$encodeRunStatus = function (status) {
	return _elm_lang$core$Json_Encode$object(
		{
			ctor: '::',
			_0: {
				ctor: '_Tuple2',
				_0: 'failed',
				_1: _elm_lang$core$Json_Encode$bool(status.failed)
			},
			_1: {
				ctor: '::',
				_0: {
					ctor: '_Tuple2',
					_0: 'total',
					_1: _elm_lang$core$Json_Encode$int(status.total)
				},
				_1: {
					ctor: '::',
					_0: {
						ctor: '_Tuple2',
						_0: 'remaining',
						_1: _elm_lang$core$Json_Encode$int(status.remaining)
					},
					_1: {
						ctor: '::',
						_0: {
							ctor: '_Tuple2',
							_0: 'nextStep',
							_1: _elm_lang$core$Json_Encode$string(status.nextStep)
						},
						_1: {ctor: '[]'}
					}
				}
			}
		});
};
var _lorenzo$elm_webdriver$Webdriver_Runner$PortEvent = F2(
	function (a, b) {
		return {name: a, value: b};
	});
var _lorenzo$elm_webdriver$Webdriver_Runner$toPort = function (event) {
	var _p9 = event;
	switch (_p9.ctor) {
		case 'Status':
			return A2(
				_lorenzo$elm_webdriver$Webdriver_Runner$PortEvent,
				'status',
				_elm_lang$core$Json_Encode$list(
					A2(
						_elm_lang$core$List$map,
						function (_p10) {
							var _p11 = _p10;
							return _elm_lang$core$Json_Encode$object(
								{
									ctor: '::',
									_0: {
										ctor: '_Tuple2',
										_0: 'name',
										_1: _elm_lang$core$Json_Encode$string(_p11._0)
									},
									_1: {
										ctor: '::',
										_0: {
											ctor: '_Tuple2',
											_0: 'value',
											_1: _lorenzo$elm_webdriver$Webdriver_Runner$encodeRunStatus(_p11._1)
										},
										_1: {ctor: '[]'}
									}
								});
						},
						_p9._0)));
		case 'StatusUpdate':
			return A2(
				_lorenzo$elm_webdriver$Webdriver_Runner$PortEvent,
				'statusUpdate',
				_elm_lang$core$Json_Encode$list(
					A2(
						_elm_lang$core$List$map,
						function (_p12) {
							var _p13 = _p12;
							return _elm_lang$core$Json_Encode$object(
								{
									ctor: '::',
									_0: {
										ctor: '_Tuple2',
										_0: 'name',
										_1: _elm_lang$core$Json_Encode$string(_p13._0)
									},
									_1: {
										ctor: '::',
										_0: {
											ctor: '_Tuple2',
											_0: 'value',
											_1: _lorenzo$elm_webdriver$Webdriver_Runner$encodeRunStatus(_p13._1)
										},
										_1: {ctor: '[]'}
									}
								});
						},
						_p9._0)));
		case 'Screenshots':
			return A2(
				_lorenzo$elm_webdriver$Webdriver_Runner$PortEvent,
				'screenshots',
				_elm_lang$core$Json_Encode$object(
					{
						ctor: '::',
						_0: {
							ctor: '_Tuple2',
							_0: 'name',
							_1: _elm_lang$core$Json_Encode$string(_p9._0)
						},
						_1: {
							ctor: '::',
							_0: {
								ctor: '_Tuple2',
								_0: 'shots',
								_1: _elm_lang$core$Json_Encode$list(
									A2(_elm_lang$core$List$map, _elm_lang$core$Json_Encode$string, _p9._1))
							},
							_1: {ctor: '[]'}
						}
					}));
		case 'Log':
			return A2(
				_lorenzo$elm_webdriver$Webdriver_Runner$PortEvent,
				'log',
				_elm_lang$core$Json_Encode$object(
					{
						ctor: '::',
						_0: {
							ctor: '_Tuple2',
							_0: 'name',
							_1: _elm_lang$core$Json_Encode$string(_p9._0)
						},
						_1: {
							ctor: '::',
							_0: {
								ctor: '_Tuple2',
								_0: 'value',
								_1: _lorenzo$elm_webdriver$Webdriver_Runner$encodeSummary(_p9._1)
							},
							_1: {ctor: '[]'}
						}
					}));
		default:
			return A2(
				_lorenzo$elm_webdriver$Webdriver_Runner$PortEvent,
				'exit',
				_lorenzo$elm_webdriver$Webdriver_Runner$encodeSummary(_p9._0));
	}
};
var _lorenzo$elm_webdriver$Webdriver_Runner$Model = F8(
	function (a, b, c, d, e, f, g, h) {
		return {options: a, runs: b, sessions: c, initTimes: d, startTimes: e, statuses: f, summaries: g, summary: h};
	});
var _lorenzo$elm_webdriver$Webdriver_Runner$RunStatus = F4(
	function (a, b, c, d) {
		return {failed: a, total: b, remaining: c, nextStep: d};
	});
var _lorenzo$elm_webdriver$Webdriver_Runner$Summary = F4(
	function (a, b, c, d) {
		return {output: a, passed: b, failed: c, screenshots: d};
	});
var _lorenzo$elm_webdriver$Webdriver_Runner$Flags = function (a) {
	return {filter: a};
};
var _lorenzo$elm_webdriver$Webdriver_Runner$Exit = function (a) {
	return {ctor: 'Exit', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_Runner$Log = F2(
	function (a, b) {
		return {ctor: 'Log', _0: a, _1: b};
	});
var _lorenzo$elm_webdriver$Webdriver_Runner$Screenshots = F2(
	function (a, b) {
		return {ctor: 'Screenshots', _0: a, _1: b};
	});
var _lorenzo$elm_webdriver$Webdriver_Runner$StatusUpdate = function (a) {
	return {ctor: 'StatusUpdate', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_Runner$updateStatus = F6(
	function (emit, runName, thisModel, remaining, result, nextStep) {
		var summaries = A3(
			_elm_lang$core$Dict$update,
			runName,
			_elm_lang$core$Maybe$map(
				_lorenzo$elm_webdriver$Webdriver_Runner$updateSummary(result)),
			thisModel.summaries);
		var failed = A2(
			_elm_lang$core$Maybe$withDefault,
			0,
			A2(
				_elm_lang$core$Maybe$map,
				function (_) {
					return _.failed;
				},
				A2(_elm_lang$core$Dict$get, runName, summaries)));
		var updater = function (status) {
			return _elm_lang$core$Native_Utils.update(
				status,
				{
					remaining: remaining,
					failed: status.failed || (_elm_lang$core$Native_Utils.cmp(failed, 0) > 0),
					nextStep: nextStep
				});
		};
		var newStatuses = A3(
			_elm_lang$core$Dict$update,
			runName,
			_elm_lang$core$Maybe$map(updater),
			thisModel.statuses);
		var newModel = _elm_lang$core$Native_Utils.update(
			thisModel,
			{statuses: newStatuses, summaries: summaries});
		return {
			ctor: '_Tuple2',
			_0: newModel,
			_1: emit(
				_lorenzo$elm_webdriver$Webdriver_Runner$StatusUpdate(
					_elm_lang$core$Dict$toList(newStatuses)))
		};
	});
var _lorenzo$elm_webdriver$Webdriver_Runner$Status = function (a) {
	return {ctor: 'Status', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_Runner$Run = F2(
	function (a, b) {
		return {ctor: 'Run', _0: a, _1: b};
	});
var _lorenzo$elm_webdriver$Webdriver_Runner$describe = F2(
	function (name, list) {
		return A2(_lorenzo$elm_webdriver$Webdriver_Runner$Run, name, list);
	});
var _lorenzo$elm_webdriver$Webdriver_Runner$Group = F2(
	function (a, b) {
		return {ctor: 'Group', _0: a, _1: b};
	});
var _lorenzo$elm_webdriver$Webdriver_Runner$group = F2(
	function (name, list) {
		return A2(_lorenzo$elm_webdriver$Webdriver_Runner$Group, name, list);
	});
var _lorenzo$elm_webdriver$Webdriver_Runner$Done = function (a) {
	return {ctor: 'Done', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_Runner$DriverMsg = F2(
	function (a, b) {
		return {ctor: 'DriverMsg', _0: a, _1: b};
	});
var _lorenzo$elm_webdriver$Webdriver_Runner$StopRun = F3(
	function (a, b, c) {
		return {ctor: 'StopRun', _0: a, _1: b, _2: c};
	});
var _lorenzo$elm_webdriver$Webdriver_Runner$endSummary = F4(
	function (emit, runName, thisModel, subModel) {
		var remainingSummaries = A2(_elm_lang$core$Dict$remove, runName, thisModel.summaries);
		var remainingSessions = A2(_elm_lang$core$Dict$remove, runName, thisModel.sessions);
		var summary = thisModel.summary;
		var runSummary = A2(
			_elm_lang$core$Maybe$withDefault,
			_lorenzo$elm_webdriver$Webdriver_Runner$newSummary,
			A2(_elm_lang$core$Dict$get, runName, thisModel.summaries));
		var updatedSummary = _elm_lang$core$Native_Utils.update(
			summary,
			{passed: summary.passed + runSummary.passed, failed: summary.failed + runSummary.failed});
		var newModel = _elm_lang$core$Native_Utils.update(
			thisModel,
			{sessions: remainingSessions, summary: updatedSummary, summaries: remainingSummaries});
		var signalStop = A2(
			_elm_lang$core$Task$perform,
			_elm_lang$core$Basics$identity,
			A2(
				_elm_lang$core$Task$map,
				A2(_lorenzo$elm_webdriver$Webdriver_Runner$StopRun, runName, runSummary),
				_elm_lang$core$Time$now));
		var persistScreenshots = emit(
			A2(_lorenzo$elm_webdriver$Webdriver_Runner$Screenshots, runName, runSummary.screenshots));
		return {
			ctor: '_Tuple2',
			_0: newModel,
			_1: _elm_lang$core$Platform_Cmd$batch(
				{
					ctor: '::',
					_0: signalStop,
					_1: {
						ctor: '::',
						_0: persistScreenshots,
						_1: {ctor: '[]'}
					}
				})
		};
	});
var _lorenzo$elm_webdriver$Webdriver_Runner$StartedRun = F2(
	function (a, b) {
		return {ctor: 'StartedRun', _0: a, _1: b};
	});
var _lorenzo$elm_webdriver$Webdriver_Runner$delegateMessage = F5(
	function (emit, runName, action, subModel, thisModel) {
		var _p14 = A2(_lorenzo$elm_webdriver$Webdriver_Process$update, action, subModel);
		var session = _p14._0;
		var next = _p14._1;
		var progressMessage = _p14._2;
		var subCommand = A2(
			_elm_lang$core$Platform_Cmd$map,
			_lorenzo$elm_webdriver$Webdriver_Runner$DriverMsg(runName),
			next);
		var newSessions = A3(_elm_lang$core$Dict$insert, runName, session, thisModel.sessions);
		var updatedModel = _elm_lang$core$Native_Utils.update(
			thisModel,
			{sessions: newSessions});
		var _p15 = function () {
			var _p16 = progressMessage;
			switch (_p16.ctor) {
				case 'Spawned':
					return {
						ctor: '_Tuple2',
						_0: updatedModel,
						_1: A2(
							_elm_lang$core$Task$perform,
							_elm_lang$core$Basics$identity,
							A2(
								_elm_lang$core$Task$map,
								_lorenzo$elm_webdriver$Webdriver_Runner$StartedRun(runName),
								_elm_lang$core$Time$now))
					};
				case 'Progress':
					return A6(_lorenzo$elm_webdriver$Webdriver_Runner$updateStatus, emit, runName, updatedModel, _p16._0, _p16._1, _p16._2);
				case 'None':
					return {ctor: '_Tuple2', _0: updatedModel, _1: _elm_lang$core$Platform_Cmd$none};
				default:
					return A4(_lorenzo$elm_webdriver$Webdriver_Runner$endSummary, emit, runName, updatedModel, subModel);
			}
		}();
		var newModel = _p15._0;
		var reportCommands = _p15._1;
		return {
			ctor: '_Tuple2',
			_0: newModel,
			_1: _elm_lang$core$Platform_Cmd$batch(
				{
					ctor: '::',
					_0: reportCommands,
					_1: {
						ctor: '::',
						_0: subCommand,
						_1: {ctor: '[]'}
					}
				})
		};
	});
var _lorenzo$elm_webdriver$Webdriver_Runner$StartRun = F3(
	function (a, b, c) {
		return {ctor: 'StartRun', _0: a, _1: b, _2: c};
	});
var _lorenzo$elm_webdriver$Webdriver_Runner$dispatchHelper = F3(
	function (options, _p18, _p17) {
		var _p19 = _p18;
		var _p23 = _p19._1._1;
		var _p20 = _p17;
		var _p22 = _p20._0;
		var status = _lorenzo$elm_webdriver$Webdriver_Runner$initStatus(
			_elm_lang$core$List$length(_p23));
		var _p21 = A2(
			_lorenzo$elm_webdriver$Webdriver_Process$update,
			_lorenzo$elm_webdriver$Webdriver_Process$open(options),
			_lorenzo$elm_webdriver$Webdriver_Process$init(_p23));
		var wModel = _p21._0;
		var wMsg = _p21._1;
		var key = A2(
			_elm_lang$core$Basics_ops['++'],
			_elm_lang$core$Basics$toString(_p19._0),
			A2(_elm_lang$core$Basics_ops['++'], ' - ', _p19._1._0));
		var newSessions = A3(_elm_lang$core$Dict$insert, key, wModel, _p22.sessions);
		var newStatuses = A3(_elm_lang$core$Dict$insert, key, status, _p22.statuses);
		var newSummaries = A3(_elm_lang$core$Dict$insert, key, _lorenzo$elm_webdriver$Webdriver_Runner$newSummary, _p22.summaries);
		var dispatchCommand = A2(
			_elm_lang$core$Task$perform,
			_elm_lang$core$Basics$identity,
			A2(
				_elm_lang$core$Task$map,
				A2(_lorenzo$elm_webdriver$Webdriver_Runner$StartRun, key, wMsg),
				_elm_lang$core$Time$now));
		return {
			ctor: '_Tuple2',
			_0: _elm_lang$core$Native_Utils.update(
				_p22,
				{sessions: newSessions, statuses: newStatuses, summaries: newSummaries}),
			_1: {ctor: '::', _0: dispatchCommand, _1: _p20._1}
		};
	});
var _lorenzo$elm_webdriver$Webdriver_Runner$dispatchTests = F3(
	function (emit, filterString, model) {
		var filter = A2(
			_elm_lang$core$Maybe$withDefault,
			_elm_lang$core$Basics$always(true),
			A2(_elm_lang$core$Maybe$map, _elm_lang$core$String$contains, filterString));
		var nextState = A3(
			_elm_lang$core$List$foldr,
			_lorenzo$elm_webdriver$Webdriver_Runner$dispatchHelper(model.options),
			{
				ctor: '_Tuple2',
				_0: model,
				_1: {ctor: '[]'}
			},
			A2(
				_elm_lang$core$List$indexedMap,
				F2(
					function (v0, v1) {
						return {ctor: '_Tuple2', _0: v0, _1: v1};
					}),
				A2(
					_elm_lang$core$List$filter,
					function (_p24) {
						return filter(
							_elm_lang$core$Tuple$first(_p24));
					},
					A2(
						_lorenzo$elm_webdriver$Webdriver_Runner$flattenRuns,
						{ctor: '[]'},
						model.runs))));
		var newModel = _elm_lang$core$Tuple$first(nextState);
		var statuses = _elm_lang$core$Dict$toList(newModel.statuses);
		return {
			ctor: '_Tuple2',
			_0: newModel,
			_1: _elm_lang$core$Platform_Cmd$batch(
				{
					ctor: '::',
					_0: emit(
						_lorenzo$elm_webdriver$Webdriver_Runner$Status(statuses)),
					_1: _elm_lang$core$Tuple$second(nextState)
				})
		};
	});
var _lorenzo$elm_webdriver$Webdriver_Runner$update = F3(
	function (emit, msg, model) {
		var _p25 = msg;
		switch (_p25.ctor) {
			case 'Begin':
				return A3(_lorenzo$elm_webdriver$Webdriver_Runner$dispatchTests, emit, _p25._0.filter, model);
			case 'StartRun':
				var _p26 = _p25._0;
				var newInitTimes = A3(_elm_lang$core$Dict$insert, _p26, _p25._2, model.initTimes);
				return {
					ctor: '_Tuple2',
					_0: _elm_lang$core$Native_Utils.update(
						model,
						{initTimes: newInitTimes}),
					_1: A2(
						_elm_lang$core$Platform_Cmd$map,
						_lorenzo$elm_webdriver$Webdriver_Runner$DriverMsg(_p26),
						_p25._1)
				};
			case 'StartedRun':
				var newStartTimes = A3(_elm_lang$core$Dict$insert, _p25._0, _p25._1, model.startTimes);
				return {
					ctor: '_Tuple2',
					_0: _elm_lang$core$Native_Utils.update(
						model,
						{startTimes: newStartTimes}),
					_1: _elm_lang$core$Platform_Cmd$none
				};
			case 'DriverMsg':
				var _p28 = _p25._0;
				var _p27 = A2(_elm_lang$core$Dict$get, _p28, model.sessions);
				if (_p27.ctor === 'Just') {
					return A5(_lorenzo$elm_webdriver$Webdriver_Runner$delegateMessage, emit, _p28, _p25._1, _p27._0, model);
				} else {
					return {ctor: '_Tuple2', _0: model, _1: _elm_lang$core$Platform_Cmd$none};
				}
			case 'StopRun':
				var _p31 = _p25._1;
				var _p30 = _p25._2;
				var _p29 = _p25._0;
				var firstTime = function ($default) {
					return A2(_lorenzo$elm_webdriver$Webdriver_Runner$getFirstRunTime, model.startTimes, $default);
				};
				var terminate = _elm_lang$core$Dict$isEmpty(model.sessions) ? A2(
					_elm_lang$core$Task$perform,
					_lorenzo$elm_webdriver$Webdriver_Runner$Done,
					_elm_lang$core$Task$succeed(
						A3(
							_lorenzo$elm_webdriver$Webdriver_Runner$exitOutput,
							model.summary,
							firstTime(_p30),
							_p30))) : _elm_lang$core$Platform_Cmd$none;
				var getTime = function (property) {
					return A2(
						_elm_lang$core$Maybe$withDefault,
						_p30,
						A2(
							_elm_lang$core$Dict$get,
							_p29,
							property(model)));
				};
				var startTime = getTime(
					function (_) {
						return _.startTimes;
					});
				var ellapsed = (_p30 - startTime) / _elm_lang$core$Time$second;
				var took = A2(
					_elm_lang$core$Basics_ops['++'],
					'Took ',
					A2(
						_elm_lang$core$Basics_ops['++'],
						_elm_lang$core$Basics$toString(ellapsed),
						's. '));
				var initTime = getTime(
					function (_) {
						return _.initTimes;
					});
				var waitTime = (startTime - initTime) / _elm_lang$core$Time$second;
				var wait = A2(
					_elm_lang$core$Basics_ops['++'],
					'Waited ',
					A2(
						_elm_lang$core$Basics_ops['++'],
						_elm_lang$core$Basics$toString(waitTime),
						's for dispatch'));
				var outputWithTime = _elm_lang$core$Native_Utils.update(
					_p31,
					{
						output: A2(
							_elm_lang$core$Basics_ops['++'],
							_p31.output,
							A2(_elm_lang$core$Basics_ops['++'], took, wait))
					});
				return {
					ctor: '_Tuple2',
					_0: model,
					_1: _elm_lang$core$Platform_Cmd$batch(
						{
							ctor: '::',
							_0: emit(
								A2(_lorenzo$elm_webdriver$Webdriver_Runner$Log, _p29, outputWithTime)),
							_1: {
								ctor: '::',
								_0: terminate,
								_1: {ctor: '[]'}
							}
						})
				};
			default:
				return A2(
					_elm_lang$core$Platform_Cmd_ops['!'],
					model,
					{
						ctor: '::',
						_0: emit(
							_lorenzo$elm_webdriver$Webdriver_Runner$Exit(_p25._0)),
						_1: {ctor: '[]'}
					});
		}
	});
var _lorenzo$elm_webdriver$Webdriver_Runner$Begin = function (a) {
	return {ctor: 'Begin', _0: a};
};
var _lorenzo$elm_webdriver$Webdriver_Runner$begin = F4(
	function (emit, options, steps, flags) {
		return A3(
			_lorenzo$elm_webdriver$Webdriver_Runner$update,
			emit,
			_lorenzo$elm_webdriver$Webdriver_Runner$Begin(flags),
			A2(_lorenzo$elm_webdriver$Webdriver_Runner$initModel, options, steps));
	});
var _lorenzo$elm_webdriver$Webdriver_Runner$run = F3(
	function (emitter, options, steps) {
		var emit = function (_p32) {
			return emitter(
				_lorenzo$elm_webdriver$Webdriver_Runner$toPort(_p32));
		};
		return _elm_lang$core$Platform$programWithFlags(
			{
				init: A3(_lorenzo$elm_webdriver$Webdriver_Runner$begin, emit, options, steps),
				update: _lorenzo$elm_webdriver$Webdriver_Runner$update(emit),
				subscriptions: _elm_lang$core$Basics$always(_elm_lang$core$Platform_Sub$none)
			});
	});

var _lorenzo$elm_webdriver$Main$firstLink_ = 'div.g:nth-child(1) > div:nth-child(1) > h3:nth-child(1) > a:nth-child(1)';
var _lorenzo$elm_webdriver$Main$searchElm = A2(
	_lorenzo$elm_webdriver$Webdriver_Runner$describe,
	'Finding Elm Lang in Google',
	{
		ctor: '::',
		_0: _lorenzo$elm_webdriver$Webdriver$visit('https://google.com'),
		_1: {
			ctor: '::',
			_0: _lorenzo$elm_webdriver$Webdriver_Assert$title(
				_elm_community$elm_test$Expect$equal('Google')),
			_1: {
				ctor: '::',
				_0: A2(
					_lorenzo$elm_webdriver$Webdriver_Assert$elementCount,
					'input[name=\'q\']',
					_elm_community$elm_test$Expect$atLeast(1)),
				_1: {
					ctor: '::',
					_0: A2(_lorenzo$elm_webdriver$Webdriver$setValue, 'input[name=\'q\']', 'Elm lang'),
					_1: {
						ctor: '::',
						_0: A2(_lorenzo$elm_webdriver$Webdriver$waitForExist, _lorenzo$elm_webdriver$Main$firstLink_, 2000),
						_1: {
							ctor: '::',
							_0: A2(
								_lorenzo$elm_webdriver$Webdriver_Assert$elementText,
								_lorenzo$elm_webdriver$Main$firstLink_,
								_elm_community$elm_test$Expect$equal('Elm')),
							_1: {
								ctor: '::',
								_0: _lorenzo$elm_webdriver$Webdriver$click(_lorenzo$elm_webdriver$Main$firstLink_),
								_1: {
									ctor: '::',
									_0: A2(
										_lorenzo$elm_webdriver$Webdriver$withScreenshot,
										true,
										_lorenzo$elm_webdriver$Webdriver$pause(1000)),
									_1: {
										ctor: '::',
										_0: _lorenzo$elm_webdriver$Webdriver_Assert$title(
											_elm_community$elm_test$Expect$equal('home')),
										_1: {ctor: '[]'}
									}
								}
							}
						}
					}
				}
			}
		}
	});
var _lorenzo$elm_webdriver$Main$emit = _elm_lang$core$Native_Platform.outgoingPort(
	'emit',
	function (v) {
		return {name: v.name, value: v.value};
	});
var _lorenzo$elm_webdriver$Main$main = A3(
	_lorenzo$elm_webdriver$Webdriver_Runner$run,
	_lorenzo$elm_webdriver$Main$emit,
	_lorenzo$elm_webdriver$Webdriver$basicOptions,
	A2(
		_lorenzo$elm_webdriver$Webdriver_Runner$group,
		'Find in Google',
		{
			ctor: '::',
			_0: _lorenzo$elm_webdriver$Main$searchElm,
			_1: {ctor: '[]'}
		}))(
	A2(
		_elm_lang$core$Json_Decode$andThen,
		function (filter) {
			return _elm_lang$core$Json_Decode$succeed(
				{filter: filter});
		},
		A2(
			_elm_lang$core$Json_Decode$field,
			'filter',
			_elm_lang$core$Json_Decode$oneOf(
				{
					ctor: '::',
					_0: _elm_lang$core$Json_Decode$null(_elm_lang$core$Maybe$Nothing),
					_1: {
						ctor: '::',
						_0: A2(_elm_lang$core$Json_Decode$map, _elm_lang$core$Maybe$Just, _elm_lang$core$Json_Decode$string),
						_1: {ctor: '[]'}
					}
				}))));

var Elm = {};
Elm['Main'] = Elm['Main'] || {};
if (typeof _lorenzo$elm_webdriver$Main$main !== 'undefined') {
    _lorenzo$elm_webdriver$Main$main(Elm['Main'], 'Main', undefined);
}

if (typeof define === "function" && define['amd'])
{
  define([], function() { return Elm; });
  return;
}

if (typeof module === "object")
{
  module['exports'] = Elm;
  return;
}

var globalElm = this['Elm'];
if (typeof globalElm === "undefined")
{
  this['Elm'] = Elm;
  return;
}

for (var publicModule in Elm)
{
  if (publicModule in globalElm)
  {
    throw new Error('There are two Elm modules called `' + publicModule + '` on this page! Rename one of them.');
  }
  globalElm[publicModule] = Elm[publicModule];
}

}).call(this);

